/*
 *    Copyright (C) 2002  Andrea Marchesini - Bakunin - bakunin@autistici.org
 *                        http://autistici.org/bakunin/
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

#include <sys/types.h>
#include <_malloc.h>

void *
_memfrob (void *s, size_t n)
{
  _malloc_list *list=NULL;
  char *s1;

  if ((list=_malloc_search ((_malloc_ *) s)))
    {

      if(check_locking(list)) return NULL;

#ifdef DEBUG
      if (_malloc_debug > 1)
	_malloc_log ("_memfrob: Argomento e' _malloc_.\n");
#endif

      s1 = _return((_malloc_ *) s);

      while (n--)
	*s1++ ^= 42;

      _memcpy ((_malloc_ *) s, s1, strlen (s1));

      free (s1);

      return s;
    }

#ifdef DEBUG
  if (_malloc_debug > 1)
    _malloc_log ("_memfrob: Argomento e' in chiaro.\n");
#endif

  s1 = (char *) s;
  while (n--)
    *s1++ ^= 42;

  return (void *) s1;
}
