/*
 *    Copyright (C) 2002  Andrea Marchesini - Bakunin - bakunin@autistici.org
 *                        http://autistici.org/bakunin/
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

#include <sys/types.h>
#include <_malloc.h>

void *
_mempcpy (const void *s1, const void *s2, size_t n)
{

  char *a, *b;

  a = (char *) s1;
  b = (char *) s2;

#ifdef DEBUG
  if (_malloc_debug > 1)
    _malloc_log ("_mempcpy: Mi appoggio alla _memccpy.\n");
#endif

  _memcpy (a, b, n);
  if (_malloc_search ((_malloc_ *) a))
    n *= 2;

  a += ++n;

  return (void *) a;
}
