/*
 *    Copyright (C) 2002  Andrea Marchesini - Bakunin - bakunin@autistici.org
 *                        http://autistici.org/bakunin/
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

#include <sys/types.h>
#include <_malloc.h>

void *
_memset (void *s, int c, size_t n)
{
  _malloc_list *list=NULL;
  int k;
  char *s1;
  _malloc_ *tmp;
  if ((list=_malloc_search ((_malloc_ *) s)))
    {

      if(check_locking(list)) return NULL;

      list->pid_lock=LOCK;

#ifdef DEBUG
      if (_malloc_debug > 1)
	_malloc_log ("_memset: Argomento _malloc_. Setto tutto a %X.\n",
		     (char) c);
#endif

      tmp = (_malloc_ *) s;

      s1 = tmp->p;

      for (k = 0; k < n; k++)
	{

	  s1[k * 2] &= ~tmp->key;
	  s1[(k * 2) + 1] &= tmp->key;

	  s1[k * 2] |= (char) GET (c, tmp->key);
	  s1[(k * 2) + 1] |= (char) GET (c, ~tmp->key);
	}

    }
  else
    {

#ifdef DEBUG
      if (_malloc_debug > 1)
	_malloc_log
	  ("_memset: Argomento in chiaro. Setto tutto a %X.\n", (char) c);
#endif

      s1 = (char *) s;
      while (n--)
	s1[n] = c;

    }

  if(list) list->pid_lock=NOLOCK;

  return (void *) s1;
}
