/*
 *    Copyright (C) 2002  Andrea Marchesini - Bakunin - bakunin@autistici.org
 *                        http://autistici.org/bakunin/
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

#include <_malloc.h>

#ifdef DEBUG

void
_malloc_set_fd (int fd)
{
  if (fd && fd > 0)
    _malloc_debug_fd = fd;
}

void
_malloc_set_debug (unsigned int debug)
{

  if (_malloc_debug)
    _malloc_log ("_malloc_set_debug: Cambio il livello di debug a: %d",
		 debug);

  if (!debug)
    _malloc_debug = 0;
  else
    _malloc_debug = debug;

}

void
_malloc_log (const char *format, ...)
{

  char **arg = (char **) &format;
  char c;
  char buf[20];

  while ((c = *format++) != 0)
    {

      if (c != '%')
	write (_malloc_debug_fd, &c, 1);
      else
	{

	  char *p;
	  c = *format++;
	  switch (c)
	    {

	    case '_':
	      {

		p = (char *) _return((_malloc_ *) * (++arg));

		write (_malloc_debug_fd, p, strlen (p));
		free (p);

		break;
	      }

	    case 'p':
	      {
		int len;
		len = sprintf (buf, "%p", *(++arg));
		write (_malloc_debug_fd, buf, len);
	      }
	      break;


	    case 'c':
	      write (_malloc_debug_fd, ++arg, 1);
	      break;

	    case 'd':
	    case 'u':
	    case 'x':
	    case 'X':
	      _convert (buf, c, *((int *) ++arg));

	      if (c == 'x' || c == 'X')
		write (_malloc_debug_fd, "0x", 2);

	      write (_malloc_debug_fd, buf, strlen (buf));
	      break;

	    case 's':
	      p = *(++arg);
	      if (!p)
		p = "(null)";

	      write (_malloc_debug_fd, p, strlen (p));
	      break;

	    default:
	      write (_malloc_debug_fd, &c, 1);
	      break;
	    }
	}
    }
}
#endif
