/*
 *    Copyright (C) 2002  Andrea Marchesini - Bakunin - bakunin@autistici.org
 *                        http://autistici.org/bakunin/
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

#include <_malloc.h>

int
_malloc_get_state (_malloc_state * state)
{

  unsigned int size, zones, fulls, fragments, unuseds;
  _malloc_list *tmp;

#ifdef DEBUG
  if (_malloc_debug)
    _malloc_log ("_malloc_get_state: Carico _malloc_state: %p.\n", state);
#endif

  if (!_malloc_list_start)
    return 1;

#ifdef DEBUG
  if (!state && !_malloc_debug)
#else
  if (!state)
#endif
    return 1;

  size = zones = fulls = fragments = unuseds = 0;

  tmp = _malloc_list_start;
  while (tmp)
    {

      size += tmp->size;

      if (!tmp->struct1 || !tmp->struct2)
	{

	  zones++;
	  fragments++;
	}
      else
	{

	  zones += 2;
	  fulls++;
	}

      if (tmp->struct1)
	unuseds += tmp->size - tmp->struct1->size;
      else
	unuseds += tmp->size;

      if (tmp->struct2)
	unuseds += tmp->size - tmp->struct2->size;
      else
	unuseds += tmp->size;

      tmp = tmp->next;
    }

  if (state)
    {
      state->size = size;
      state->zones = zones;
      state->fulls = fulls;
      state->fragments = fragments;
      state->unuseds = unuseds;
    }

#ifdef DEBUG
  if (_malloc_debug)
    _malloc_log
      ("_malloc_get_state:  Dimensione allocata: %d, N. Zone: %d, Piene: %d, Frammentate: %d, Inutilizzato %d.\n",
       size, zones, fulls, fragments, unuseds);
#endif

  return 0;
}
