/*
 * Copyright (C) 2003  
 * paranoy project - paranox.sf.net - paranoy@autistici.org
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

#include "include.h"

#ifdef USE_CURSES
void
add_attach(struct email *mail)
{
  short i, c, n;

  // unsigned long filesize = 0;
  byte pos, oldpos;
  ushort real = 0;
  char *p;
  char buff[BUFFER_REAL];
  struct dirent **dir;
  struct stat f;

  p = get_current_dir_name();

  title("Add Attach (%s)", p);

  wclear(wmain);
  i = oldpos = pos = 0;

  // qui nn fa' alcun controllo sul valore di ritorno di scandir TOFIX
  i = scandir(p, &dir, 0, alphasort);

  // printa la lista iniziale
  print_attach_list(dir, 0, i);
  pos = oldpos = 0;
  // ciclo principale
  while (1)
  {
    if (!net_optimize)
    {
      stat(dir[real + oldpos]->d_name, &f);
      if (S_IFDIR & f.st_mode)
        wattrset(wmain, COLOR_PAIR(NEW));
      else
        wattrset(wmain, A_NORMAL);

      // deseleziono la roba vekkia
      wattroff(wmain, A_REVERSE);
      mvwprintw(wmain, oldpos + 2, 2, "%20s", dir[real + oldpos]->d_name);

      stat(dir[real + pos]->d_name, &f);
      if (S_IFDIR & f.st_mode)
        wattrset(wmain, COLOR_PAIR(NEW));
      else
        wattrset(wmain, A_NORMAL);

      // nuova selezione
      wattron(wmain, A_REVERSE);
      mvwprintw(wmain, pos + 2, 2, "%20s", dir[real + pos]->d_name);
    } else
    {
      // deselezione
      mvwprintw(wmain, oldpos + 2, 1, " ");
      // selezione
      mvwprintw(wmain, pos + 2, 1, ">");
    }
    wrefresh(wmain);
    // dentro i sta il numero di entry
    switch (c = getch())
    {
      case KEY_DOWN:
        oldpos = pos;
        // nel caso le entries siano + delle righe disponibili
        if (i > LINES - 4)
        {
          logg("qui dentro\n");
          // se siamo alla fine dello skermo
          if (pos == LINES - 6)
          {
            if (i < real + pos + 2)
              break;
            real++;
            print_attach_list(dir, real, i);
          } else
            pos++;
        }
        // le entries sono meno delle righe disponibili sullo skermo
        else if (pos < i - 1)
          pos++;
        break;
      case KEY_UP:
        oldpos = pos;
        // se il primo file printato nn e' effettivamente il primo della
        // lista
        if (real > 0)
        {
          if (pos == 0)
          {
            real--;
            print_attach_list(dir, real, i);
          } else
            pos--;
        } else if (pos != 0)
          pos--;
        break;
      case 10:
      case KEY_RIGHT:
      case 32:
        // mette dentro buff la roba premuta
        strncpy(buff, dir[pos + real]->d_name, BUFFER_LEN);
        for (n = 0; n < i; n++)
          free(dir[n]);
        if (dir != NULL)
          free(dir);
        i = scandir(buff, &dir, 0, NULL);
        // se e' un file
        if (i == -1)
        {
          logg("%s e' un file\n", buff);
          // make boundary if it didn't it yet
          if (!mail->boundary)
            make_boundary(mail);

          // add attachment to mail struct
          if (mail->nattach == 0)
            mail->attach =
              (struct attachments **) malloc(sizeof(struct attachments *));
          else
            mail->attach =
              (struct attachments **) realloc(mail->attach,
                                              sizeof(struct attachments *) *
                                              mail->nattach + 2);

          mail->attach[mail->nattach] =
            (struct attachments *) malloc(sizeof(struct attachments));

          // scrive nome file nella struttura
          logg("scrive nome %d\n", mail->nattach);
          mail->attach[mail->nattach]->name = strdup(buff);

          mail->attach[mail->nattach]->path = strdup(p);

          mail->nattach++;
          chdir(MAILDIR);
          return;
        }
        free(p);
        chdir(buff);
        p = get_current_dir_name();
        // riprinta la lista dei file
        real = pos = oldpos = 0;
        print_attach_list(dir, 0, i);
        title("Add Attach (%s)\n", p);
        break;
      case KEY_NPAGE:
        break;
      case KEY_PPAGE:
        break;
      case 'q':
      case 27:
      case KEY_LEFT:
        chdir(MAILDIR);
        wclear(wmain);
        return;
        break;
    }
  }
}


void
print_attach_list(struct dirent **dir, ushort start, ushort max)
{
  byte pos;
  struct stat f;

  // wclear(wmain);
  // printa la lista iniziale
  wattroff(wmain, A_REVERSE);
  for (pos = 0; pos < max && pos < LINES - 4; pos++)
  {
    stat(dir[pos + start]->d_name, &f);
    if (S_IFDIR & f.st_mode)
      wattrset(wmain, COLOR_PAIR(NEW));
    else
      wattrset(wmain, A_NORMAL);
    mvwprintw(wmain, pos + 2, 2, "%20s\t%ld\n", dir[pos + start]->d_name,
              f.st_size);
  }
  wattrset(wmain, A_NORMAL);
}
#endif // USE_CURSES

#define PAD	"="
// tabella Base64
char base64[64] = {
  'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M',
  'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z',
  'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm',
  'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z',
  '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '+', '/'
};

// encode from (ASCII) to a base64 format (for MIME encoding...rfc 1521);
char *
base64_encode(char *to, char *from)
{
  char t[4];
  unsigned int count = 0;


  /*
   * ASCII -> 8bits 11111111 11111111 00000000 
   * Base64 -> 6bits 111111   000011   110000   111111 
   */

  t[0] = (from[0] & 0xFC) >> 2;
  t[1] = ((from[0] & 0x03) << 4) | ((from[1] & 0xF0) >> 4);
  t[2] = ((from[1] & 0x0F) << 2) | ((from[2] & 0xC0) >> 6);
  t[3] = from[2] & 0x3F;

  to[0] = base64[(int) t[0]];
  to[1] = base64[(int) t[1]];
  to[2] = base64[(int) t[2]];
  to[3] = base64[(int) t[3]];
  to[4] = 0;
  count = strlen(from) % 3;
  if (count > 0)
    to[3] = '=';
  if (count == 1)
    to[2] = '=';

  return to;
}

// decode from (base64) to an ASCII format (for MIME encoding...rfc 1521);
char *
base64_decode(char *to, char *from)
{
  char f[4];
  unsigned int i = 0, count = 0;

  count = strlen(from) / 4;

  /*
   * Base64 -> 6bits 111111 111111 000000 000000 ASCII -> 8bits 11111100
   * 11000000 00001111 
   */

  for (i = 0; i < count; i++)
  {
    strncpy(f, from + i * 4, 4);

    f[0] = found64(f[0]);
    f[1] = found64(f[1]);
    f[2] = found64(f[2]);
    f[3] = found64(f[3]);

    to[i * 3] = (f[0] << 2) | ((f[1] & 0x30) >> 4);
    to[i * 3 + 1] = ((f[1] & 0x0F) << 4) | ((f[2] & 0x3C) >> 2);
    to[i * 3 + 2] = ((f[2] & 0x03) << 6) | (f[3] & 0x3F);
  }
  return to;
}

// return the char to its Base64 decimal value
int
found64(char c)
{
  int i;

  for (i = 0; i <= 64; i++)
    if (base64[i] == c)
      return i;
  return 0;
}



char *
tolow(char *s, int lenght)
{
  unsigned short int i, l;

  l = strlen(s) > lenght ? lenght : strlen(s);
  for (i = 0; i < l; i++)
  {
    if (s[i] >= 65 && s[i] <= 90)
      s[i] += 32;
  }
  return s;
}



// fill mail->attach array
void
parse_attach(struct email *mail, ushort boundlen)
{
  char *attach;
  char *end_attach;
  unsigned long int l = 0;

  attach = (char *) malloc(sizeof(char) * (boundlen + 3));
  end_attach = (char *) malloc(sizeof(char *) * (boundlen + 5));

  mail->nattach = 0;
  mail->txt_attach = 0;

  sprintf(attach, "--%s", mail->boundary);
  sprintf(end_attach, "%s--", attach);

  mail->attach = (struct attachments **) malloc(sizeof(struct attachments *));
  mail->attach[mail->nattach] =
    (struct attachments *) malloc(sizeof(struct attachments));
  mail->attach[mail->nattach]->length = 0;
  mail->attach[mail->nattach]->name = NULL;

  if (!mail->body)
    return;

  while (strncmp(mail->body[l], end_attach, boundlen + 4))
  {
    if (!strncmp(mail->body[l], attach, boundlen + 2))
    {
      /*
       * -> --BOUNDARY Content-Type: text/plain; charset="iso-8859-1"
       * Content-Transfer-Encoding: quoted-printable
       * 
       * body mail --BOUNDARY Content-Type: text/html; charset="iso-8859-1"
       * Content-Transfer-Encoding: quoted-printable
       * 
       * <html><body>body mail</body></html>
       * 
       * --BOUNDARY-- 
       */

      mail->attach[mail->nattach]->offset = l;



      mail->attach =
        realloc((struct attachments **) mail->attach,
                sizeof(struct attachments *) * (mail->nattach + 2));
      mail->attach[mail->nattach + 1] =
        (struct attachments *) malloc(sizeof(struct attachments));
      mail->attach[mail->nattach + 1]->length = 0;
      mail->attach[mail->nattach + 1]->name = 0;


      while (mail->body[++l])
      {
        logg
          ("PARSE_ATTACH - dentro il while del controllo dell'header dell'allegato\n");
        char *p;

        // respect
        if (mail->body[l][0] == '-')
          if (!strncmp(mail->body[l], attach, boundlen + 2) ||!strncmp(mail->body[l], end_attach, boundlen + 4))
					{
						l--;
            break;
					}
        p = strcasestr(mail->body[l], "content-type:");
        if (p)
        {
          if (strcasestr(p + 14, "text/plain"))
            mail->txt_attach = mail->nattach;
        }
      }
			mail->attach[mail->nattach]->length = l-mail->attach[mail->nattach]->offset;
			mail->nattach++;
    }
    l++;
    if (!mail->body[l])
      break;
  }

  logg("prima dei free\n");
  if (!mail->nattach)
    free(mail->attach);
  free(attach);
  free(end_attach);
}


void
save_attach(struct email *mail, ushort n)
{
  FILE *file;

  chdir("~");
  file = fopen(mail->attach[n]->name, "w");
  // deve andare da mail->body[mail->attach[n]->offset] a
  // mail->body[mail->attach[n]->length + mail->attach[n]->offset]
  // e passarli a base64_decode
  fclose(file);
  chdir(MAILDIR);
}


void
make_boundary(struct email *mail)
{
  if (!mail->messageid)
    mail->messageid = message_id(mail);
  mail->boundary = mail->messageid;

}
