/*
 * Copyright (C) 2003  
 * paranoy project - paranox.sf.net - paranoy@autistici.org
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

#include "include.h"

void
first_time()
{
  char buff[BUFFER_REAL];
  char buff2[BUFFER_REAL];
  char *p;

  // initialize default value
  contact = NULL;
  filt = NULL;
  mail_check_time = 0;
  latent_time = NULL;
  smtpport = SMTP_PORT;
  ssmtp = CLEAR_CONNECTION;
  smtpserver = NULL;
  MAILDIR = NULL;
  groups = NULL;

#ifdef USE_CURSES
  // sets default colors..
  cnew_back = 0;
  cnew_fore = 3;
  cold_back = 0;
  cold_fore = 7;
  cquote1_back = 0;
  cquote1_fore = 2;
  cquote2_back = 0;
  cquote2_fore = 3;
  cquote3_back = 0;
  cquote3_fore = 4;
  ctitle_fore = 4;
  ctitle_back = 2;
  chavekey_fore = 2;
  chavekey_back = 4;
  ctoyou_fore = 5;
  ctoyou_back = 0;
  cdelete_fore = 6;
  cdelete_back = 1;
  cinfo_fore = 1;
  cinfo_back = 0;
#endif



  printf("This is the first time you run paranoy.\n");
  logg("-=== First run ===-\n");

  // choosing a directory to store emails
  printf
    ("You have to choose a directory where paranoy store emails [%s/.paranoy]: ",
     getenv("HOME") ? getenv("HOME") : ".");

  fgets(buff, BUFFER_LEN, stdin);


  if (buff[0] == '\n')
    snprintf(buff, BUFFER_LEN, "%s/.paranoy",
             getenv("HOME") ? getenv("HOME") : ".");
  else
    strip(buff, '\n');


  if ((MAILDIR = strdup(buff)) == NULL)
    end("No enought memory");

  logg("config - MAILDIR is '%s'\n", MAILDIR);
  if (chdir(MAILDIR) < 0)
  {
    printf("Making %s directory..\n", MAILDIR);
    if (mkdir(MAILDIR, 0700) < 0)
      end("Error while enter/create ~/.paranoy\n");
    else
    {
      chdir(MAILDIR);
      mkdir("Themes", 0700);
      mkdir("plugins", 0700);
    }
  }

  printf("Now you have to choose a password!\n");
  printf
    ("If you don't know what you are doing, read first the HOWTO file!\n");

  // ask the password
  while (1)
  {
    strncpy(buff, getpass("Insert password: "), BUFFER_LEN);
    strncpy(buff2, getpass("Reinsert password: "), BUFFER_LEN);
    if (strcmp(buff, buff2))
      printf("The password isn't equals!\n");
    else
      break;
  }

  // generate a random sequence
  printf("Generating a random numer\n");
  logg("config - before generating a random number\n");
  p = gen_random(KEY_LEN);
  p[KEY_LEN] = 0;

  logg("config - generating a random number --> '%s'\n", p);
  logg("config - the password               --> '%s'\n", buff);

  // use _malloc functions to store reserved data
  _pass = (_malloc_ *) _malloc(strlen(buff));
  _memcpy(_pass, buff, strlen(buff));

  _random = (_malloc_ *) _malloc(KEY_LEN);
  _memcpy(_random, p, KEY_LEN);
  free(p);

  logg("config - write_configuration\n");
  printf("Writing configuration..\n");
  if (write_configuration(1))
    end("Error while create configuration file\n");

  logg("config - before create new folders\n");

  // create new folders

  new_folder("Trash");
  // new_folder("Draft");
  new_folder("Sent");
  new_folder("Inbox");

  write_index();


  // end of first run :)
  logg("config - end of first run\n");
}

void
read_configuration(FILE * conf)
{
  char buff[BUFFER_REAL];
  char buff2[BUFFER_REAL];
  char buff3[BUFFER_REAL];
  struct rules *rul;
  EVP_CIPHER_CTX ctx;
  ushort l;


  // initialize default value
  contact = NULL;
  filt = NULL;
  mail_check_time = 0;
  latent_time = NULL;
  smtpport = SMTP_PORT;
  ssmtp = CLEAR_CONNECTION;
  smtpserver = NULL;
  MAILDIR = NULL;
  groups = NULL;

#ifdef USE_CURSES
  cnew_back = 0;
  cnew_fore = 3;
  cold_back = 0;
  cold_fore = 7;
  cquote1_back = 0;
  cquote1_fore = 2;
  cquote2_back = 0;
  cquote2_fore = 3;
  cquote3_back = 0;
  cquote3_fore = 4;
  ctitle_fore = 4;
  ctitle_back = 2;
  chavekey_fore = 2;
  chavekey_back = 4;
  ctoyou_fore = 5;
  ctoyou_back = 0;
  cdelete_fore = 6;
  cdelete_back = 1;
  cinfo_fore = 1;
  cinfo_back = 0;
#endif


  logg("Dentro read_configuration\n");

  // read release that writed this configuration file
  fgets(buff, BUFFER_LEN, conf);
  strip(buff, '\n');
  if (strcmp(buff, VERSION))
    end
      ("The configuration file is not compatible with this release of paranoy\n");

  // ask for a password
  logg("ask for password\n");
  strncpy(buff, getpass("Insert password: "), BUFFER_LEN);
  logg("password is '%s'\n", buff);

  // use _malloc functions to store reserved data
  _pass = (_malloc_ *) _malloc(strlen(buff));
  _memcpy(_pass, buff, strlen(buff));


  // read the lenght of encrypted key
  fread(buff2, 2, 1, conf);
  buff2[2] = 0;
  l = atoi(buff2);
  logg("the encrypted key is %d bytes\n", l);

  // read encrypted key
  fread(buff2, l, 1, conf);
  buff2[l] = 0;

  logg("the encrypted key is '%s'\n", buff2);

  logg("call cryptz(NULL,'%s',%d,buff3,'%s','%s',%d);\n", buff2, l, buff,
       DECRYPT);
  l = cryptz(NULL, buff2, l, buff3, buff, DECRYPT);
  logg("dopo il cryptz l=%d\n", l);
  buff3[l] = 0;
  logg("decrypted random key is %d bytes '%s'\n", l, buff3);
  if (!l)
    end("\n\e[0;31mThe password isn't correct!!\e[0m\n\n");
  fread(buff2, 32, 1, conf);
  buff2[32] = 0;
  logg("md5conf = '%s'\n", buff2);
  memcpy(buff, buff3, l);
  buff[l] = 0;
  MD5String(buff);
  logg("md5 = '%s'\n\n", buff);
  if (memcmp(buff, buff2, 32))

    end("\n\e[0;31mThe password isn't correct!!\e[0m\n\n");
  logg("OK! password corretta\n");

  _random = (_malloc_ *) _malloc(KEY_LEN);
  _memcpy(_random, buff3, KEY_LEN);


  crypto_init(&ctx, DECRYPT);

  // read the configuration
  while (readcline(&ctx, conf, buff, BUFFER_LEN, &l))
  {
    logg("sono al while iniziale e leggo %s\n", buff);
    if (!strncmp(buff, "[options]", 9))
    {
      while (1)
      {
        readcline(&ctx, conf, buff, BUFFER_LEN, &l);
        logg("il buffer letto e' : %s\n", buff);
        if (!strncmp(buff, "[end-options]", 13))
        {
          logg("found [end-options]\n");
          break;
        }
#ifdef USE_CURSES
        else if (!strncmp(buff, "cnew_back:", 10))
        {
          cnew_back = atoi(strdup(buff + 10));
          logg("ho letto cnew_back %d\n", cnew_back);
        } else if (!strncmp(buff, "cnew_fore:", 10))
        {
          cnew_fore = atoi(strdup(buff + 10));
          logg("ho letto cnew_fore %d\n", cnew_fore);
        } else if (!strncmp(buff, "cold_back:", 10))
          cold_back = atoi(strdup(buff + 10));
        else if (!strncmp(buff, "cold_fore:", 10))
          cold_fore = atoi(strdup(buff + 10));
        else if (!strncmp(buff, "ctitle_back:", 12))
          ctitle_back = atoi(strdup(buff + 12));
        else if (!strncmp(buff, "ctitle_fore:", 12))
          ctitle_fore = atoi(strdup(buff + 12));
        else if (!strncmp(buff, "cinfo_back:", 11))
          cinfo_back = atoi(strdup(buff + 11));
        else if (!strncmp(buff, "cinfo_fore:", 11))
          cinfo_fore = atoi(strdup(buff + 11));
        else if (!strncmp(buff, "cquote1_back:", 13))
          cquote1_back = atoi(strdup(buff + 13));
        else if (!strncmp(buff, "cquote1_fore:", 13))
          cquote1_fore = atoi(strdup(buff + 13));
        else if (!strncmp(buff, "cquote2_back:", 13))
          cquote2_back = atoi(strdup(buff + 13));
        else if (!strncmp(buff, "cquote2_fore:", 13))
          cquote2_fore = atoi(strdup(buff + 13));
        else if (!strncmp(buff, "cquote3_back:", 13))
          cquote3_back = atoi(strdup(buff + 13));
        else if (!strncmp(buff, "cquote3_fore:", 13))
          cquote3_fore = atoi(strdup(buff + 13));
        else if (!strncmp(buff, "chavekey_fore:", 14))
          chavekey_fore = atoi(strdup(buff + 14));
        else if (!strncmp(buff, "chavekey_back:", 14))
          chavekey_back = atoi(strdup(buff + 14));
        else if (!strncmp(buff, "ctoyou_back:", 12))
          ctoyou_back = atoi(strdup(buff + 12));
        else if (!strncmp(buff, "ctoyou_fore:", 12))
          ctoyou_fore = atoi(strdup(buff + 12));
        else if (!strncmp(buff, "cdelete_back:", 13))
          cdelete_back = atoi(strdup(buff + 13));
        else if (!strncmp(buff, "cdelete_fore:", 13))
          cdelete_fore = atoi(strdup(buff + 13));

#endif



        else if (!strncmp(buff, "maildir:", 8))
        {
          logg("MAILDIR is '%s'\n", buff + 8);
          MAILDIR = strdup(buff + 9);
          if (chdir(MAILDIR) < 0)
          {
            printf("Making %s directory\n", MAILDIR);
            if (mkdir(MAILDIR, 0700) < 0)
              end("Error while enter/create ~/.paranoy\n");
            else
              chdir(MAILDIR);
          }
        } else if (!strncmp(buff, "smtpserver:", 11))
        {
          if (l - 11 > 2)
          {
            smtpserver = (char *) malloc(l - 11);
            memcpy(smtpserver, buff + 12, l - 12);
            *(smtpserver + (l - 12)) = 0;
          }
        } else if (!strncmp(buff, "smtps:", 6))
        {
          ssmtp = atoi(buff + 7);
          logg("config - ssmtp = %d\n", ssmtp);
        }

        else if (!strncmp(buff, "smtpauth:", 9))
        {
          smtpauth = atoi(buff + 10);
          logg("config - smtpauth = %d\n", smtpauth);
        } else if (!strncmp(buff, "smtpuser:", 9))
        {
          smtpuser = (char *) malloc(l - 9);
          memcpy(smtpuser, buff + 10, l - 10);
          *(smtpuser + (l - 10)) = 0;
        } else if (!strncmp(buff, "smtppass:", 9))
        {
          smtppass = (char *) malloc(l - 9);
          memcpy(smtppass, buff + 10, l - 10);
          *(smtppass + (l - 10)) = 0;
        } else if (!strncmp(buff, "smtpport:", 9))
        {
          smtpport = atoi(buff + 10);
          logg("the smtp port is %d\n", smtpport);
        } else if (!strncmp(buff, "mail_check_time:", 16))
        {
          mail_check_time = atoi(buff + 16);
          logg("mail_check_time is %d\n", mail_check_time);
        }
#ifdef USE_GTK
        else if (!strncmp(buff, "theme:", 6))
        {
          THEME = (char *) malloc(l - 6);
          memcpy(THEME, buff + 7, l - 7);
          *(THEME + (l - 7)) = 0;
          printf("il tema e' \"%s\"\n", THEME);
          fflush(stdout);
        }
#endif

      }
    } else if (!strncmp(buff, "[accounts]", 10))
    {
      naccount = 0;
      logg("in [account]\n");
      while (1)
      {
        readcline(&ctx, conf, buff, BUFFER_LEN, &l);
        if (!strncmp(buff, "[end-accounts]", 14))
          break;
        if (naccount == 0)
        {
          account =
            (struct accountlist **) malloc(sizeof(struct accountlist *));
          account[0] =
            (struct accountlist *) malloc(sizeof(struct accountlist));
        } else
        {
          account =
            (struct accountlist **) realloc(account,
                                            sizeof(struct accountlist *) *
                                            naccount + 1);
          account[naccount] =
            (struct accountlist *) malloc(sizeof(struct accountlist));
        }
        naccount++;


        // host
        account[naccount - 1]->host = (char *) malloc(l - 5);
        memcpy(account[naccount - 1]->host, buff + 6, l - 6);
        *(account[naccount - 1]->host + (l - 6)) = 0;
        logg("host: '%s'\n", account[naccount - 1]->host);

        // port
        readcline(&ctx, conf, buff, BUFFER_LEN, NULL);
        account[naccount - 1]->port = atoi(buff + 6);
        logg("port: '%d'\n", account[naccount - 1]->port);

        // proto
        readcline(&ctx, conf, buff, BUFFER_LEN, NULL);
        account[naccount - 1]->proto = atoi(buff + 7);
        logg("proto: '%d'\n", account[naccount - 1]->proto);

        // user
        readcline(&ctx, conf, buff, BUFFER_LEN, &l);
        account[naccount - 1]->user = (char *) malloc(l - 5);
        memcpy(account[naccount - 1]->user, buff + 6, l - 6);
        *(account[naccount - 1]->user + (l - 6)) = 0;
        logg("user: '%s'\n", account[naccount - 1]->user);

        // email
        readcline(&ctx, conf, buff, BUFFER_LEN, &l);
        account[naccount - 1]->email = (char *) malloc(l - 6);
        memcpy(account[naccount - 1]->email, buff + 7, l - 7);
        *(account[naccount - 1]->email + (l - 7)) = 0;
        logg("email: '%s'\n", account[naccount - 1]->email);

        // pass
        readcline(&ctx, conf, buff, BUFFER_LEN, &l);
        account[naccount - 1]->pass = (_malloc_ *) _malloc(l - 5);
        logg("l = %d -- pass: %s\n", l, buff + 6);
        if (buff[0] == '0' && l - 6 == 1)
        {
          account[naccount - 1]->nopass = 1;
          account[naccount - 1]->pass = NULL;
        } else
        {
          account[naccount - 1]->nopass = 0;
          _memcpy(account[naccount - 1]->pass, buff + 6, l - 6);
        }

      }
    }
    /*
     * here reads groups and contacts 
     */
    else if (!strncmp(buff, "[contacts]", 10))
    {
      struct contacts_group *g;

      logg("dentro contatti\n");
      while (1)
      {
        g = (struct contacts_group *) malloc(sizeof(struct contacts_group));

        readcline(&ctx, conf, buff, BUFFER_LEN, NULL);
        if (!strncmp(buff, "[end-contacts]", 14))
        {
          logg("esco dai contatti\n");
          free(g);
          break;
        }

        g->head = NULL;
        g->tail = NULL;
        g->next = groups;
        groups = g;

        g->name = strdup(buff);
        logg("ho trovato il gruppo %s\n", g->name);

        while (1)
        {
          struct contacts *temp =
            (struct contacts *) malloc(sizeof(struct contacts));
          readcline(&ctx, conf, buff, BUFFER_LEN, NULL);

          if (!strncmp(buff, "end group", 9))
          {
            free(temp);
            logg("fine del gruppo\n");
            break;
          }

          logg("ho trovato un contatto\n");

          // name
          temp->name = strdup(buff + 6);
          logg("il nome e' %s\n", temp->name);

          // email
          readcline(&ctx, conf, buff, BUFFER_LEN, &l);
          temp->email = strdup(buff + 7);
          logg("la mail e' %s\n", temp->email);

          // have_key
          readcline(&ctx, conf, buff, BUFFER_LEN, NULL);
          temp->have_key = atoi(buff + 8);
          logg("Leggendo i contatti all'inizio : %s %d\n", temp->name,
               temp->have_key);

          // add contact in the list
          if (!g->head)
            g->tail = temp;
          temp->next = g->head;
          g->head = temp;
        }

      }
    }
    /*
     * now read filters 
     */
    else if (!strncmp(buff, "[filters]", 10))
    {
      logg("dentro i filtri\n");
      while (1)
      {
        struct filters *temp =
          (struct filters *) malloc(sizeof(struct filters));
        readcline(&ctx, conf, buff, BUFFER_LEN, NULL);
        logg("son qui all'inizio dei filtri\n");
        if (!strncmp(buff, "[end-filters]", 13))
        {
          logg("esco dai filters\n");
          free(temp);
          break;
        }
        // fill filter

        temp->name = strdup(buff);
        rul = temp->head = (struct rules *) smalloc(sizeof(struct rules));

        logg("vai di rules\n");

        // fill rules
        while (1)
        {
          // what
          readcline(&ctx, conf, buff, BUFFER_LEN, NULL);
          rul->what = strdup(buff);


          // value
          readcline(&ctx, conf, buff, BUFFER_LEN, NULL);
          rul->value = strdup(buff);

          // parse
          readcline(&ctx, conf, buff, BUFFER_LEN, NULL);
          rul->parse = atoi(buff);

          // after
          readcline(&ctx, conf, buff, BUFFER_LEN, NULL);
          rul->after = atoi(buff);

          if (rul->after == NONE)
            break;

          rul->next = (struct rules *) smalloc(sizeof(struct rules));
          rul = rul->next;
        }

        logg("dopo le rules\n");

        // read the action
        readcline(&ctx, conf, buff, BUFFER_LEN, NULL);
        temp->action = atoi(buff);

        if (temp->action != DELETE)
        {
          readcline(&ctx, conf, buff, BUFFER_LEN, NULL);
          temp->where = strdup(buff);
        }
        logg("add the filter to list\n");

        // add the filter to list
        if (!filt)
        {
          logg("primo filtro\n");
          filt = temp;
          filt->next = NULL;
        } else
        {
          temp->next = filt;
          filt = temp;
        }
      }
    }
  }

  EVP_CIPHER_CTX_cleanup(&ctx);

  return;
}


int
write_configuration(int first)
{
  char buff[BUFFER_REAL];
  FILE *conf;
  struct contacts *pcon;
  struct contacts_group *pgr;
  EVP_CIPHER_CTX ctx;
  int i, l;
  struct rules *rul;
  struct filters *fil;
  char *random, *pass;

  logg("config - in write_configuration\n");

  random = _return(_random);
  pass = _return(_pass);

  // open configuration file
  snprintf(buff, BUFFER_LEN, "%s/.paranoyrc",
           getenv("HOME") ? getenv("HOME") : ".");

  logg("config - open configuration file -> %s\n", buff);
  if ((conf = fopen(buff, "w")) == NULL)
  {
    logg("config - Error while open configuration file\n");
    return -1;
  }
  // write paranoy's release
  fprintf(conf, "%s\n", VERSION);

  logg("config - writing random = %s\n");

  // encode random key with user password
  logg("call cryptz(NULL,'%s',%d,buff,'%s',%d);\n", random, KEY_LEN, pass,
       ENCRYPT);
  i = cryptz(NULL, random, KEY_LEN, buff, pass, ENCRYPT);
  buff[i] = 0;

  free(pass);

  // write the length of encrypted key and encrypted key
  fprintf(conf, "%2d", i);
  fwrite(buff, 1, i, conf);



  // write the hash of key
  memcpy(buff, random, KEY_LEN);
  buff[KEY_LEN] = 0;
  free(random);
  MD5String(buff);
  fwrite(buff, 32, 1, conf);

  // prepare use of openssl crypto function to write in file
  crypto_init(&ctx, ENCRYPT);

  logg("config - writing options\n");
  l = sprintf(buff, "[options]\n");
  cfwrite(&ctx, buff, l, 0, conf);

  // writes configuration
  l = snprintf(buff, BUFFER_LEN, "maildir: %s\n", MAILDIR);
  cfwrite(&ctx, buff, l, 0, conf);

  if (smtpserver)
  {
    l = snprintf(buff, BUFFER_LEN, "smtpserver: %s\n",
                 smtpserver ? smtpserver : "");
    cfwrite(&ctx, buff, l, 0, conf);
  }

  l = snprintf(buff, BUFFER_LEN, "smtpauth: %d\n", smtpauth);
  cfwrite(&ctx, buff, l, 0, conf);

  l = snprintf(buff, BUFFER_LEN, "smtpport: %d\n", smtpport);
  cfwrite(&ctx, buff, l, 0, conf);

  l = snprintf(buff, BUFFER_LEN, "ssmtp: %d\n", ssmtp);
  cfwrite(&ctx, buff, l, 0, conf);

  l = snprintf(buff, BUFFER_LEN, "smtpuser: %s\n", smtpuser);
  cfwrite(&ctx, buff, l, 0, conf);

  l = snprintf(buff, BUFFER_LEN, "smtppass: %s\n", smtppass);
  cfwrite(&ctx, buff, l, 0, conf);

#ifdef USE_GTK
  l = snprintf(buff, BUFFER_LEN, "theme: %s\n", THEME);
  cfwrite(&ctx, buff, l, 0, conf);
#endif

  l = snprintf(buff, BUFFER_LEN, "mail_check_time: %d\n", downloadtime);
  cfwrite(&ctx, buff, l, 0, conf);



#ifdef USE_CURSES
  // writes colors
  l = snprintf(buff, BUFFER_LEN, "cnew_back:%d\n", cnew_back);
  cfwrite(&ctx, buff, l, 0, conf);
  l = snprintf(buff, BUFFER_LEN, "cnew_fore:%d\n", cnew_fore);
  cfwrite(&ctx, buff, l, 0, conf);
  l = snprintf(buff, BUFFER_LEN, "cold_back:%d\n", cold_back);
  cfwrite(&ctx, buff, l, 0, conf);
  l = snprintf(buff, BUFFER_LEN, "cold_fore:%d\n", cold_fore);
  cfwrite(&ctx, buff, l, 0, conf);
  l = snprintf(buff, BUFFER_LEN, "ctitle_back:%d\n", ctitle_back);
  cfwrite(&ctx, buff, l, 0, conf);
  l = snprintf(buff, BUFFER_LEN, "ctitle_fore:%d\n", ctitle_fore);
  cfwrite(&ctx, buff, l, 0, conf);
  l = snprintf(buff, BUFFER_LEN, "cinfo_back:%d\n", cinfo_back);
  cfwrite(&ctx, buff, l, 0, conf);
  l = snprintf(buff, BUFFER_LEN, "cinfo_fore:%d\n", cinfo_fore);
  cfwrite(&ctx, buff, l, 0, conf);
  l = snprintf(buff, BUFFER_LEN, "cquote1_back:%d\n", cquote1_back);
  cfwrite(&ctx, buff, l, 0, conf);
  l = snprintf(buff, BUFFER_LEN, "cquote1_fore:%d\n", cquote1_fore);
  cfwrite(&ctx, buff, l, 0, conf);
  l = snprintf(buff, BUFFER_LEN, "cquote2_back:%d\n", cquote2_back);
  cfwrite(&ctx, buff, l, 0, conf);
  l = snprintf(buff, BUFFER_LEN, "cquote2_fore:%d\n", cquote2_fore);
  cfwrite(&ctx, buff, l, 0, conf);
  l = snprintf(buff, BUFFER_LEN, "cquote3_back:%d\n", cquote3_back);
  cfwrite(&ctx, buff, l, 0, conf);
  l = snprintf(buff, BUFFER_LEN, "cquote3_fore:%d\n", cquote3_fore);
  cfwrite(&ctx, buff, l, 0, conf);

  l = snprintf(buff, BUFFER_LEN, "chavekey_fore:%d\n", chavekey_fore);
  cfwrite(&ctx, buff, l, 0, conf);
  l = snprintf(buff, BUFFER_LEN, "chavekey_back:%d\n", chavekey_back);
  cfwrite(&ctx, buff, l, 0, conf);
  l = snprintf(buff, BUFFER_LEN, "ctoyou_fore:%d\n", ctoyou_fore);
  cfwrite(&ctx, buff, l, 0, conf);
  l = snprintf(buff, BUFFER_LEN, "ctoyou_back:%d\n", ctoyou_back);
  cfwrite(&ctx, buff, l, 0, conf);
  l = snprintf(buff, BUFFER_LEN, "cdelete_fore:%d\n", cdelete_fore);
  cfwrite(&ctx, buff, l, 0, conf);
  l = snprintf(buff, BUFFER_LEN, "cdelete_back:%d\n", cdelete_back);
  cfwrite(&ctx, buff, l, 0, conf);

#endif


  l = sprintf(buff, "[end-options]\n");
  cfwrite(&ctx, buff, l, 0, conf);

  l = sprintf(buff, "[accounts]\n");
  cfwrite(&ctx, buff, l, 0, conf);


  // write account
  logg("config - writing accounts\n");
  i = naccount;
  for (i = 0; i < naccount; i++)
  {
    l = snprintf(buff, BUFFER_LEN, "host: %s\n", account[i]->host);

    cfwrite(&ctx, buff, l, 0, conf);

    l = snprintf(buff, BUFFER_LEN, "port: %d\n", account[i]->port);
    cfwrite(&ctx, buff, l, 0, conf);

    l = snprintf(buff, BUFFER_LEN, "proto: %d\n", account[i]->proto);
    cfwrite(&ctx, buff, l, 0, conf);

    l = snprintf(buff, BUFFER_LEN, "user: %s\n", account[i]->user);
    cfwrite(&ctx, buff, l, 0, conf);

    l = snprintf(buff, BUFFER_LEN, "email: %s\n", account[i]->email);
    cfwrite(&ctx, buff, l, 0, conf);

    pass = NULL;
    l =
      snprintf(buff, BUFFER_LEN, "pass: %s\n",
               account[i]->nopass ? "0" : (pass = _return(account[i]->pass)));
    cfwrite(&ctx, buff, l, 0, conf);

    logg("config - writing account -> %s :: %d :: %d  :: %s :: %s\n",
         account[i]->host, account[i]->port, account[i]->proto,
         account[i]->user, account[i]->email);
    if (pass)
      free(pass);
  }

  l = sprintf(buff, "[end-accounts]\n");
  cfwrite(&ctx, buff, l, 0, conf);


  // write contacts
  logg("config - writing contacts\n");
  l = sprintf(buff, "[contacts]\n");

  cfwrite(&ctx, buff, l, 0, conf);

  if (groups)
    logg(" il gruppo e' %s e il con %s.\n ", groups->name,
         groups->head->email);
  else
    logg("nn c'e' groups\n");

  if (groups)
  {
    pgr = groups;
    pcon = pgr->head;
  } else
  {
    pgr = NULL;
    pcon = NULL;
  }

  while (pgr)
  {

    pcon = pgr->head;

    // write name of group
    l = snprintf(buff, BUFFER_LEN, "%s\n", pgr->name);
    cfwrite(&ctx, buff, l, 0, conf);

    // write all contacts of this group
    while (pcon)
    {
      l = snprintf(buff, BUFFER_LEN, "name: %s\n", pcon->name);
      cfwrite(&ctx, buff, l, 0, conf);

      l = snprintf(buff, BUFFER_LEN, "email: %s\n", pcon->email);
      cfwrite(&ctx, buff, l, 0, conf);

      l = snprintf(buff, BUFFER_LEN, "have_key: %d\n", pcon->have_key);
      cfwrite(&ctx, buff, l, 0, conf);

      logg("config - writing contact -> %s :: %s :: %d\n", pcon->name,
           pcon->email, pcon->have_key);

      pcon = pcon->next;
    }

    l = snprintf(buff, BUFFER_LEN, "end group\n");
    cfwrite(&ctx, buff, l, 0, conf);
    pgr = pgr->next;
  }

  l = sprintf(buff, "[end-contacts]\n");
  cfwrite(&ctx, buff, l, 0, conf);

  // write filters
  logg("config - Writing filters\n");
  l = sprintf(buff, "[filters]\n");
  cfwrite(&ctx, buff, l, 0, conf);

  fil = filt;
  while (fil)
  {
    logg("dentro il while di ogni filtro\n");
    // write the filter's name
    l = snprintf(buff, BUFFER_LEN, "%s\n", fil->name);
    cfwrite(&ctx, buff, l, 0, conf);
    rul = fil->head;
    logg("prima del while di scrittura delle rules\n");
    // write rules
    while (rul)
    {
      l =
        snprintf(buff, BUFFER_LEN, "%s\n%s\n%d\n%d\n", rul->what, rul->value,
                 rul->parse, rul->after);
      cfwrite(&ctx, buff, l, 0, conf);
      // logg("config - writing filter [%s] -> rule :: %s :: %d:: %s ::
      // %s\n",
      // rul->what, rul->value, rul->parse, rul->after);
      rul = rul->next;
    }

    l = snprintf(buff, BUFFER_LEN, "%d\n", fil->action);
    cfwrite(&ctx, buff, l, 0, conf);
    if (fil->action != DELETE)
    {
      l = snprintf(buff, BUFFER_LEN, "%s\n", fil->where);
      cfwrite(&ctx, buff, l, 0, conf);
    }
    fil = fil->next;
  }

  l = sprintf(buff, "[end-filters]\n[end]\n");
  cfwrite(&ctx, buff, l, 1, conf);
  logg("config - finish write configuration file\n");
  return 0;
}
