/*
 * Copyright (C) 2003  
 * paranoy project - paranox.sf.net - paranoy@autistici.org
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

#include "include.h"

int
curmain(int narg, char *arg[])
{
  // main menu
  char *mlist[6] =
    { "Read", "Compose", "Download", "Settings", "Help", "Quit" };

  // to store the position of the cursor in main menu
  static ushort fmenu = 0;
  long int i = 0;

  // need by getch
  int c;

  winfo = wmenu = wlist = wmain = weditor = wdata = wcompose = NULL;
  text = NULL;

  // let's go...initialize ncurses
  initscr();
  noecho();
  curs_set(0);
  keypad(stdscr, TRUE);

  // initialize colors
  start_color();

  // used to force background transparency in terminal that support it
  use_default_colors();

  init_pair(1, COLOR_WHITE, COLOR_BLACK);
  init_pair(2, COLOR_BLACK, COLOR_RED);
  init_pair(3, COLOR_BLACK, COLOR_GREEN);
  init_pair(4, COLOR_BLACK, COLOR_YELLOW);
  init_pair(5, COLOR_BLACK, COLOR_BLUE);
  init_pair(6, COLOR_BLACK, COLOR_MAGENTA);
  init_pair(7, COLOR_BLACK, COLOR_CYAN);
  init_pair(8, COLOR_BLACK, COLOR_WHITE);
  // init_pair(9,COLOR_WHITE,-1);


  init_pair(COLOR_NEW, cnew_fore, cnew_back);
  init_pair(COLOR_OLD, cold_fore, cold_back);
  init_pair(COLOR_TITLE, ctitle_fore, ctitle_back);
  init_pair(COLOR_INFO, cinfo_fore, cinfo_back);
  init_pair(COLOR_QUOTE1, cquote1_fore, cquote1_back);
  init_pair(COLOR_QUOTE2, cquote2_fore, cquote2_back);
  init_pair(COLOR_QUOTE3, cquote3_fore, cquote3_back);
  init_pair(COLOR_HAVEKEY, chavekey_fore, chavekey_back);
  init_pair(COLOR_TOYOU, ctoyou_fore, ctoyou_back);
  init_pair(COLOR_DELETE, cdelete_fore, cdelete_back);

  // drop ctrl+c & SIGTERM
  signal(SIGINT, cursig);
  signal(SIGTERM, cursig);

  // this is a ncurses constant (edit /usr/include/curses.h for more info)
  ESCDELAY = 0;

  // control if the terminal is too small
  if (COLS < 50 || LINES < 20)
  {
    // clear();
    // refresh();
    endwin();
    stdscr = NULL;
    end("Your terminal is too small to run paranoy...");
  }
  // menu position
  fmenu = 0;
  downloading = 0;
  if (!has_colors())
    info(0,
         "Your terminal don't support color...paranoy's information will not clear");

  wtop = newwin(1, COLS, 0, 0);
  wmain = newwin(LINES - 2, COLS, 1, 0);
  winfo = newwin(1, COLS, LINES - 1, 0);
  keypad(wmain, TRUE);
  // wbkgdset(wtop, COLOR_PAIR(1));
  refresh();


  // compose
  if (mode == COMPOSE)
  {
    compose(NULL, 0);
    end("Send bug reports to lesion@autistici.org\n");
  }


  print_menu(mlist);
  cbreak();
  i = 0;


  // the main cicle begins
  do
  {
    logg("curmain - main loop\n");
    if (!net_optimize)
    {
      // normalize old selection
      wattroff(wmain, A_REVERSE);
      mvwprintw(wmain, 2 + i, 6, mlist[i]);

      // select new label
      wattron(wmain, A_REVERSE);
      mvwprintw(wmain, 2 + fmenu, 6, mlist[fmenu]);

    } else
    {
      // normalize old selection
      mvwprintw(wmain, 2 + i, 5, " ");
      // select new label
      mvwprintw(wmain, 2 + fmenu, 5, ">");
    }
    logg("curmain - main loop\n");
    wrefresh(wmain);
    // wait the user press a key
    c = wgetch(wmain);

    // user have to put the password to download....
    if (downpass == 1)
    {
      ungetch(c);
      while (1)
      {
        usleep(100000);
        if (downpass == 0)
          break;
      }

      logg("curmain3 - main loop\n");
      logg("curmain4 - main loop\n");
      continue;
    }

    switch (c)
    {
      case KEY_RESIZE:
        c = wgetch(wmain);
        logg("curmain - window resize %d\n", c);
        break;
        // exit
      case 'q':
      case 27:
        if (downloading)
          info(1, "paranoy is downloading email... please wait");
        else
          i = 27;
        break;
        // down
      case KEY_DOWN:
        i = fmenu;
        if (fmenu == 5)
          fmenu = 0;
        else
          fmenu++;
        break;
        // up
      case KEY_UP:
        i = fmenu;
        if (fmenu == 0)
          fmenu = 5;
        else
          fmenu--;
        break;
        // read,compose,setting,help
      case 'r':
      case 'c':
      case 'd':
      case 's':
      case 'h':
      case KEY_F(1):
      case '?':
        i = fmenu;
        if (c == 'r')
          fmenu = 0;
        else if (c == 'c')
          fmenu = 1;
        else if (c == 'd')
          fmenu = 2;
        else if (c == 's')
          fmenu = 3;
        else if (c == KEY_F(1) || c == '?' || c == 'h')
          fmenu = 4;
        // right, space and enter
      case KEY_RIGHT:
      case 10:
      case 32:
        // read
        if (fmenu == 0)
        {
          if (nfolds != 0)
          {
            folders();
            print_menu(mlist);
          } else
            info(0, "No folders...\n");
        }
        // compose
        else if (fmenu == 1)
        {
          if (smtpserver == NULL)
          {
            info(0, "No smtp server configured!\n");
            break;
          }
          compose(NULL, 0);
          // print the title on the top of the screen
          print_menu(mlist);

        }
        // download
        else if (fmenu == 2)
        {
          if (!downloading)
          {
            downloading = 1;
            pthread_create(&download_thread, NULL, (void *) download, NULL);
          } else
            info(2, "paranoy is still download your mail!");
        }
        // setting
        else if (fmenu == 3)
        {
          setting();
          // rewrite menu
          print_menu(mlist);
        }
        // help
        else if (fmenu == 4)
        {
          help("help");
          print_menu(mlist);
        }
        // quit
        else if (fmenu == 5)
        {
          if (downloading)
            info(0, "paranoy is downloading email... please wait");
          else
            i = 27;
        }
        break;
      default:
        info(1, "unknow key...\n");
        break;
    }
  }
  while (i != 27);
  end("Send bug reports to paranoy@autistici.org\n");
  return -1;
}



void
print_menu(char **mlist)
{
  byte i;

  // print the title on the top of the screen
  title("-= paranoy %s =-", VERSION);

  // print menu
  wattroff(wmain, COLOR_PAIR(1));
  for (i = 0; i < 6; i++)
    mvwprintw(wmain, 2 + i, 6, mlist[i]);
}
