/*
 * Copyright (C) 2003  
 * paranoy project - paranox.sf.net - paranoy@autistici.org
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */
#include <curses.h>


#define ENTER	10
#define KEY_TAB	        9
#define ESC		        27
#define SPACE 	        32

#define CTRLW           25
#define CTRLE           5
#define CTRLR           18
#define CTRLT           20
#define CTRLY           25
#define CTRLU           21
#define CTRLO           15
#define CTRLP           16
#define CTRLA           1
#define CTRLD           4
#define CTRLF           6
#define CTRLG           7
#define CTRLH           8
#define CTRLK           11
#define CTRLL           12
#define CTRLX           24
#define CTRLV           22
#define CTRLB           2
#define CTRLN           14


#define COLOR_NEW       10
#define COLOR_OLD       11
#define COLOR_TITLE     12
#define COLOR_INFO      13
#define COLOR_QUOTE1    14
#define COLOR_QUOTE2    15
#define COLOR_QUOTE3    16
#define COLOR_HAVEKEY   17
#define COLOR_TOYOU     18
#define COLOR_DELETE    19
#define COLOR_TEMP      20

short int cnew_back, cnew_fore, cold_back, cold_fore,
  ctitle_back, ctitle_fore, cinfo_back, cinfo_fore, cquote1_back,
  cquote1_fore, cquote2_back, cquote2_fore, cquote3_back, cquote3_fore,
  chavekey_fore, chavekey_back, ctoyou_fore, ctoyou_back, cdelete_fore,
  cdelete_back;

// setting windows
WINDOW *wmenu, *wlist, *wdata, *winfo, *wmain, *weditor, *wcompose, *wtop;

/*
 * curmain.c 
 */
int curmain(int narg, char *arg[]);
void print_menu(char **mlist);

/*
 * setting.c 
 */
void setting();
void sel(ushort mpos, ushort lpos);


/*
 * curfunz.c 
 */
void add_account();
void list_account();
void edit_contact();

void edit_account(struct accountlist *temp);
void list_contact();
void add_contact();


short account_menu();
void title(const char *str, ...);
void set_color();
void print_line(WINDOW * win, ushort y, char *l);
char *edit_string(char *str, byte y, byte x, WINDOW * win);
void clear_w(WINDOW * win, byte border);
void get_color(short pair);

// compose.c
void compose(struct email *rmail, byte empty_reply_forward);
void save_draft(struct email *mail);

// attach.c
void add_attach(struct email *mail);
void print_attach_list(struct dirent **dir, ushort start, ushort max);

// nym.c
void create_nym_account();

// editor.c


void edit();
void print_text(struct lines *head, ushort first, int nline);

void cur_gen_key();
void cur_gen_key_callback(void *self, const char *what, int type, int current,
                          int total);
