/*
 * Copyright (C) 2003  
 * paranoy project - paranox.sf.net - paranoy@autistici.org
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

#include "include.h"

void
del_rules(struct filters *f)
{
  struct rules *old, *cur = f->head;

  while (cur)
  {
    if (cur->value)
      free(cur->value);
    if (cur->what)
      free(cur->what);
    old = cur;
    cur = cur->next;
    free(old);
  }

}

int
del_filter(char *name)
{
  struct filters *old = NULL, *cur = filt;

  while (cur)
  {
    if (!strcmp(cur->name, name))
    {
      if (cur == filt)
        filt = filt->next;
      else
        old->next = cur->next;

      free(cur->name);
      del_rules(cur);

      if (cur->where)
        free(cur->where);
      free(cur);
      return 1;
    }
    old = cur;
    cur = cur->next;
  }
  return 0;
}

// try to delete all filters
void
del_all_filter()
{
  struct filters *cur = filt;

  while (filt)
  {
    filt = filt->next;
    free(cur->name);
    if (cur->where)
      free(cur->where);
    del_rules(cur);
    free(cur);
    cur = filt;
  }
  filt = NULL;
}

struct filters *
filterz(struct connection *c, struct email *mail)
{
  int l;
  byte i = 0;
  char buff[BUFFER_LEN];
  struct filters *cur = filt;
  struct rules *rul;
  byte value;

  logg("\n\n DENTRO FILTER \n\n");


  // here we keep TOP output, the headers of email
  // qui devo usare pop3_recv_line
  l = pop3_recv_line(c, buff, BUFFER_LEN);

  // logg("filter - recvline l = %d buff = '%s'\n", l, buff);

  while (buff[0] != '.' && buff[1] != '\n')
  {
    logg("-= HEAD - leggo  %d caratteri '%s'\n", l, buff);
    mail->hlen += l;
    mail->header = (char **) realloc(mail->header, sizeof(char *) * (i + 2));
    mail->header[i] = (char *) malloc(sizeof(char) * l + 1);
    mail->head_lines++;
    // l+1 ci copia anke il \0 finale
    memcpy(mail->header[i++], buff, l + 1);

    if (!strncasecmp(buff, "message-id:", 11))
    {
      mail->messageid = (char *) smalloc(sizeof(char) * l - 11);
      memcpy(mail->messageid, buff + 12, l - 11);
      // logg("filterz - found messageid = '%s'\n", mail->messageid);
    } else if (!strncasecmp(buff, "date:", 5))
    {
      mail->date = rfcdate(buff + 6);
      // if (mail->date)
      // logg("filterz - date of messages '%d/%d'\n", mail->date->tm_mday,
      // mail->date->tm_mon);
    } else if (!strncasecmp(buff, "mime-version:", 13))
    {
      mail->mime = MIME;
    } else if (!strncasecmp(buff, "subject:", 8))
    {
      mail->subject = strdup(buff + 9);
      // logg("filterz - subject: %s\n", mail->subject);
    } else if (!strncasecmp(buff, "content-type:", 13))
    {
      char *p, *ca;

      if ((p = strcasestr(buff, "boundary=")))
      {
        // printf("filter - boundary '%s'\n", p);
        // fflush(stdout);
        ca = nexttoken(p + 11);
        // printf("nextoken ritorna %s\n", ca);
        // fflush(stdout);
        // clean quotes 
        ca--;
        ca = 0;
        mail->boundary = strdup(p + 10);
        p = strstr(mail->boundary, "\"");
        if (p)
          *(p) = 0;
        p = strstr(mail->boundary, "\'");
        if (p)
          *(p) = 0;

        // printf("il * voundary dopo il nexttoken e' %s\n", mail->boundary);
        // fflush(stdout);
      }
    }

    else if (!strncasecmp(buff, "to:", 3))
    {
      mail->to = (char **) malloc(sizeof(char *));
      mail->to[0] = strdup(buff + 4);
      mail->nto = 1;
    } else if (!strncasecmp(buff, "from:", 5))
    {
      mail->from = strdup(buff + 6);
    } else if (!strncasecmp(buff, "in-reply-to:", 12))
    {
      mail->inreplyto = strdup(buff + 13);
      // logg("filterz - inreplyto: %s\n", mail->inreplyto);
    }

    logg("-- prima di pop3_recv_line \n");
    l = pop3_recv_line(c, buff, BUFFER_LEN);
    logg("-- dopo di pop3_recv_line %d\n", l);

  }

  logg("dopo il while ke ha parsato gli headers\n");
  if (!mail->subject)
    mail->subject = strdup("no subject");
  if (!mail->from)
    mail->from = strdup("no from");
  if (!mail->inreplyto)
    mail->inreplyto = strdup("no inreplyto");
  if (!mail->to)
  {
    mail->to = (char **) malloc(sizeof(char *));
    mail->to[0] = strdup("Unknown");
    mail->nto = 1;
  }
  if (!mail->messageid)
    mail->messageid = strdup(mail->subject);
  if (!mail->date)
  {
    mail->date = (struct tm *) malloc(sizeof(struct tm));
    mail->date->tm_mday = 0;
    mail->date->tm_mon = 13;
    mail->date->tm_year = 0;
  }

  mail->header[i] = NULL;

  logg("prima dei filteri\n");
  // pass through filters list
  while (cur)
  {
    rul = cur->head;
    value = match_rules(mail, rul);
    do
    {
      if (rul->after == AND)
        value = value & match_rules(mail, rul->next);
      else if (rul->after == OR)
        value = value | match_rules(mail, rul->next);
      else if (rul->after == NONE)
        break;
      rul = rul->next;
    }
    while (1);

    if (value)
    {
      logg("esco dal filter\n");
      return cur;
    }
    cur = cur->next;
  }
  logg("esco dal filter\n");
  return NULL;
}


byte
match_rules(struct email * mail, struct rules * rul)
{
  byte i = 0;

  logg("son dentro  match_rules\n");
  while (mail->header[i])
  {
    logg("prima di strncasecmp '%s' ... '%s' per %d bytes\n", mail->header[i],
         rul->what, strlen(rul->what));
    if (!strncasecmp(mail->header[i], rul->what, strlen(rul->what)))
    {
      logg("dentro dentro dentro\n");
      switch (rul->parse)
      {
        case CONTAIN:
          logg("sono nel contain .... rul '%s' e l'header '%s'\n", rul->value,
               mail->header[i] + strlen(rul->what));
          if (strstr(mail->header[i] + strlen(rul->what), rul->value))
            return 1;
          else
            return 0;
        case NOT_CONTAIN:
          if (!strstr(mail->header[i] + strlen(rul->what), rul->value))
            return 1;
          else
            return 0;
        case EQUAL:
          if (!strcmp(mail->header[i] + strlen(rul->what) + 1, rul->value))
            return 1;
          else
            return 0;
        case NOT_EQUAL:
          if (strcmp(mail->header[i] + strlen(rul->what) + 1, rul->value))
            return 1;
          else
            return 0;
        default:
          break;
      }
    }
    i++;
  }
  return 0;
}
