/*
 * Copyright (C) 2003  
 * paranoy project - paranoy.sf.net - paranoy@autistici.org
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

#include "include.h"

void
init_gpgme(gpgme_protocol_t proto)
{
  gpgme_error_t err;

  gpgme_check_version(NULL);

  err = gpgme_engine_check_version(proto);

}


#ifdef USE_CURSES
#include "curses.h"
static const char *
cur_ask_passphrase(void *opaque, const char *desc, void **r_hd)
{
  char *s;

  if (!desc)
    return NULL;
  s = (char *) malloc(60);
  curs_set(2);
  info(1, "Insert passphrase : ");
  noecho();
  keypad(stdscr, FALSE);
  keypad(winfo, FALSE);
  wgetnstr(winfo, s, 63);
  keypad(stdscr, TRUE);
  keypad(winfo, TRUE);
  curs_set(0);
  return s;
}


#endif

#ifdef USE_GTK
static const char *
gtk_ask_passphrase(void *opaque, const char *desc, void **r_hd)
{
  return NULL;
}
#endif


void
gen_key(char *name, char *comment, char *mail, char *pass, ushort length)
{
  gpgme_ctx_t ctx;
  gpgme_error_t err;
  char *params;

  init_gpgme(GPGME_PROTOCOL_OpenPGP);

  err = gpgme_new(&ctx);
  if (err)
  {
    info(1, "Error while generating key: %s", gpgme_strerror(err));
    return;
  }

  if (gui == GTK)
  {
#ifdef USE_GTK
    // gpgme_set_progress_cb(ctx, gtk_gen_key_callback, NULL);
#endif
  } else if (gui == NCURSES)
  {
#ifdef USE_CURSES
    gpgme_set_progress_cb(ctx, cur_gen_key_callback, NULL);
#endif
  }
  params = (char *) malloc(400);
  sprintf(params, "<GnupgKeyParms format=\"internal\">\n"
          "Key-Type: DSA\n"
          "Key-Length: %d\n"
          "Subkey-Type: ELG-E\n"
          "Subkey-Length: 1024\n"
          "Name-Real: %s\n"
          "Name-Comment: (%s)\n"
          "Name-Email: %s\n"
          "Expire-Date: 0\n"
          "Passphrase: %s\n" "</GnupgKeyParms>\n", length, name,
          comment == NULL ? "" : comment, mail, pass);
  err = gpgme_op_genkey(ctx, params, NULL, NULL);
  if (err)
  {
    info(1, "Error while generating key: %s", gpgme_strerror(err));
    free(params);
    gpgme_release(ctx);
    return;
  }
  free(params);
  gpgme_release(ctx);
  info(0, "Keys generated!");
}


short
have_public_key(char *email)
{
  gpgme_ctx_t ctx = NULL;
  gpgme_error_t err;
  gpgme_key_t key;
  ushort res = 0;

  gpgme_set_keylist_mode(ctx, 1);
  err = gpgme_op_keylist_start(ctx, email, 0);
  if (err)
  {
    info(1, "Error while keylist start: %s", gpgme_strerror(err));
    return -1;
  }
  res = gpgme_op_keylist_next(ctx, &key);
  gpgme_key_release(key);
  gpgme_release(ctx);
  return res;
}

#define return_on_error(err) if(err){logg("Error while encrypt: %s",gpgme_strerror(err)); return data;}
char *
gpg_encrypt(char *data, struct contacts *recipient)
{
  gpgme_ctx_t ctx;
  gpgme_error_t err;
  gpgme_data_t in, out = NULL;
  gpgme_key_t key[1] = { NULL };
  char *s;
  char buff[BUFFER_REAL];
  size_t i;
  unsigned long long int l;

  // gpgme_encrypt_result_t result;

  init_gpgme(GPGME_PROTOCOL_OpenPGP);

  err = gpgme_new(&ctx);
  return_on_error(err);

  gpgme_set_armor(ctx, 1);
  err = gpgme_data_new_from_mem(&in, data, strlen(data), 0);
  return_on_error(err);
  err = gpgme_get_key(ctx, recipient->fingerprint, &key[0], 0);
  return_on_error(err);
  err = gpgme_op_encrypt(ctx, key, GPGME_ENCRYPT_ALWAYS_TRUST, in, out);
  return_on_error(err);

  gpgme_data_seek(out, 0, SEEK_SET);
  s = (char *) malloc(BUFFER_REAL * sizeof(char));
  bzero(s, BUFFER_REAL);
  l = BUFFER_LEN;
  while (!(i = gpgme_data_read(out, buff, BUFFER_LEN)))
  {
    buff[i] = 0;
    // TOFIX (this is shit, cpusucante)
    strncat(s, buff, i);
    l += i;
    s = (char *) realloc(s, sizeof(char) * l);
  }

  free(data);
  gpgme_data_release(in);
  gpgme_data_release(out);
  gpgme_release(ctx);
  return s;
}


char *
gpg_sign(char *data)
{
  char *s = NULL;
  size_t i;
  unsigned long int l = 0;
  gpgme_ctx_t ctx;
  gpgme_error_t err;
  gpgme_data_t in, out;

	logg("prima aver chiesto la passphrase\n");
  return_on_error(gpgme_new(&ctx));

	logg("prima aver chiesto la passphrase\n");
  if (gui == GTK)
  {
#ifdef USE_GTK
    gpgme_set_passphrase_cb(ctx, gtk_ask_passphrase, NULL);
#endif
  } else if (gui == NCURSES)
  {
#ifdef  USE_CURSES 
	gpgme_set_passphrase_cb(ctx, cur_ask_passphrase, NULL);
#endif
  }

	logg("dopo aver chiesto la passphrase\n");

  gpgme_set_textmode(ctx, 1);
  gpgme_set_armor(ctx, 1);
  return_on_error(gpgme_data_new_from_mem(&in, data, strlen(data), 0));
  return_on_error(gpgme_data_new(&out));
  return_on_error(gpgme_op_sign(ctx, in, out, GPGME_SIG_MODE_CLEAR));
  return_on_error(gpgme_data_seek(out,0,SEEK_SET));
  s = (char *) malloc(sizeof(char) * 501);
  while (!(i = gpgme_data_read(out, s + l, 500)))
  {
    l += i;
    s = (char *) realloc(s, sizeof(char) * (l + 500));
  } s[l] = 0;
  logg(s);
  gpgme_data_release(in);
  gpgme_data_release(out);
  gpgme_release(ctx);
  free(data);
  return s;

}
