/*
 * Copyright (C) 2003  
 * paranoy project - paranox.sf.net - paranoy@autistici.org
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

#include "include.h"

#define IMAP_ERROR		-1

#define IMAP_START_OK 		"* OK"
#define IMAP_OK          	"OK"
#define IMAP_NO          	"NO"
#define IMAP_BAD         	"BAD"
#define IMAP_EOL         	"\n\r"
#define IMAP_QUOTE_EOL   	"\"\n\r"
#define IMAP_QUOTE_QUOTE 	"\"\""
#define IMAP_QUOTE_SPACE_QUOTE  "\" \""

#define IMAP_LOGIN_COMMAND       "LOGIN"
#define IMAP_LOGOUT_COMMAND      "LOGOUT"

#define IMAP_LIST_COMMAND	"LIST"
#define IMAP_LIST_ALL_FOLDERS   "\"*\""

#define IMAP_SELECT_COMMAND	"SELECT"

#define IMAP_EXPUNGE_COMMAND	"EXPUNGE"

#define IMAP_EXISTS		"EXISTS"

#define IMAP_NEW_TAG         sprintf(imap_tag,"A%d",tag++)

#define IMAP_MAX_DOWNLOAD_MESG	1000000

int tag = 10000;
char imap_tag[7] = { '\0', '\0', '\0', '\0', '\0', '\0', '\0' };

struct connection *
imap_session(struct accountlist *a)
{
  struct connection *c;
  char buff[BUFFER_REAL];
  ushort n;
  int n_mesg;

  /*
   * ushort i, n, len; struct email *mail; struct folders *fold; struct
   * filters *filter = NULL; struct list *l, *last = NULL; char *banner; FILE 
   * *index; EVP_CIPHER_CTX ctx; char iv[9] = "aaaaaaaa"; 
   */

  c = (struct connection *) smalloc(sizeof(struct connection));
  c->sbio = NULL;
  c->state = IMAP_NOT_AUTHENTICATED_STATE;
  c->err = NO_ERROR;

  logg("IMAP_NOT_AUTHENTICATED_STATE\n");

  info(0, "Connecting to %s", a->host);
  // controlla ke la connesione sia andata a buon fine
  if (para_connect
      (c, a->host, a->port,
       (a->proto == IMAP_SSL_PROTO) ? SSL_CONNECTION : CLEAR_CONNECTION))
  {
    logg("dopo para connect sono in error\n");
    info(1, "Error while connecting to %s:%d", a->host, a->port);
    free(c);
    c = NULL;
    return c;
  }
  logg("sono connesso leggo il banner!\n");
  info(0, "Connected...reading banner\n");
  // legge il banner
  if (para_read(c, buff, BUFFER_LEN) < 0)
  {
    logg("Error reading banner\n");
    info(1, "Error while reading imap banner");
    return c;
  }

  if (!strncasecmp(buff, IMAP_START_OK, 4))
  {
    info(0, "Trying authentication ...\n");
    logg("Trying authenticated state\n");
  } else
  {
    logg("Error in banner response\n");
    info(1, "I didn't find * OK");
    return c;
  }

  if (a->nopass == 1 && a->pass == NULL)
  {
    n = downpass = 1;
    info(0, "Insert the password for %s: ", a->email);
    // TOFIX wgetnstr(winfo, buff, BUFFER_LEN);
    a->pass = _malloc(strlen(buff) + 1);
    _mempcpy(a->pass, buff, strlen(buff));
    downpass = 0;
  }

  logg("IMAP Authentication\n");

  c->err = imap_login(c, a);

  if (c->err != NO_ERROR)
  {
    info(0, "Error while IMAP authentication\n");
    logg("Error while IMAP authentication\n");
    imap_logout(c);
    return c;
  }

  c->state = IMAP_AUTHENTICATED_STATE;
  info(0, "Authentication successfull\n");
  logg("Auth successfull: Enter in IMAP_AUTHENTICATED_STATE\n");

  switch (n_mesg = imap_select_mailbox(c, "inbox"))
  {
    case 0:
      info(0, "Non ci sono nuovi messaggi\n");
      logg("Non ci sono nuovi messaggi\n");
      imap_logout(c);
      return c;
    case -1:
      info(0, "Errore durante la select\n");
      logg("Errore durante la select\n");
      imap_logout(c);
      return c;
    default:
      info(0, "Ci sono numero %d messaggi\n", n_mesg);
      logg("Ci sono numero %d messaggi\n", n_mesg);
      imap_logout(c);
      return c;
  }

  c->err = imap_expunge(c);

  c->err = imap_logout(c);

  return NULL;
}


/*
 * Tenta di loggarsi sul server imap
 */

byte
imap_login(struct connection * c, struct accountlist * a)
{
  char buff[BUFFER_REAL];
  char imap_ok_login[10];
  char *pass;

  logg("IMAP LOGIN\n");
  pass = _return(a->pass);

  IMAP_NEW_TAG;
  snprintf(imap_ok_login, 10, "%s OK", imap_tag);
  snprintf(buff, BUFFER_LEN, "%s %s %s %s%s", imap_tag, IMAP_LOGIN_COMMAND,
           a->user, pass ? pass : "", IMAP_EOL);

  if (pass)
    free(pass);

  logg("IMAP login string: %s\n", buff);

  if (para_write(c, buff) < 0)
  {
    logg("IMAP login error in para_write\n");
    return IMAP_ERROR;
  }

  if (para_read(c, buff, BUFFER_LEN) < 0)
  {
    logg("IMAP login error in para_read\n");
    return IMAP_ERROR;
  }

  logg("IMAP login response %s\n", buff);

  if (!strncasecmp(buff, imap_ok_login, 9))
    return NO_ERROR;
  return IMAP_ERROR;
}


byte
imap_logout(struct connection * c)
{
  char buff[BUFFER_REAL];
  byte err;

  logg("Logout from Imap Server: IMAP_LOGOUT_STATE\n");

  IMAP_NEW_TAG;

  snprintf(buff, sizeof(buff), "%s %s%s", imap_tag, IMAP_LOGOUT_COMMAND,
           IMAP_EOL);

  if (para_write(c, buff) < 0)
  {
    logg("IMAP logout error in para_write\n");
    return IMAP_ERROR;
  }

  c->state = IMAP_LOGOUT_STATE;

  if (para_read(c, buff, BUFFER_LEN) < 0)
  {
    logg("IMAP logout error in para_read. I'll close connection anyway\n");
    err = IMAP_ERROR;
  } else
  {
    logg("IMAP logout response %s\n", buff);
    err = NO_ERROR;
  }

  para_close(c);

  return err;
}

/*
 * The EXPUNGE command permanently removes from the currently selected
 * mailbox all messages that have the \Deleted flag set. Before returning an
 * OK to the client, an untagged EXPUNGE response is sent for each message
 * that is removed. 
 */

byte
imap_expunge(struct connection * c)
{
  char buff[BUFFER_REAL];

  logg("Expunge\n");

  IMAP_NEW_TAG;

  snprintf(buff, sizeof(buff), "%s %s%s", imap_tag, IMAP_EXPUNGE_COMMAND,
           IMAP_EOL);

  logg("%s\n", buff);

  if (para_write(c, buff) < 0)
  {
    logg("IMAP expunge error in para_write\n");
    return IMAP_ERROR;
  }

  if (para_read(c, buff, BUFFER_LEN) < 0)
  {
    logg("IMAP expunge error in para_read\n");
    return IMAP_ERROR;
  }

  logg("%s\n", buff);
  return NO_ERROR;
}

byte
imap_list_mailbox(struct connection * c)
{
  char buff[BUFFER_REAL];

  logg("Listing mailbox\n");

  IMAP_NEW_TAG;

  snprintf(buff, sizeof(buff), "%s %s %s %s %s", imap_tag, IMAP_LIST_COMMAND,
           IMAP_QUOTE_QUOTE, IMAP_LIST_ALL_FOLDERS, IMAP_QUOTE_EOL);

  if (para_write(c, buff) < 0)
  {
    logg("IMAP list mailbox error in para_write\n");
    return IMAP_ERROR;
  }

  if (para_read(c, buff, BUFFER_LEN) < 0)
  {
    logg("IMAP list mailbox error in para_read\n");
    return IMAP_ERROR;
  }

  logg("IMAP list mailbox\n %s\n", buff);
  return NO_ERROR;
}

int
imap_select_mailbox(struct connection *c, char *mailbox)
{
  char buff[BUFFER_REAL];
  char *buff_temp;
  int i = 0, n_mesg = 0;

  logg("Select a mailbox\n");

  IMAP_NEW_TAG;

  snprintf(buff, sizeof(buff), "%s %s \"%s%s", imap_tag, IMAP_SELECT_COMMAND,
           mailbox, IMAP_QUOTE_EOL);

  logg("%s\n", buff);

  if (para_write(c, buff) < 0)
  {
    logg("IMAP select mailbox error in para_write\n");
    return IMAP_ERROR;
  }

  c->state = IMAP_SELECTED_STATE;

  if (para_read(c, buff, BUFFER_LEN) < 0)
  {
    logg("IMAP select mailbox error in para_read\n");
    return IMAP_ERROR;
  }

  /*
   * Schifezza per recuperare il numero di messaggi nella mailbox
   */

  if ((buff_temp = strstr(buff, IMAP_EXISTS)) == NULL)
  {
    logg("IMAP select mailbox error: exists\n");
    return IMAP_ERROR;
  }

  while (*buff_temp != '*')
    buff_temp--;

  buff_temp += 2;

  while (isdigit(*buff_temp))
  {
    buff[i] = *buff_temp;
    i++;
    buff_temp++;
  }
  buff[i] = '\0';

  n_mesg = atoi(buff);

  logg("Ci sono %d\n", n_mesg);
  info(0, "Ci sono %d\n", n_mesg);

  return n_mesg;
}
