/*
 * include.h.  Generated automatically by configure.  
 */
/*
 * Copyright (C) 2003
 * paranoy project - paranox.sf.net - paranoy@autistici.org
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

#define __USE_GNU
#define _GNU_SOURCE

#include <netdb.h>
#include <arpa/inet.h>
#include <dlfcn.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <stdarg.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/param.h>
#include <time.h>
#include <signal.h>
#include <dirent.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/wait.h>

#ifndef WINDOWS
#include <sys/ptrace.h>
#include <sys/dir.h>
#else
#define strcasestr(x,y) strstr(x,y)
#endif


#include <fcntl.h>

#include <stdio.h>
#include <openssl/ssl.h>
#include <openssl/md5.h>
#include <openssl/err.h>
#include <openssl/bio.h>
#include <openssl/evp.h>
#include <openssl/rand.h>
#include <pthread.h>
#include <ctype.h>
#include <gpgme.h>
#include <_malloc.h>

#include <string.h>
#include <unistd.h>



#define VERSION "0.8"

#define NCURSES	0
#define GTK	1

#define BUFFER_LEN   512
#define BUFFER_REAL  513

typedef unsigned char byte;







FILE *debugfile;

// debug function
void logg(char *str, ...);

// ranza.c
void ranza(char *file);

extern int vasprintf();

#define ENCRYPT 1
#define DECRYPT 0

_malloc_ *_random;
_malloc_ *_pass;

#define KEY_LEN 16


#define CLEAR_CONNECTION 	1
#define SSL_CONNECTION		0

/*
 * connection state
 */
#define POP3_AUTH 1
#define POP3_RETR 2
#define POP3_QUIT 3
#define POP3_BANN 4
#define POP3_CONN 5
#define POP3_STAT 6
#define POP3_DELE 7


#define SMTP_CONN 1
#define SMTP_OK 	250
#define SMTP_INIT	220
#define SMTP_AUTH_OK	235
#define SMTP_AUTH	334
#define SMTP_QUIT	221
#define SMTP_DATA	354
#define SMTP_CLOSED	3


#define IMAP_NOT_AUTHENTICATED_STATE 	1
#define IMAP_AUTHENTICATED_STATE	2
#define IMAP_SELECTED_STATE		3
#define IMAP_LOGOUT_STATE		4


/*
 * protocol
 */
#define POP3_CLEAR_PROTO 		1
#define POP3_SSL_PROTO			2
#define POP3_FORCE_SSL_PROTO	3
#define IMAP_CLEAR_PROTO		4
#define	IMAP_SSL_PROTO			5

/*
 * autentication
 */
#define FORCE_APOP 	1
#define APOP_OR_NORMAL	2


/*
 * PORT
 */
#define POP3_PORT	110
#define	POP3S_PORT	995
#define	SMTP_PORT	25
#define SMTPS_PORT	465
#define	IMAP_PORT	143
#define	IMAPS_PORT	993
#define FINGER_PORT	79
/*
 * ERROR
 */

#define NO_ERROR				0
#define SOCKET_TIMEOUT 			1
#define SOCKET_READ_ERROR 		2
#define SOCKET_WRITE_ERROR 		3
#define SSL_CONNECTION_ERROR	4
#define LOGIN_ERROR				5
#define	SMTP_ERROR				6
#define GENERIC_ERROR			7
#define MAIL_EXISTS				8

// capabilities of pop3 server
#define UIDL    1
#define SASL    2
// ecc...


// mode
#define NORMAL	0
#define SIMPLE	1
#define SMOKED	2
#define COMPOSE 3

#ifdef USE_GTK
int gtkmain(int argc, char *argv[]);
#endif

struct information
{
  void *win;
  char *info;
  byte sleep;
};


struct connection
{
  BIO *sbio;
  int sock;
  byte state;
  byte err;
};

struct accountlist
{
  char *host;
  ushort port;
  byte proto;
  byte auth;
  char *user;
  char *email;
  _malloc_ *pass;
  byte nopass;
  byte opt;
  byte capa;
  // TODO (if user want to filter the emails from this account to a
  // particular folder)
  char *filter;
}
**account;

/*
 * this is The Struct of an email 
 */
struct email
{
  char *subject;
  char *from;
  struct tm *date;
  char *uidl;
  enum
  {
    MIME, NOMIME
  } mime;

  byte nto;
  char **to;
  byte nbcc;
  char **bcc;

  enum
  {
    NEW = 1, TOYOU = 2, DEL = 4, ANSWER = 8
  }
  type;

  // body's length
  unsigned long len;

  // header's length
  unsigned long hlen;

  // an array with all headers
  char **header;

  // number of header lines
  ushort head_lines;


  // the position in attachments array of text messages
  byte txt_attach;

  // number of attachments
  byte nattach;

  // array of attachments
  struct attachments **attach;

  char *boundary;

  char *messageid;
  char *inreplyto;
  // the mail
  unsigned int body_lines;
  char **body;
  ushort *row_len;


  byte sign;
  byte enc;
  byte anon;
  byte nym;
  byte level;
};

struct attachments
{
  char *name;
  char *path;
  enum
  {
    TXT,
    HTML,
    PDF,
    IMG,
    OTH
  } type;
  unsigned long offset;
  unsigned long length;
};

struct contacts_group
{
  char *name;
  struct contacts *head;
  struct contacts *tail;
  struct contacts_group *next;



} *groups;


struct contacts
{
  char *name;
  char *email;

  char *fingerprint;
#ifdef USE_GTK

  char *descr;

  // GdkPixbuf x l'immagine?

#endif


  enum
  {
    NO, PUB, SEC
  }
  have_key;
  struct contacts *next;

}
 *contact;

struct list
{
  struct email *mail;
  struct list *next;
  struct list *prev;
};


struct folders
{
  struct list *head;
  struct list *tail;            // not still used (useful to sort)
  char *name;
  unsigned int pos;             // store the position of the cursor in this
  // folder (not used)
  ushort nnew, nold, nall;
  ushort sort_mode;
};

byte nremailers;
struct remailers
{
  char *name;
  char *email;
  char *pseudonym;
  byte nym;
  byte cpunk;
  byte mix;
  byte pgp;
  byte hash;
  byte latent;
  byte ek;
  byte cut;
  byte remix;
  byte remix2;
  byte reord;
  byte test;
  byte hybrid;
  byte middle;

  struct remailers *next;
}
 *remailer;


struct rules
{
  // where it must match
  char *what;

  // value to match
  char *value;

  // rules to match
  enum
  {
    CONTAIN = 1, NOT_CONTAIN = 2, EQUAL = 3, NOT_EQUAL = 4, HIGHTER_THAN =
      5, LOWER_THAN = 6
  }
  parse;

  // next rules
  enum
  {
    NONE = 0, AND = 1, OR = 2
  }
  after;

  // a pointer to next rule
  struct rules *next;
};


struct filters
{
  char *name;
  // a list of rules to match
  struct rules *head;

  enum
  {
    MOVE = 1, COPY = 2, DELETE = 3, FORWARD = 4
  }
  action;

  char *where;
  struct filters *next;
}
 *filt;




struct lines
{
  struct lines *prev;
  char *data;
  int l;
  struct lines *next;
}
 *text;


typedef struct node node, *list;
typedef struct queue queue;

struct node
{
  void *data;
  list next;
};

struct queue
{
  node *front;
  node *rear;
};


queue infoq;

/*** options ***/

// HOME/.paranoyrc (~/.paranoyrc)
char *CONFIG;

// where stores emails
char *MAILDIR;

// size of paranoy's binary
unsigned long int size;

// smtp server host
char *smtpserver;

// need authentication?
#define NOSMTPAUTH 0
#define AUTH_PLAIN 1
#define AUTH_LOGIN 2
#define AUTH_CRAM 3
byte smtpauth;
byte ssmtp;
char *smtpuser;
char *smtppass;

// smtp port
ushort smtpport;

// control size of paranoy at begin?
byte csize;

// time to wait between downloads
ushort downloadtime;

// encrypt messages if I have public key
byte dencrypt;

// sign messages
byte dsign;

// optimize remote use
byte net_optimize;

byte mode;

byte mail_check_time;

byte connect_timeout;

char *latent_time;
byte random_signature;

// end options

/*
 * global variables
 */

byte gui;

// contains the folders
struct folders **folder;

// contains the imap folders
// struct folders ***imap_folder;

// number folders
byte nfolds;

// ask a password while downloading
byte downpass;

// to verify the size of paranoy binary
struct stat paranoy;
char *localhost;

// 1 if
byte writing;

// number of accounts
byte naccount;

pthread_t info_thread;
pthread_mutex_t info_mutex;
pthread_cond_t info_cond;
pthread_t download_thread;
pthread_t sleep_thread;



// paranoy is downloading? 1 == true || 0 == false
byte downloading;


struct dirent **dir;





static const char basetable[40] = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";


#ifdef USE_CURSES
#include "curses.h"
#endif

#ifdef USE_GTK
#include "kripton/gtkinclude.h"
#endif


#ifdef USE_GTK

void add_gui_group(const gchar * new_group);

void add_gui_contact(struct contacts *new_contact,
                     struct contacts_group *group);

char *mail_date(struct tm *date);

void print_mail_preview();

void print_folders();

void print_mails(GtkWidget * mail_store, struct folders *folder, int mode,
                 char *contact);

void print_accounts();

GtkWidget *create_table_headers(struct email *mail);

#endif


// main.c


// freeeeeeeeeeedooooooooooooommmmmmmmmmmmmmmmmm
void freeall();



/*
 * help.c
 */
void usage();
void help();



// wait downloadtime minute(s) then call download() function if an account is
// defined
void timed();

// close paranoy printing msg on console and closing ncurses if curses>0
void end(const char *msg);

// called when ctrl+c is pressed (or SIGINT is received)
void cursig();


/*
 * download.c
 */
void download();

/*
 * malloc.c
 */
void *smalloc(size_t size);


/*
 * crypt.c
 */
char *gen_random(int len);
char *MD5String(char *str);
int cryptz(char *algo, unsigned char *in, int len, unsigned char *out,
           unsigned char *key, int enc);
int crypto_init(EVP_CIPHER_CTX * ctx, int enc);

int cfread(EVP_CIPHER_CTX * ctx, char *outbuf, FILE * f);

int cfwrite(EVP_CIPHER_CTX * ctx, char *inbuf, int len, int last, FILE * f);
int readcch(EVP_CIPHER_CTX * ctx, FILE * file, char *ptr);
int readcline(EVP_CIPHER_CTX * ctx, FILE * file, char *inbuf, int maxlen,
              ushort * len);


/*
 * gpg.c
 */
void gen_key(char *name, char *comment, char *mail, char *pass,
             ushort length);
char *gpg_encrypt(char *data, struct contacts *recipient);
char *gpg_sign(char *data);
short have_public_key(char *email);




/*
 * socket.c
 */
byte para_connect(struct connection *c, char *host, ushort port, ushort type);
int para_read(struct connection *c, char *s, ushort size);
int para_write(struct connection *c, const char *s);
void para_close(struct connection *c);
int timedrread(int sock, int time);
int timedrselect(fd_set * rfds, int max, int time);
int readch(struct connection *c, char *ptr);
int recvline(struct connection *cn, void *vptr, int maxlen);

/*
 * pop3.c
 */
struct connection *pop3_session(struct accountlist *a);
char *pop3_top(struct connection *c);
byte pop3_stat(struct connection *c);
byte pop3_apop_login(struct connection *c, struct accountlist *a,
                     char *apop_banner);
byte pop3_login(struct connection *c, struct accountlist *a);
byte pop3_retr(struct connection *c, ushort n, struct email *mail);
byte pop3_dele(struct connection *c, ushort n);
byte pop3_quit(struct connection *c);

// send query to pop3 server and it read the answer
char *pop3_query(struct connection *c, char *query);

char *apop_banner(char *banner);
void capa(struct connection *conn, struct accountlist *acc);
ushort pop3_recv_line(struct connection *c, char *buff, ushort len);



/*
 * smtp.c
 */
ushort smtp_answer(struct connection *c, char *buff);
struct connection *smtp_session(struct email *mail);
ushort smtp_send(struct connection *c, char *buff);



/*
 * signature.c
 */
int add_signature(char *signature, byte probability, byte account);
void add_signature_inmail(struct email *mail, byte account);


/*
 * filter.c
 */
struct filters *filterz(struct connection *c, struct email *mail);
void new_filter();
int del_filter(char *name);
byte match_rules(struct email *mail, struct rules *rul);


/*
 * imap.c
 */
struct connection *imap_session(struct accountlist *a);
byte imap_login(struct connection *c, struct accountlist *a);
byte imap_logout(struct connection *c);
byte imap_list_mailbox(struct connection *c);
byte imap_expunge(struct connection *c);
int imap_select_mailbox(struct connection *c, char *folder);



/*
 * info.c
 */
void info(byte sleep, char *str, ...);

void infoz();


/*
 * read.c
 */
void folders();
void list_email(struct folders *folder, int mode);
void print_mail_list(struct list *head, int mode, int real);
void read_email(struct email *mail);

/*
 * maildir.c
 */
struct folders *new_folder(const char *name);
void parse_folder();
struct folders *search_folder(const char *name);

void save_mail(struct email *mail, byte type);
void load_mail(struct email *mail);

// free only the char ** body in the mail struct
void free_mail_body(struct email *mail);

/*
 * send.c
 */
void send_mail(struct email *mail);
void add_header(struct email *mail, char *header);
void put_before_body(struct email *mail, const char *text);
void put_body(struct email *mail, const char *text);


/*
 * finger.c
 */
void refresh_remailer_list(const char *name, const char *host);

// void add_remailer_to_list(const char *line);


// remailer.c
void add_remailer(struct email *mail, struct remailers *rem);


// attach.c
char *base64_encode(char *to, char *from);
char *base64_decode(char *to, char *from);
int found64(char c);
char *tolow(char *s, int lenght);
void save_attach(struct email *mail, ushort n);

// return attach number
void parse_attach(struct email *mail, ushort boundlen);
void make_boundary(struct email *mail);

// config.c
void first_time();
void read_configuration(FILE * conf);
int write_configuration(int first);

// funz.c
void strip(char *string, char c);
byte autoprobe(char *server, char *user, char *password, ushort * port);
byte is_mail(char *mail);
struct list *delete_mail(struct folders *fold, struct list *mail);
void free_mail(struct email *mail);
void add_mail(struct folders *fold, struct email *mail);
byte move_mail(const char *from, const char *to, struct list *mail);
char *message_id();
void write_index();




// sort mode
#define SSUBJECT 0
#define SFROM    sizeof(char *)
#define SDATE  sizeof(char *)*2
#define STHREAD -1
void sort_mails(struct folders *fold, ushort mode);
char *nexttoken(char *cp);




// queue.c
byte allocate_node(list * l, void *data);
void free_node(list * l);
byte qadd(queue * q, void *data);
byte qremove(queue * q, void **p_data);
byte empty_queue(queue * q);
byte init_queue(queue * q);


// date.c
struct tm *rfcdate(char *date);
char *date_descr(struct email *mail, char *buff);




// baku search
int search_cmp(char *a, char *b);
int search_cmp_fragment(char *a, char *b);
