/*
 * Copyright (C) 2003  
 * paranoy project - paranox.sf.net - paranoy@autistici.org
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

#include "include.h"

void
info(byte sleep, char *str, ...)
{
  struct information *inf;
  va_list ap;
  inf = (struct information *) smalloc(sizeof(struct information));
  // logg("info - dopo smalloc\n");
  va_start(ap, str);

  // logg("info - dopo va_start\n");
  inf->info[vasprintf(&inf->info, str, ap)] = '\0';
  inf->sleep = sleep;
  // inf->win=win;
  va_end(ap);

  pthread_mutex_lock(&info_mutex);

  qadd(&infoq, (void *) inf);
  pthread_mutex_unlock(&info_mutex);
  pthread_cond_signal(&info_cond);
}

void
infoz()
{

  struct information *s = NULL;

  while (1)
  {
    pthread_mutex_lock(&info_mutex);
    if (empty_queue(&infoq))
      pthread_cond_wait(&info_cond, &info_mutex);
    qremove(&infoq, (void **) &s);
    pthread_mutex_unlock(&info_mutex);
#ifdef USE_CURSES
    if (gui == NCURSES)
    {
      mvwprintw(winfo, 0, 2, " \n");
      wattrset(winfo, COLOR_PAIR(COLOR_INFO));
      if (s && s->info)
        mvwprintw(winfo, 0, 2, s->info);
      wrefresh(winfo);

    }
#endif
#ifdef USE_GTK
    if (gui == GTK)
    {
      gtk_statusbar_pop((GtkStatusbar *) main_statusbar, 0);
      gtk_statusbar_push((GtkStatusbar *) main_statusbar, 0, s->info);
    }
#endif
    if (s->sleep)
      sleep(s->sleep);
    free(s->info);
    free(s);
  }
}
