
#include "../include.h"

/*
 * 0 name se c'e' 1 email 2 nome email con " 
 */
char *
format_from(char *str, int mode)
{
  char *buff, *p;

  // buff = (char *)malloc(sizeof(char)*strlen(str));

  buff = strdup(str);

  while ((p = strchr(buff, '<')))
  {
    p[0] = mode == 2 ? '\"' : '\0';
    p += 1;
    memset(strchr(p, '>'), mode == 2 ? '\"' : 0, 1);
  }

  if (p && (mode == 1))
    return p;
  else
    return buff;

}

void
on_new_group_activate(GtkWidget * widget, gpointer user_data)
{
  gtk_widget_show_all(newgroup_vbox);
  gtk_widget_grab_focus(newgroup_entry);


  /*
   * g_signal_connect((gpointer) newgroup_entry, "focus_out_event",
   * G_CALLBACK(on_focus),newgroup_vbox);
   */

}

void
on_newgroup_done(GtkWidget * widget, gpointer user_data)
{
  const gchar *p = gtk_entry_get_text((GtkEntry *) widget);

  if (*p)
    add_gui_group(p);

  gtk_widget_hide_all(newgroup_vbox);
}



struct contacts *
catch_contacts_selection(GtkListStore * model, GtkTreeView * tree)
{
  GtkTreeSelection *sel;
  GtkTreeIter iter;
  struct contacts *contact;

  sel = gtk_tree_view_get_selection(GTK_TREE_VIEW(tree));
  if (gtk_tree_selection_get_selected(GTK_TREE_SELECTION(sel), NULL, &iter))
  {
    gtk_tree_model_get(GTK_TREE_MODEL(model), &iter, CONTACT, &contact, -1);
    return contact;
  }
  return NULL;
}


struct contacts_group *
catch_group_selection(GtkListStore * model, GtkTreeView * tree)
{
  GtkTreeSelection *sel;
  GtkTreeIter iter;
  struct contacts_group *group;

  sel = gtk_tree_view_get_selection(GTK_TREE_VIEW(tree));
  if (gtk_tree_selection_get_selected(GTK_TREE_SELECTION(sel), NULL, &iter))
  {
    gtk_tree_model_get(GTK_TREE_MODEL(model), &iter, GROUP, &group, -1);
    return group;
  }
  return NULL;
}



struct email *
catch_mail_selection(GtkListStore * model, GtkTreeView * tree)
{
  GtkTreeSelection *sel;
  GtkTreeIter iter;
  struct email *mail;

  sel = gtk_tree_view_get_selection(GTK_TREE_VIEW(tree));
  if (gtk_tree_selection_get_selected(GTK_TREE_SELECTION(sel), NULL, &iter))
  {
    gtk_tree_model_get(GTK_TREE_MODEL(model), &iter, MAIL, &mail, -1);
    return mail;
  }
  return NULL;
}

struct folders *
catch_fold_selection(GtkListStore * model, GtkTreeView * tree)
{
  GtkTreeSelection *sel;
  GtkTreeIter iter;
  struct folders *folder;

  sel = gtk_tree_view_get_selection(GTK_TREE_VIEW(tree));
  if (gtk_tree_selection_get_selected(GTK_TREE_SELECTION(sel), NULL, &iter))
  {
    gtk_tree_model_get(GTK_TREE_MODEL(model), &iter, FOLD, &folder, -1);
    return folder;
  }
  return NULL;
}


char *
mail_date(struct tm *date)
{
  char *buff;
  buff = (char *) malloc(sizeof(char) * 50);
  switch (date->tm_mon)
  {
    case 0:
      sprintf(buff, "January");
    case 1:
      sprintf(buff, "February");
    case 2:
      sprintf(buff, "March");
    case 3:
      sprintf(buff, "Abril");
    case 4:
      sprintf(buff, "May");
    case 5:
      sprintf(buff, "June");
    case 6:
      sprintf(buff, "July");
    case 7:
      sprintf(buff, "August");
    case 8:
      sprintf(buff, "September");
    case 9:
      sprintf(buff, "October");
    case 10:
      sprintf(buff, "November");
    case 11:
      sprintf(buff, "December");
  }

  sprintf(buff + strlen(buff), "  %d  %d   h: %d:%d", date->tm_mday,
          date->tm_year, date->tm_hour, date->tm_min);
  return buff;
}

void
print_mail_preview()
{
  GtkTextIter selmail_iter, end_iter;
  struct email *mail;
  char buff[BUFFER_REAL];
  int i;
  GtkTreeSelection *sel;
  GtkTreeIter iter;

  sel = gtk_tree_view_get_selection(GTK_TREE_VIEW(mail_tree));


  if (gtk_tree_selection_get_selected(GTK_TREE_SELECTION(sel), NULL, &iter))
  {
    gtk_tree_model_get(GTK_TREE_MODEL(mail_store), &iter, MAIL, &mail, -1);
    current_mail = mail;

    // open correct file and fill mail structure with its content
    load_mail(mail);
    i = 0;
    gtk_text_buffer_get_start_iter(GTK_TEXT_BUFFER(selmail_buffer),
                                   &selmail_iter);
    gtk_text_buffer_get_end_iter(GTK_TEXT_BUFFER(selmail_buffer), &end_iter);
    gtk_text_buffer_delete(GTK_TEXT_BUFFER(selmail_buffer), &selmail_iter,
                           &end_iter);

    gtk_text_buffer_get_start_iter(GTK_TEXT_BUFFER(selmail_buffer),
                                   &selmail_iter);
    if (!mail->nattach)
      while (i < mail->body_lines)
      {
        sprintf(buff, "%s\n", mail->body[i]);
        gtk_text_buffer_insert(GTK_TEXT_BUFFER(selmail_buffer), &selmail_iter,
                               buff, strlen(buff));
        gtk_text_buffer_get_iter_at_line(GTK_TEXT_BUFFER(selmail_buffer),
                                         &selmail_iter, ++i);
    } else
      while (i < mail->attach[mail->txt_attach]->length)
      {
//				while(mail->body[mail->attach[mail->txt_attach]->offset+i]!="")
	//				i++;
        // respect
				if (mail->row_len[mail->attach[mail->txt_attach]->offset+i])
				{
				  snprintf(buff, BUFFER_LEN,"%s\n",mail->body[mail->attach[mail->txt_attach]->offset + i]);
        	gtk_text_buffer_insert(GTK_TEXT_BUFFER(selmail_buffer), &selmail_iter,
                               buff, strlen(buff));
        	gtk_text_buffer_get_iter_at_line(GTK_TEXT_BUFFER(selmail_buffer),
                                         &selmail_iter, ++i);
				}
				else
					i++;
      }

    if (head_table)
      gtk_widget_destroy(head_table);


    head_table = create_table_headers(mail);

    gtk_container_add((GtkContainer *) preview_viewport, head_table);

    gtk_widget_show_all(preview_viewport);

  }
}

GtkWidget *
create_table_headers(struct email *mail)
{
  GtkWidget *head_table;
  char buff[BUFFER_REAL];

  head_table = gtk_table_new(4, 2, FALSE);
  gtk_container_set_border_width(GTK_CONTAINER(head_table), 5);

  real_label = gtk_label_new(_("<b> Subject :: </b>"));
  gtk_widget_show(real_label);
  gtk_table_attach(GTK_TABLE(head_table), real_label, 0, 1, 0, 1,
                   (GtkAttachOptions) (GTK_FILL),
                   (GtkAttachOptions) (0), 0, 2);
  gtk_label_set_use_markup(GTK_LABEL(real_label), TRUE);
  gtk_label_set_justify(GTK_LABEL(real_label), GTK_JUSTIFY_RIGHT);
  gtk_misc_set_alignment(GTK_MISC(real_label), 0, 0.5);



  real_label = gtk_label_new(_("<b>     From :: </b>"));
  gtk_widget_show(real_label);
  gtk_table_attach(GTK_TABLE(head_table), real_label, 0, 1, 1, 2,
                   (GtkAttachOptions) (GTK_FILL),
                   (GtkAttachOptions) (0), 0, 3);
  gtk_label_set_use_markup(GTK_LABEL(real_label), TRUE);
  gtk_misc_set_alignment(GTK_MISC(real_label), 0, 0.5);

  real_label = gtk_label_new(_("<b>     Date :: </b>"));
  gtk_widget_show(real_label);
  gtk_table_attach(GTK_TABLE(head_table), real_label, 0, 1, 2, 3,
                   (GtkAttachOptions) (GTK_FILL),
                   (GtkAttachOptions) (0), 0, 2);
  gtk_label_set_use_markup(GTK_LABEL(real_label), TRUE);
  gtk_misc_set_alignment(GTK_MISC(real_label), 0, 0.5);

  real_label = gtk_label_new(_("<b>         To :: </b>"));
  gtk_widget_show(real_label);
  gtk_table_attach(GTK_TABLE(head_table), real_label, 0, 1, 3, 4,
                   (GtkAttachOptions) (GTK_FILL),
                   (GtkAttachOptions) (0), 0, 4);
  gtk_label_set_use_markup(GTK_LABEL(real_label), TRUE);
  gtk_misc_set_alignment(GTK_MISC(real_label), 0, 0.5);


  real_label = gtk_label_new(_(mail->subject));
  gtk_widget_show(real_label);
  gtk_table_attach(GTK_TABLE(head_table), real_label, 1, 2, 0, 1,
                   (GtkAttachOptions) (GTK_FILL),
                   (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_use_markup(GTK_LABEL(real_label), TRUE);
  gtk_misc_set_alignment(GTK_MISC(real_label), 0, 0.5);

  // real_label = gtk_label_new(_(mail->from));



  real_label = create_link(mail->from, event_press_on_mail_address, mail);
  gtk_widget_show(real_label);
  gtk_table_attach(GTK_TABLE(head_table), real_label, 1, 2, 1, 2,
                   (GtkAttachOptions) (GTK_FILL),
                   (GtkAttachOptions) (0), 0, 0);
  gtk_signal_connect((gpointer) real_label, "button_press_event",
                     G_CALLBACK(event_press_on_mail_address),
                     (gpointer) mail);



  real_label = gtk_label_new(_(mail_date(mail->date)));
  gtk_widget_show(real_label);
  gtk_table_attach(GTK_TABLE(head_table), real_label, 1, 2, 2, 3,
                   (GtkAttachOptions) (GTK_FILL),
                   (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_use_markup(GTK_LABEL(real_label), TRUE);
  gtk_misc_set_alignment(GTK_MISC(real_label), 0, 0.5);



  real_label = create_link(mail->to[0], NULL, mail);
  gtk_widget_show(real_label);
  gtk_table_attach(GTK_TABLE(head_table), real_label, 1, 2, 3, 4,
                   (GtkAttachOptions) (GTK_FILL),
                   (GtkAttachOptions) (0), 0, 0);



  return head_table;
}

void
print_accounts()
{
  int i = 0;
  GtkTreeIter iter;

  gtk_list_store_clear(GTK_LIST_STORE(account_store));

  while (i < naccount)
  {
    gtk_list_store_append(GTK_LIST_STORE(account_store), &iter);
    gtk_list_store_set(account_store, &iter, ACC_NAME, account[i]->user,
                       ACC_EMAIL, account[i]->email, -1);
    i++;
  }

}

void
print_contacts()
{
  GtkTreeIter iter;
  struct contacts *p;

  p = current_group ? current_group->head : NULL;

  gtk_list_store_clear(GTK_LIST_STORE(contacts_list));

  while (p)
  {
    gtk_list_store_append(GTK_LIST_STORE(contacts_list), &iter);
    gtk_list_store_set((GtkListStore *) contacts_list, &iter, CON_NAME,
                       p->name, CON_EMAIL, p->email, CON_KEY,
                       p->have_key ? "*" : "", CONTACT, p, -1);
    p = p->next;
  }

}

void
print_contacts_group()
{
  struct contacts_group *p;
  GtkTreeIter iter;

  p = groups;

  gtk_list_store_clear(GTK_LIST_STORE(groups_list));
  while (p)
  {
    gtk_list_store_append(GTK_LIST_STORE(groups_list), &iter);
    gtk_list_store_set(GTK_LIST_STORE(groups_list), &iter, GROUP_NAME,
                       p->name, GROUP, p, -1);
    p = p->next;
  }

}

void
on_moveto_activate(GtkMenuItem * menuitem, char *folder)
{
  if (current_fold && current_mail)
  {
    printf("attivo il move su %s\n", folder);
    struct list *p;

    p = current_fold->head;
    while (p->mail != current_mail)
      p = p->next;

    move_mail(current_fold->name, folder, p);
    print_mails(mail_store, current_fold,
                gtk_combo_box_get_active((GtkComboBox *) view_combobox),
                NULL);
    print_folders();

  }
}


void
on_new_mail_activate(GtkMenuItem * menuitem, gpointer user_data)
{
  compose_window = create_compose_window(0, 0);
  gtk_widget_show(compose_window);
}


void
on_from_file_activate(GtkMenuItem * menuitem, gpointer user_data)
{
  mail_filechooserdialog = create_mail_filechooserdialog();
  gtk_widget_show(mail_filechooserdialog);

}


void
on_posponed_mail_activate(GtkMenuItem * menuitem, gpointer user_data)
{

}


void
on_from_contacts_menu_activate(GtkMenuItem * menuitem, gpointer user_data)
{

}


void
on_prova_figlio1_activate(GtkMenuItem * menuitem, gpointer user_data)
{

}


void
on_get_mail_activate(GtkMenuItem * menuitem, gpointer user_data)
{
  if (naccount)
    create_download_window();
  else
    info(2, " -[ No account ]-");
}

void
on_get_mail_enter(GtkButton * button, gpointer user_data)
{
  // printf("sono dentro\n");
}

void
on_get_mail_for_activate(GtkMenuItem * menuitem, gpointer user_data)
{

}


void
on_prova_for1_activate(GtkMenuItem * menuitem, gpointer user_data)
{

}


void
on_sent_postponed_mail_activate(GtkMenuItem * menuitem, gpointer user_data)
{

}


void
on_accounts_activate(GtkMenuItem * menuitem, gpointer user_data)
{

  settings_window = create_settings_window(ACCOUNT_MENU);
  gtk_widget_show(settings_window);



}

void
event_press_on_mail_address(GtkWidget * menuitem, GdkEventButton * event,
                            struct email *mail)
{
  GtkWidget *mailadd_menu;

  // GdkEventButton *event = (GdkEventButton *) user_data;
  printf("qua e' %s.\n", mail->from);
  mailadd_menu = create_mailaddress_menu(mail);
  gtk_menu_popup(GTK_MENU(mailadd_menu), NULL, NULL, NULL, NULL,
                 0, gtk_get_current_event_time());
}


int
event_press_on_mail_list(GtkWidget * menuitem, GdkEvent * user_data)
{
  GdkEventButton *event = (GdkEventButton *) user_data;

  if ((event->type == GDK_BUTTON_PRESS) && (event->button == 3))
  {
    gtk_menu_popup(GTK_MENU(maillist_menu), NULL, NULL, NULL, NULL,
                   event->button, event->time);
    return TRUE;
  }
  return FALSE;
}


int
event_press_on_fold_list(GtkWidget * menuitem, GdkEvent * user_data)
{
  GdkEventButton *event = (GdkEventButton *) user_data;

  if ((event->type == GDK_BUTTON_PRESS) && (event->button == 3))
  {
    gtk_menu_popup(GTK_MENU(foldlist_menu), NULL, NULL, NULL, NULL,
                   event->button, event->time);
    return TRUE;
  }
  return FALSE;
}


void
on_contacts_activate(GtkMenuItem * menuitem, gpointer user_data)
{
  settings_window = create_settings_window(CONTACTS_MENU);
  gtk_widget_show(settings_window);

}


void
on_general_options_activate(GtkMenuItem * menuitem, gpointer user_data)
{
  settings_window = create_settings_window(GOPTION_MENU);
  gtk_widget_show(settings_window);

}


void
on_filters_activate(GtkMenuItem * menuitem, gpointer user_data)
{
  settings_window = create_settings_window(FILTERS_MENU);
  gtk_widget_show(settings_window);

}


void
on_pgp_item_activate(GtkMenuItem * menuitem, gpointer user_data)
{
  settings_window = create_settings_window(PGP_MENU);
  gtk_widget_show(settings_window);

}


void
on_security_activate(GtkMenuItem * menuitem, gpointer user_data)
{
  settings_window = create_settings_window(SECUR_MENU);
  gtk_widget_show(settings_window);

}


void
on_anonimity_activate(GtkMenuItem * menuitem, gpointer user_data)
{
  settings_window = create_settings_window(ANON_MENU);
  gtk_widget_show(settings_window);

}


void
on_help_paranoy1_activate(GtkMenuItem * menuitem, gpointer user_data)
{

}


void
on_help_pgp_activate(GtkMenuItem * menuitem, gpointer user_data)
{

}

void
on_parapass_button_clicked(GtkButton * button, gpointer user_data)
{
  parapass_window = create_parapass_window();
  gtk_widget_show(parapass_window);
}



void
on_about_email_activate(GtkMenuItem * menuitem, gpointer user_data)
{

}



gboolean
on_settings_window_destroy_event(GtkWidget * widget,
                                 GdkEvent * event, gpointer user_data)
{

  return FALSE;
}


void
on_mainquit_button_clicked(GtkButton * button, gpointer user_data)
{
  write_index();
  gtk_main_quit();

}


void
on_addsign_button_clicked(GtkButton * button, gpointer user_data)
{

}



void
on_modsign_button_clicked(GtkButton * button, gpointer user_data)
{

}


void
on_delsign_button_clicked(GtkButton * button, gpointer user_data)
{

}


void
on_settingapply_button_clicked(GtkButton * button, gpointer user_data)
{
  gchar *buff;

  buff = (gchar *) gtk_entry_get_text(GTK_ENTRY(smtpserver_entry));

  if (smtpserver != NULL)
    free(smtpserver);

  if (strlen(buff) > 2)
  {
    smtpserver = (char *) malloc(strlen(buff));
    strcpy(smtpserver, buff);
  }
  write_configuration(0);


}


void
on_cancel_button_clicked(GtkButton * button, GtkWidget * window)
{
  gtk_widget_destroy(window);

}

void
on_settingcancel_button_clicked(GtkButton * button, gpointer user_data)
{
  gtk_widget_destroy(settings_window);

}


void
on_settingok_button_clicked(GtkButton * button, gpointer user_data)
{
  gchar *buff;

  buff = (gchar *) gtk_entry_get_text(GTK_ENTRY(smtpserver_entry));

  if (smtpserver != NULL)
    free(smtpserver);

  if (strlen(buff) > 2)
  {
    smtpserver = (char *) malloc(strlen(buff));
    strcpy(smtpserver, buff);
  }

  write_configuration(0);

  gtk_widget_destroy(settings_window);

}


void
on_account_button_clicked(GtkButton * button, gpointer user_data)
{
  if (naccount == 0)
    account = (struct accountlist **) malloc(sizeof(struct accountlist *));
  else
    account =
      (struct accountlist **) realloc(account,
                                      sizeof(struct accountlist *) *
                                      naccount + 1);

  account[naccount] =
    (struct accountlist *) malloc(sizeof(struct accountlist));
  naccount++;

  account[naccount - 1]->user =
    (char *) malloc(sizeof(char) *
                    strlen(gtk_entry_get_text(GTK_ENTRY(username_entry))));
  strcpy(account[naccount - 1]->user,
         gtk_entry_get_text(GTK_ENTRY(username_entry)));

  if (gtk_entry_get_text(GTK_ENTRY(password_entry)) == NULL)
  {
    account[naccount - 1]->nopass = 1;
    account[naccount - 1]->pass = NULL;
  } else
  {
    account[naccount - 1]->nopass = 0;
    account[naccount - 1]->pass =
      _malloc(strlen(gtk_entry_get_text(GTK_ENTRY(password_entry))) + 1);
    _mempcpy(account[naccount - 1]->pass,
             gtk_entry_get_text(GTK_ENTRY(password_entry)),
             strlen(gtk_entry_get_text(GTK_ENTRY(password_entry))));
  }

  account[naccount - 1]->host =
    (char *)
    malloc(strlen(gtk_entry_get_text(GTK_ENTRY(addacc_pop_entry)) + 1));
  strcpy(account[naccount - 1]->host,
         gtk_entry_get_text(GTK_ENTRY(addacc_pop_entry)));
  account[naccount - 1]->email =
    (char *) malloc(strlen(gtk_entry_get_text(GTK_ENTRY(addacc_email_entry)))
                    + 1);
  strcpy(account[naccount - 1]->email,
         gtk_entry_get_text(GTK_ENTRY(addacc_email_entry)));

  account[naccount - 1]->port =
    atoi(gtk_entry_get_text(GTK_ENTRY(addacc_port_entry)));
  // account[naccount - 1]->proto =
  // atoi(gtk_entry_get_text(GTK_ENTRY(GTK_BIN(popproto_comboboxentry))));
  account[naccount - 1]->opt = 0;



  // aggiornare la lista di account
  // gtk_list_store_clear(GTK_LIST_STORE(account_store));
  print_accounts();

  // scrive la configurazione
  write_configuration(0);

  info(2, "-{ Account added }-");

  gtk_widget_destroy(add_accounts_window);


}


void
on_accountcancel_button_clicked(GtkButton * button, gpointer user_data)
{
  gtk_widget_destroy(accounts_window);

}


void
on_accountok_button_clicked(GtkButton * button, gpointer user_data)
{
  gtk_widget_destroy(accounts_window);
}



void
on_plugin_select(GtkWidget * widget, gpointer * combo)
{
  int i, c, t = 0;
  char buff[BUFFER_REAL];
  struct dirent **plugins;
  void *plugin;
  GtkWidget *(*p) () = NULL;
  GtkWidget *a;

  c = gtk_combo_box_get_active((GtkComboBox *) combo);
  if (c < 0)
  {
    info(2, " -= No plugin selected =-");
    return;
  }
  snprintf(buff, BUFFER_LEN, "%s/plugins/", MAILDIR);
  i = scandir(buff, &plugins, NULL, NULL);
  // aggiunge alla combo box tutti i plugin che trova
  if (i >= 0)
  {
    while (i--)
    {
      if (!strstr(plugins[i]->d_name, ".so"))
      {
        free(plugins[i]);
        continue;
      }

      if (t == c)
      {
        snprintf(buff, BUFFER_LEN, "%s/plugins/%s", MAILDIR,
                 plugins[i]->d_name);
        plugin = dlopen(buff, RTLD_LAZY);
        p = (GtkWidget * (*)())dlsym(plugin, "main_func");

      }
      t++;
      snprintf(buff, strlen(plugins[i]->d_name) - 2, "%s",
               plugins[i]->d_name);
      gtk_combo_box_append_text((GtkComboBox *) combo, _(buff));
      free(plugins[i]);
    }
    free(plugins);
  }

  gtk_widget_destroy(plugbox);
  plugbox = gtk_vbox_new(FALSE, 0);
  gtk_widget_show(plugbox);
  gtk_container_add((GtkContainer *) more_expander, plugbox);

  a = gtk_button_new_with_mnemonic(_("Back"));
  gtk_widget_show(a);
  gtk_container_add((GtkContainer *) plugbox, a);
  g_signal_connect((gpointer) a, "clicked", G_CALLBACK(plugin_main), NULL);


  a = p();
  gtk_widget_show(a);
  gtk_container_add((GtkContainer *) plugbox, a);

}


void
plugin_main()
{

  GtkWidget *combo, *button;
  char buff[BUFFER_REAL];
  struct dirent **plugins;
  int i;

  if (plugbox)
    gtk_widget_destroy(plugbox);

  plugbox = gtk_vbox_new(FALSE, 0);
  gtk_widget_show(plugbox);
  gtk_container_add((GtkContainer *) more_expander, plugbox);


  combo = gtk_combo_box_new_text();
  gtk_widget_show(combo);
  button = gtk_button_new_with_mnemonic(_("Load"));
  gtk_widget_show(button);
  gtk_container_add((GtkContainer *) plugbox, combo);
  gtk_container_add((GtkContainer *) plugbox, button);

  snprintf(buff, BUFFER_LEN, "%s/plugins/", MAILDIR);
  i = scandir(buff, &plugins, NULL, NULL);
  printf("dopo la scandir dei plugin ne ho trovati%d \n", i);
  fflush(stdout);
  // aggiunge alla combo box tutti i plugin che trova
  gtk_combo_box_append_text((GtkComboBox *) combo, "Contacts");

  if (i >= 0)
  {
    while (i--)
    {
      if (!strstr(plugins[i]->d_name, ".so"))
        continue;
      snprintf(buff, strlen(plugins[i]->d_name) - 2, "%s",
               plugins[i]->d_name);
      gtk_combo_box_append_text((GtkComboBox *) combo, _(buff));
      free(plugins[i]);
    }
    free(plugins);
  }

  g_signal_connect((gpointer) button, "clicked", G_CALLBACK(on_plugin_select),
                   combo);


}

void
on_addfilterok_button_clicked(GtkButton * button, gpointer user_data)
{
  
}
void
on_contactok_button_clicked(GtkButton * button, gpointer user_data)
{
  if ((!gtk_entry_get_text((GtkEntry *) contactname_entry))
      && (!gtk_entry_get_text((GtkEntry *) contactmail_entry)))
  {
    info(2, "-[ You have to name and email ok your contatc ]-");
  } else
  {
    struct contacts *temp =
      (struct contacts *) malloc(sizeof(struct contacts));
    temp->name = g_strdup(gtk_entry_get_text((GtkEntry *) contactname_entry));
    temp->email =
      g_strdup(gtk_entry_get_text((GtkEntry *) contactmail_entry));
    add_gui_contact(temp, current_group);
    gtk_widget_destroy(contact_window);

    print_contacts();
  }
}



void
on_contactadd_button_clicked(GtkButton * button, gpointer user_data)
{
  if (current_group)
  {
    contact_window = create_contact_window(0);
    gtk_widget_show(contact_window);
  }
}


void
on_contactmod_button_clicked(GtkButton * button, gpointer user_data)
{
  if (current_contact)
  {
    contact_window = create_contact_window(1);
    gtk_widget_show(contact_window);
  }
}


void
on_contactdel_button_clicked(GtkButton * button, gpointer user_data)
{

}

void
on_addrole_button_clicked(GtkButton * button, gpointer user_data)
{
}

void
on_delrole_button_clicked(GtkButton * button, gpointer user_data)
{
}

void
on_filteradd_button_clicked(GtkButton * button, gpointer user_data)
{
  GtkWidget *addfil_win;
  
  addfil_win = create_addfilter_window();
  gtk_widget_show(addfil_win);

}


void
on_filtermod_button_clicked(GtkButton * button, gpointer user_data)
{

}


void
on_filterddel_button_clicked(GtkButton * button, gpointer user_data)
{

}


gboolean
on_parapass_window_destroy_event(GtkWidget * widget,
                                 GdkEvent * event, gpointer user_data)
{

  return FALSE;
}


void
on_passcancel_button_clicked(GtkButton * button, gpointer user_data)
{
  gtk_widget_destroy(parapass_window);

}


void
on_paraok_button_clicked(GtkButton * button, gpointer user_data)
{
  gtk_widget_destroy(parapass_window);

}


void
on_composeppone_button_clicked(GtkButton * button, gpointer user_data)
{

}

void
on_okalert_button_clicked(GtkButton * button, GtkWidget * dialog)
{
  gtk_widget_destroy(dialog);
}

void
on_compose_activate(GtkMenuItem * menuitem, struct email *mail)
{
  GtkWidget *composewin;

  composewin = create_compose_window(mail, 4);
  gtk_widget_show(composewin);
}

void
on_composesend_button_clicked(GtkButton * button, gpointer user_data)
{
  gint i;
  gchar *buff;
  GtkTextIter start, end;
  struct email *mail;

  if ((!smtpserver) || (!strcmp(smtpserver, "")))
  {
    GtkWidget *alert;

    alert =
      create_alert_dialog
      ("You have to insert an SMTP server in General options\nto send your mails");
    gtk_widget_show(alert);
    // info(3,"-[ You have to insert an SMTP server to send your mails ]-");
    return;
  }

  mail = (struct email *) malloc(sizeof(struct email));
  mail->subject = NULL;
  mail->body = NULL;
  mail->nto = 0;
  mail->nattach = 0;
  mail->boundary = NULL;
  mail->nbcc = 0;
  mail->to = (char **) malloc(50 * sizeof(char *));
  mail->to[0] = NULL;
  mail->enc = FALSE;
  mail->sign = FALSE;
  mail->anon = FALSE;
  mail->bcc = (char **) malloc(50 * sizeof(char *));
  mail->nattach = 0;
  mail->attach = NULL;
  mail->inreplyto = NULL;


  // prendo il to
  buff = (gchar *) gtk_entry_get_text(GTK_ENTRY(to_entry));
  mail->to[mail->nto] =
    (char *) malloc(sizeof(char) * (strlen((char *) buff) + 1));
  strcpy(mail->to[mail->nto], buff);
  mail->nto++;
  buff = NULL;
  // prendo il bcc
  buff = (gchar *) gtk_entry_get_text(GTK_ENTRY(bcc_entry));
  mail->bcc[mail->nbcc] =
    (char *) malloc(sizeof(char) * (strlen((char *) buff) + 1));
  strcpy(mail->bcc[mail->nbcc], buff);
  mail->nbcc++;
  buff = NULL;
  // prendo il subject
  buff = (gchar *) gtk_entry_get_text(GTK_ENTRY(subject_entry));
  mail->subject = (char *) malloc(sizeof(char) * (strlen((char *) buff) + 1));
  strcpy(mail->subject, buff);
  buff = NULL;

  // prendo il body
  body_buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(body_textview));
  i = gtk_text_buffer_get_line_count(GTK_TEXT_BUFFER(body_buffer));

  mail->body = (char **) malloc(sizeof(char *) * (i + 1));

  while (i > 0)
  {
    gtk_text_buffer_get_iter_at_line(GTK_TEXT_BUFFER(body_buffer), &start,
                                     i - 1);
    gtk_text_buffer_get_iter_at_line(GTK_TEXT_BUFFER(body_buffer), &end,
                                     i - 1);
    gtk_text_iter_forward_chars(&end,
                                gtk_text_iter_get_chars_in_line(&start));
    mail->body[i - 1] =
      (char *) malloc(sizeof(char *) *
                      (gtk_text_iter_get_chars_in_line(&start) + 1));
    strcpy(mail->body[i - 1],
           gtk_text_buffer_get_text(GTK_TEXT_BUFFER(body_buffer), &start,
                                    &end, FALSE));
    i--;
  }

  mail->len = gtk_text_buffer_get_char_count(GTK_TEXT_BUFFER(body_buffer));
  mail->body_lines =
    gtk_text_buffer_get_line_count(GTK_TEXT_BUFFER(body_buffer));

  /*
   * for
   * (i=0;i<gtk_text_buffer_get_line_count(GTK_TEXT_BUFFER(body_buffer));i++)
   * { printf("%s",mail->body[i]); } 
   */



  // check anon
  // mail->anon =
  // gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(anon_checkbutton)) ? TRUE
  // : FALSE;

  // check sign quando funzionera'

  /*
   * mail->sign =
   * gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(sign_checkbutton))?TRUE:FALSE;
   * 
   * //check encrypt
   * 
   * mail->enc =
   * gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(encrypt_checkbutton))?TRUE:FALSE; 
   */
  // prendo il from
  i = gtk_combo_box_get_active(GTK_COMBO_BOX(from_comboboxentry));

  // se e' un account
  if (i < naccount)
  {
    mail->from =
      (char *) malloc(sizeof(char) * (strlen(account[i]->email) + 1));
    strcpy(mail->from, account[i]->email);
  }
  // se e' manual
  else
  {
    buff = (gchar *) gtk_entry_get_text(GTK_ENTRY(manualfrom_entry));
    mail->from = (char *) malloc(sizeof(char) * (strlen(buff) + 1));
    strcpy(mail->from, buff);
    buff = NULL;
  }

  printf("From: %s.\n", mail->from);
  fflush(stdout);
  mail->messageid = message_id();

  // buff = (gchar
  // *)gtk_entry_get_text(GTK_ENTRY(GTK_BIN(from_comboboxentry)));
  // mail->from = (char *)malloc(sizeof(char)* strlen(buff));
  // strcpy(mail->from,buff);

  // controllo gli attach TODO
  gtk_widget_destroy(compose_window);

  send_mail(mail);
  free_mail(mail);



}


void
on_composecancel_button_clicked(GtkButton * button, gpointer user_data)
{
  gtk_widget_destroy(compose_window);
}

void
on_from_changed(GtkButton * button, gpointer user_data)
{
  // gtk_widget_destroy(manualfrom_entry);

  if (gtk_combo_box_get_active(GTK_COMBO_BOX(from_comboboxentry)) == naccount)
  {
    gtk_widget_show(manualfrom_entry);
    gtk_widget_show(manual_label);
    gtk_paned_set_position(GTK_PANED(compose_vpaned), 160);
    // gtk_editable_set_editable(GTK_EDITABLE(GTK_BIN(from_comboboxentry)->child), 
    // 
    // 
    // 
    // 
    // 
    // 
    // 
    // TRUE);
  } else
  {
    gtk_widget_hide(manualfrom_entry);
    gtk_widget_hide(manual_label);
    gtk_paned_set_position(GTK_PANED(compose_vpaned), 140);
    // gtk_editable_set_editable(GTK_EDITABLE(GTK_BIN(from_comboboxentry)->child), 
    // 
    // 
    // 
    // 
    // 
    // 
    // 
    // FALSE);
  }
}



void
on_search_change(GtkWidget * entry, gpointer user_data)
{

  GtkTreeModel *model;
  GtkTreeIter iter;
  gchar *c = NULL;
  const gchar *p = NULL;
  gint s = gtk_combo_box_get_active((GtkComboBox *) user_data);

  p = gtk_entry_get_text((GtkEntry *) entry);
  model = gtk_tree_view_get_model((GtkTreeView *) mail_tree);
  unsigned short int i = 0;

  // barbatrucco
  gtk_tree_sortable_set_sort_column_id(GTK_TREE_SORTABLE(mail_store),
                                       MAIL, GTK_SORT_DESCENDING);



  if (!gtk_tree_model_get_iter_first(model, &iter))
    return;


  if (!p || p[0] == 0)
  {
    do
    {
      gtk_list_store_set(GTK_LIST_STORE(model), &iter, MAIL_SORT, FALSE, -1);
    }
    while (gtk_tree_model_iter_next(model, &iter));
    gtk_tree_sortable_set_sort_column_id(GTK_TREE_SORTABLE(mail_store),
                                         MAIL_SORT, GTK_SORT_DESCENDING);
    info(0, " ");
    return;
  }
  fflush(stdout);
  switch (s)
  {
    case 0:
    case 2:
      s = MAIL_SUBJECT;
      break;
    case 1:

      s = MAIL_FROM;
      break;
  }

  do
  {
    gtk_tree_model_get(model, &iter, s, &c, -1);
    if (search_cmp(c, (char *) p))
    {
      gtk_list_store_set(GTK_LIST_STORE(model), &iter, MAIL_SORT, TRUE, -1);
      i++;
    } else
      gtk_list_store_set(GTK_LIST_STORE(model), &iter, MAIL_SORT, FALSE, -1);

  }
  while (gtk_tree_model_iter_next(model, &iter));
  gtk_tree_sortable_set_sort_column_id(GTK_TREE_SORTABLE(mail_store),
                                       MAIL_SORT, GTK_SORT_DESCENDING);

  info(0, " -[ %d mails matched \"%s\" in %s]-", i, p,
       (s == MAIL_SUBJECT ? "Subject" : s == MAIL_FROM ? "From" : "Boh?"));

}



void
on_attachdel_button_clicked(GtkButton * button, gpointer user_data)
{

}

void
on_from_file_open_clicked(GtkButton * button, gpointer user_data)
{
}

void
on_from_file_cancel_clicked(GtkButton * button, gpointer user_data)
{
  gtk_widget_destroy(mail_filechooserdialog);
}

void
on_view_changed(GtkWidget * combobox, gpointer user_data)
{
  if (current_fold)
    print_mails(mail_store, current_fold,
                gtk_combo_box_get_active((GtkComboBox *) combobox), NULL);
}

void
on_fold_changed(GtkTreeView * treeview, gpointer user_data)
{
  struct folders *fold;

  if ((fold =
       catch_fold_selection(GTK_LIST_STORE(fold_store),
                            GTK_TREE_VIEW(fold_tree))))
  {
    current_fold = fold;
    print_mails(mail_store, fold,
                gtk_combo_box_get_active((GtkComboBox *) view_combobox),
                NULL);
  }
}

void
on_group_changed(GtkTreeView * treeview, gpointer user_data)
{
  struct contacts_group *group;

  if ((group =
       catch_group_selection(GTK_LIST_STORE(groups_list),
                             GTK_TREE_VIEW(groups_tree))))
  {
    current_group = group;
    print_contacts();
  }
}

void
on_contact_changed(GtkTreeView * treeview, gpointer user_data)
{
  struct contacts *contact;

  if ((contact =
       catch_contacts_selection(GTK_LIST_STORE(contacts_list),
                                GTK_TREE_VIEW(contacts_tree))))
  {
    printf("contact sel %s.\n", contact->name);
    current_contact = contact;
  }
}


void
print_folders()
{
  GtkTreeIter fold_iter;
  GdkPixbuf *icon;

  char buff[BUFFER_REAL], path[BUFFER_REAL];
  int i, all, unread;

  all = unread = 0;
  gtk_tree_store_clear((GtkTreeStore *) fold_store);

  /*
   * gtk_tree_store_append ((GtkTreeStore *)fold_store, &parent, NULL);
   * gtk_tree_store_set((GtkTreeStore *)fold_store, &parent, FOLD_ICON, icon,
   * FOLD_NAME, "Local folders",FOLD,NULL,-1);
   */
  snprintf(path, BUFFER_LEN, "%s/Themes/%s/letters.png", MAILDIR, THEME);
  icon = gdk_pixbuf_new_from_file(path, NULL);

  for (i = nfolds - 1; i >= 0; i--)
  {
    gtk_tree_store_append((GtkTreeStore *) fold_store, &fold_iter, NULL);

    sprintf(buff, "[%d/%d]", folder[i]->nnew, folder[i]->nall);
    if (i == 0)
    {
      snprintf(path, BUFFER_LEN, "%s/Themes/%s/listlast.png", MAILDIR, THEME);
      icon = gdk_pixbuf_new_from_file(path, NULL);
    } else if (i == nfolds - 2)
    {
      snprintf(path, BUFFER_LEN, "%s/Themes/%s/list.png", MAILDIR, THEME);
      icon = gdk_pixbuf_new_from_file(path, NULL);
    }

    gtk_tree_store_set((GtkTreeStore *) fold_store, &fold_iter, FOLD_ICON,
                       icon, FOLD_NAME,
                       folder[i]->name, FOLD_NUM, buff, FOLD,
                       (gpointer) folder[i], -1);
    all += folder[i]->nall;
    unread += folder[i]->nnew;
  }
  sprintf(buff, "Total :: <i>%d</i>", all);
  gtk_label_set_text((GtkLabel *) total_label, buff);
  gtk_label_set_use_markup(GTK_LABEL(total_label), TRUE);

  sprintf(buff, "Unread :: <i>%d</i>", unread);
  gtk_label_set_text((GtkLabel *) unread_label, buff);
  gtk_label_set_use_markup(GTK_LABEL(unread_label), TRUE);

  gtk_tree_view_expand_row((GtkTreeView *) fold_tree,
                           gtk_tree_path_new_from_string("0"), FALSE);

  if (current_fold)
    print_mails(mail_store, current_fold,
                gtk_combo_box_get_active((GtkComboBox *) view_combobox),
                NULL);

}

void
print_mails(GtkWidget * mail_store, struct folders *folder, int mode,
            char *contact)
{
  GtkTreeIter mail_iter;
  GdkPixbuf *icon, *icon_new;
  struct list *p;
  char buff[BUFFER_REAL];
  int i;

  fflush(stdout);
  p = folder->head;

  gtk_list_store_clear((GtkListStore *) mail_store);
  icon =
    gdk_pixbuf_new_from_file
    ("/usr/share/gtk-doc/html/libgimpwidgets/stock-eye-20.png", NULL);

  icon_new =
    gdk_pixbuf_new_from_file
    ("/home/drama/.paranoy/Themes/Default/newmail.png", NULL);

  i = 0;

  switch (mode)
  {
      // all
    case 0:
      while (p)
      {
        if (p->mail->type == NEW)
          icon_new =
            gdk_pixbuf_new_from_file
            ("/home/drama/.paranoy/Themes/Default/newmail.png", NULL);
        else
          icon_new =
            gdk_pixbuf_new_from_file
            ("/home/drama/.paranoy/Themes/Default/readedmail.png", NULL);

        gtk_list_store_append((GtkListStore *) mail_store, &mail_iter);
        gtk_list_store_set((GtkListStore *) mail_store, &mail_iter,
                           MAIL_ATTACH, p->mail->nattach ? icon : NULL,
                           MAIL_DATE, date_descr(p->mail, buff), MAIL_NEW,
                           icon_new, MAIL_FROM, format_from(p->mail->from, 0),
                           MAIL_SUBJECT, p->mail->subject, MAIL, p->mail,
                           MAIL_SORT, FALSE, -1);
        p = p->next;
        i++;
      }
      break;
      // new
    case 1:
      while (p)
      {
        if (p->mail->type == NEW)
        {
          gtk_list_store_append((GtkListStore *) mail_store, &mail_iter);
          gtk_list_store_set((GtkListStore *) mail_store, &mail_iter,
                             MAIL_ATTACH, p->mail->nattach ? icon : NULL,
                             MAIL_DATE, date_descr(p->mail, buff), MAIL_FROM,
                             format_from(p->mail->from, 0), MAIL_SUBJECT,
                             p->mail->subject, MAIL, p->mail, MAIL_SORT,
                             FALSE, -1);
        }
        p = p->next;
        i++;

      }
      break;
      // important
    case 2:
      while (p)
      {
        gtk_list_store_append((GtkListStore *) mail_store, &mail_iter);
        gtk_list_store_set((GtkListStore *) mail_store, &mail_iter,
                           MAIL_ATTACH, p->mail->nattach ? icon : NULL,
                           MAIL_DATE, date_descr(p->mail, buff), MAIL_FROM,
                           format_from(p->mail->from, 0), MAIL_SUBJECT,
                           p->mail->subject, MAIL, p->mail, MAIL_SORT, FALSE,
                           -1);
        p = p->next;
        i++;
      }
      break;
    case 13:
      while (p)
      {
        if (!strcmp(p->mail->from, contact))
        {
          gtk_list_store_append((GtkListStore *) mail_store, &mail_iter);
          gtk_list_store_set((GtkListStore *) mail_store, &mail_iter,
                             MAIL_ATTACH, p->mail->nattach ? icon : NULL,
                             MAIL_DATE, date_descr(p->mail, buff), MAIL_FROM,
                             format_from(p->mail->from, 0), MAIL_SUBJECT,
                             p->mail->subject, MAIL, p->mail, MAIL_SORT,
                             FALSE, -1);
        }
        p = p->next;
        i++;
      }
      break;
    case 14:
      while (p)
      {
        // queste le dovrebbe cercare solo in sent mail
        if (!strcmp(p->mail->to[0], contact))
        {
          gtk_list_store_append((GtkListStore *) mail_store, &mail_iter);
          gtk_list_store_set((GtkListStore *) mail_store, &mail_iter,
                             MAIL_ATTACH, p->mail->nattach ? icon : NULL,
                             MAIL_DATE, date_descr(p->mail, buff), MAIL_FROM,
                             format_from(p->mail->from, 0), MAIL_SUBJECT,
                             p->mail->subject, MAIL, p->mail, MAIL_SORT,
                             FALSE, -1);
        }
        p = p->next;
        i++;
      }
      break;
  }
}

void
on_getmail_button_clicked(GtkButton * button, gpointer user_data)
{

}


void
on_compose_button_clicked(GtkButton * button, gpointer user_data)
{
  if (current_contact)
  {
    struct email *mail;
    mail = (struct email *) malloc(sizeof(struct email));
    mail->from = strdup(current_contact->email);
    on_compose_activate(NULL, mail);
  }
}


void
on_contacts_button_clicked(GtkButton * button, gpointer user_data)
{

}


void
on_reply_button_clicked(GtkButton * button, struct email *mail)
{
  if (current_mail)
  {
    compose_window = create_compose_window(mail ? mail : current_mail, 1);
    gtk_widget_show(compose_window);
  }
}


void
on_replyall_button_clicked(GtkButton * button, struct email *mail)
{

}


void
on_forward_button_clicked(GtkButton * button, struct email *mail)
{
  if (current_mail)
  {
    compose_window = create_compose_window(mail ? mail : current_mail, 2);
    gtk_widget_show(compose_window);
  }
}


void
on_del_button_clicked(GtkButton * button, struct email *mail)
{
  if (current_mail)
  {
    // TODO
  }

}

void
on_open_mail_activate()
{
  struct email *mail;

  printf("attivata la mail\n");
  if ((mail =
       catch_mail_selection(GTK_LIST_STORE(mail_store),
                            GTK_TREE_VIEW(mail_tree))))
  {
    printf("catcho  la selezio\n");
    mail_window = create_mail_window(mail);
    gtk_widget_show(mail_window);

    // print_mails(model, current_fold, gtk_combo_box_get_active((GtkComboBox 
    // 
    // 
    // 
    // *) view_combobox),NULL);

    // TO FIX DEVE FARE IL SET SOLO DELLA COLONNA DELLE NEW
    print_folders();

  } else
    printf("ciccia la selezione\n");

}


void
on_edit_as_new_activate(GtkMenuItem * menuitem, gpointer user_data)
{
  if (current_mail)
  {
    compose_window = create_compose_window(current_mail, 3);
    gtk_widget_show(compose_window);
  }

}


void
on_move_to_activate(GtkMenuItem * menuitem, gpointer user_data)
{

}


void
on_provafiglio_activate(GtkMenuItem * menuitem, gpointer user_data)
{

}


void
on_copy_to_activate(GtkMenuItem * menuitem, gpointer user_data)
{

}


void
on_delete_activate(GtkMenuItem * menuitem, gpointer user_data)
{

}

void
on_mail_activate(GtkMenuItem * menuitem, gpointer user_data)
{

}


void
on_account_activate(GtkMenuItem * menuitem, gpointer user_data)
{

}


void
on_folder_activate(GtkMenuItem * menuitem, gpointer user_data)
{

}


void
on_contacts_menu_activate(GtkMenuItem * menuitem, gpointer user_data)
{

}


void
on_close_paranoy_activate(GtkMenuItem * menuitem, gpointer user_data)
{

}


void
on_cut_activate(GtkMenuItem * menuitem, gpointer user_data)
{

}


void
on_copy_activate(GtkMenuItem * menuitem, gpointer user_data)
{

}


void
on_paste_activate(GtkMenuItem * menuitem, gpointer user_data)
{

}


void
on_delete_mail_activate(GtkMenuItem * menuitem, gpointer user_data)
{

}


void
on_select_all_activate(GtkMenuItem * menuitem, gpointer user_data)
{

}


void
on_item1_activate(GtkMenuItem * menuitem, gpointer user_data)
{

}


void
on_preferences_activate(GtkMenuItem * menuitem, gpointer user_data)
{

}


void
on_view_activate(GtkMenuItem * menuitem, gpointer user_data)
{

}


void
on_mails_activate(GtkMenuItem * menuitem, gpointer user_data)
{

}



void
on_mail_as_new_activate(GtkMenuItem * menuitem, gpointer user_data)
{

}



void
on_filter_from_mail_activate(GtkMenuItem * menuitem, gpointer user_data)
{

}

void
on_showattach_button_clicked(GtkButton * button, gpointer user_data)
{
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new();

  if (!attshow)
  {
    gtk_widget_destroy(att_image);
    att_image = gtk_image_new_from_stock("gtk-redo", GTK_ICON_SIZE_BUTTON);
    gtk_widget_show(att_image);
    gtk_container_add(GTK_CONTAINER(showattach_button), att_image);
    gtk_tooltips_set_tip(tooltips, showattach_button, _("Hide attachments"),
                         NULL);
    gtk_widget_show_all(attach_scrolledwindow);
    attshow = 1;
  } else
  {
    gtk_widget_destroy(att_image);
    att_image = gtk_image_new_from_stock("gtk-undo", GTK_ICON_SIZE_BUTTON);
    gtk_widget_show(att_image);
    gtk_container_add(GTK_CONTAINER(showattach_button), att_image);
    gtk_tooltips_set_tip(tooltips, showattach_button, _("Show attachments"),
                         NULL);
    gtk_widget_hide_all(attach_scrolledwindow);
    attshow = 0;
  }
}


void
on_addattach_button_clicked(GtkButton * button, gpointer user_data)
{

}


void
on_delattach_button_clicked(GtkButton * button, gpointer user_data)
{

}


void
on_cut_button_clicked(GtkButton * button, gpointer user_data)
{

}


void
on_copy_button_clicked(GtkButton * button, gpointer user_data)
{

}


void
on_paste_button_clicked(GtkButton * button, gpointer user_data)
{

}


void
on_selall_button_clicked(GtkButton * button, gpointer user_data)
{

}


void
on_delete_button_clicked(GtkButton * button, gpointer user_data)
{

}


void
on_clear_button_clicked(GtkButton * button, gpointer user_data)
{

}


void
on_fromfile_button_clicked(GtkButton * button, gpointer user_data)
{

}

void
on_addaccount_button_clicked(GtkButton * button, gpointer user_data)
{
  addacc_finish_button = gtk_button_new_with_mnemonic(_(" Finish "));
  // gtk_button_set_relief(GTK_BUTTON(addacc_finish_button),
  // GTK_RELIEF_NONE);
  g_signal_connect((gpointer) addacc_finish_button, "clicked",
                   G_CALLBACK(on_account_button_clicked), NULL);

  newacc_pages = add_account_pages_new();

  add_accounts_window =
    create_backnext_window(newacc_pages, addacc_finish_button);
  gtk_widget_show(add_accounts_window);


}


void
on_modaccount_button_clicked(GtkButton * button, gpointer user_data)
{

  accounts_window = create_accounts_window();
  gtk_widget_show(accounts_window);


}


void
on_delaccount_button_clicked(GtkButton * button, GtkWidget * window)
{

  /*
   * while (del[0]<naccount-1) { account[del[0]] = account[del[0]+1];
   * del[0]++; } account[del[0]] = NULL;
   * 
   * naccount--;
   */
  print_accounts();
  gtk_widget_destroy(window);
  write_configuration(0);
  // free(del);
  // info (2,"-{ Account delete }-");

}

void
on_back_button_clicked(GtkButton * button, struct backnext_pages *pages)
{
  if (newacc_pages->prev != NULL)
  {
    // se fo un back dall'ultima pagina
    if (!newacc_pages->next)
    {
      // rimetto il tasto next
      gtk_widget_hide_all(addacc_finish_button);
      gtk_widget_show_all(next_button);
    }

    gtk_widget_hide_all(newacc_pages->page);

    newacc_pages = newacc_pages->prev;
    gtk_widget_show_all(newacc_pages->page);

  }

  if (newacc_pages->prev == NULL)
  {
    gtk_widget_show(buio_label);
    gtk_widget_hide((GtkWidget *) button);
  }


}


void
on_next_button_clicked(GtkButton * button, struct backnext_pages *pages)
{
  gtk_widget_hide_all(newacc_pages->page);
  newacc_pages = newacc_pages->next;

  // se e' l'ultima pagina
  if (newacc_pages->next == NULL)
  {
    if (info_table)
      gtk_widget_destroy(info_table);

    info_table = print_info_table();
    gtk_widget_show(info_table);
    gtk_table_attach(GTK_TABLE(confirm_table), info_table, 0, 1, 1, 2,
                     (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                     (GtkAttachOptions) (GTK_FILL), 0, 25);

    // metto il tasto finish
    gtk_widget_hide_all(GTK_WIDGET(button));
    gtk_widget_show_all(addacc_finish_button);
  } else if (newacc_pages->prev->prev == NULL)
  {
    gtk_widget_show(back_button);
    gtk_widget_hide(buio_label);
  }

  gtk_widget_show_all(newacc_pages->page);
}



void
on_newcancel_button_clicked(GtkButton * button, gpointer user_data)
{
  gtk_widget_destroy(add_accounts_window);
}

GtkWidget *
print_info_table()
{
  GtkWidget *label, *info_table;

  info_table = gtk_table_new(6, 2, FALSE);


  label = gtk_label_new(_(gtk_entry_get_text(GTK_ENTRY(addacc_email_entry))));
  gtk_widget_show(label);
  gtk_table_attach(GTK_TABLE(info_table), label, 1, 2, 1, 2,
                   (GtkAttachOptions) (GTK_FILL),
                   (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment(GTK_MISC(label), 0, 0.5);

  label = gtk_label_new(_(gtk_entry_get_text(GTK_ENTRY(addacc_port_entry))));
  gtk_widget_show(label);
  gtk_table_attach(GTK_TABLE(info_table), label, 1, 2, 3, 4,
                   (GtkAttachOptions) (GTK_FILL),
                   (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment(GTK_MISC(label), 0, 0.5);

  label = gtk_label_new(_("POP3[???]"));
  gtk_widget_show(label);
  gtk_table_attach(GTK_TABLE(info_table), label, 1, 2, 4, 5,
                   (GtkAttachOptions) (GTK_FILL),
                   (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment(GTK_MISC(label), 0, 0.5);

  label = gtk_label_new(_("Clear[???]"));
  gtk_widget_show(label);
  gtk_table_attach(GTK_TABLE(info_table), label, 1, 2, 5, 6,
                   (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                   (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment(GTK_MISC(label), 0, 0.5);

  label = gtk_label_new(_(gtk_entry_get_text(GTK_ENTRY(addacc_pop_entry))));
  gtk_widget_show(label);
  gtk_table_attach(GTK_TABLE(info_table), label, 1, 2, 2, 3,
                   (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                   (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment(GTK_MISC(label), 0, 0.5);

  label = gtk_label_new(_(gtk_entry_get_text(GTK_ENTRY(addacc_name_entry))));
  gtk_widget_show(label);
  gtk_table_attach(GTK_TABLE(info_table), label, 1, 2, 0, 1,
                   (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                   (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment(GTK_MISC(label), 0, 0.5);

  label = gtk_label_new(_("Your email ::"));
  gtk_widget_show(label);
  gtk_table_attach(GTK_TABLE(info_table), label, 0, 1, 1, 2,
                   (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                   (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_use_markup(GTK_LABEL(label), TRUE);
  gtk_misc_set_alignment(GTK_MISC(label), 0, 0.5);

  label = gtk_label_new(_("Your name ::"));
  gtk_widget_show(label);
  gtk_table_attach(GTK_TABLE(info_table), label, 0, 1, 0, 1,
                   (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                   (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_use_markup(GTK_LABEL(label), TRUE);
  gtk_misc_set_alignment(GTK_MISC(label), 0, 0.5);

  label = gtk_label_new(_("Incoming server port ::"));
  gtk_widget_show(label);
  gtk_table_attach(GTK_TABLE(info_table), label, 0, 1, 3, 4,
                   (GtkAttachOptions) (GTK_FILL),
                   (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_use_markup(GTK_LABEL(label), TRUE);
  gtk_misc_set_alignment(GTK_MISC(label), 0, 0.5);

  label = gtk_label_new(_("Incoming server address ::"));
  gtk_widget_show(label);
  gtk_table_attach(GTK_TABLE(info_table), label, 0, 1, 2, 3,
                   (GtkAttachOptions) (GTK_FILL),
                   (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_use_markup(GTK_LABEL(label), TRUE);
  gtk_misc_set_alignment(GTK_MISC(label), 0, 0.5);

  label = gtk_label_new(_("Incoming server type ::"));
  gtk_widget_show(label);
  gtk_table_attach(GTK_TABLE(info_table), label, 0, 1, 4, 5,
                   (GtkAttachOptions) (GTK_FILL),
                   (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_use_markup(GTK_LABEL(label), TRUE);
  gtk_misc_set_alignment(GTK_MISC(label), 0, 0.5);

  label = gtk_label_new(_("Type of connection ::"));
  gtk_widget_show(label);
  gtk_table_attach(GTK_TABLE(info_table), label, 0, 1, 5, 6,
                   (GtkAttachOptions) (GTK_FILL),
                   (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_use_markup(GTK_LABEL(label), TRUE);
  gtk_misc_set_alignment(GTK_MISC(label), 0, 0.5);

  return info_table;
}

void
on_delacc_button_clicked(GtkButton * button, gpointer user_data)
{
  GtkTreeSelection *sel;
  GtkTreeIter iter;
  int *del;
  char buff[BUFFER_REAL];

  del = (int *) malloc(sizeof(int));
  sel = gtk_tree_view_get_selection(GTK_TREE_VIEW(account_list));

  if (gtk_tree_selection_get_selected(GTK_TREE_SELECTION(sel), NULL, &iter))
  {
    del[0] =
      atoi(gtk_tree_model_get_string_from_iter
           (GTK_TREE_MODEL(account_store), &iter));
    sprintf(buff, "Are you sure to remove '%s' from your account list?",
            account[del[0]]->email);
    account_dialog =
      create_twobutton_dialog(buff, on_delaccount_button_clicked);
    gtk_widget_show(account_dialog);
  } else
  {
    info(2, "-{ No Account selected }-");
  }
}

void
on_delacc_cancelbutton_clicked(GtkButton * button, gpointer user_data)
{
  gtk_widget_destroy(account_dialog);
}

void
delgroup_clicked(GtkButton * button, GtkWidget * window)
{
  struct contacts_group *p;

  if (current_group == groups)
    groups = groups->next;
  else
  {
    p = groups;

    while (p->next != current_group)
      p = p->next;

    p->next = p->next->next;
  }


  // tofix 
  free(current_group);
  current_group = NULL;
  current_contact = NULL;
  gtk_widget_destroy(window);
  write_configuration(0);
  print_contacts_group();
  print_contacts();


}


void
on_delgroup_button_clicked(GtkButton * button, gpointer user_data)
{

  if (current_group)
  {
    if (current_group->head)
    {
      char buff[BUFFER_REAL];

      sprintf(buff,
              "This group contains some contacts.\nAre you sure to remove '%s' from your Address book?",
              current_group->name);
      delgroup_dialog = create_twobutton_dialog(buff, delgroup_clicked);
      gtk_widget_show(delgroup_dialog);
    } else
    {
      delgroup_clicked(NULL, NULL);
    }
  } else
  {
    GtkWidget *alert;

    alert = create_alert_dialog("No group selected !!!");
    gtk_widget_show(alert);
  }
}



void
toggle_smtp_auth_info()
{
  if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(auth_checkbutton)))
  {
    gtk_widget_show_all(smtpauth_table);
  } else
  {
    gtk_widget_hide_all(smtpauth_table);
  }
}
