#include "../include.h"

#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  g_object_set_data_full (G_OBJECT (component), name, \
    gtk_widget_ref (widget), (GDestroyNotify) gtk_widget_unref)

#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  g_object_set_data (G_OBJECT (component), name, widget)


GtkWidget *
create_compose_window(struct email *mail, int mode)
{
  GtkWidget *compose_window;
  GtkWidget *composemain_hbox;

  GtkWidget *up_hbox;
  GtkWidget *head_hbox;
  GtkWidget *scrolledwindow;

  GtkWidget *viewport;
  GtkWidget *head_table;
  GtkWidget *label;
  GtkWidget *opt_vbox;
  GtkWidget *butt_vbox;
  GtkWidget *vbox;


  GtkWidget *att_table;
  GtkWidget *out_hbox;
  GtkWidget *addattach_button;
  GtkWidget *image82;
  GtkWidget *delattach_button;
  GtkWidget *image81;
  GtkWidget *text_vbox;
  GtkWidget *hbox;
  GtkWidget *cut_button;
  GtkWidget *image84;
  GtkWidget *copy_button;
  GtkWidget *image85;
  GtkWidget *paste_button;
  GtkWidget *image86;
  GtkWidget *separatortoolitem;
  GtkWidget *selall_button;
  GtkWidget *image87;
  GtkWidget *delete_button;
  GtkWidget *image83;
  GtkWidget *clear_button;
  GtkWidget *image90;
  GtkWidget *fromfile_button;
  GtkWidget *image89;
  GtkWidget *label250;
  GtkWidget *composebutton_vbox;
  GtkWidget *postpone_button;
  GtkWidget *send_button;
  GtkWidget *cancel_button;
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new();

  compose_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_size_request(compose_window, 650, 450);
  gtk_window_set_title(GTK_WINDOW(compose_window), _(":: compose ::"));
  gtk_window_set_position(GTK_WINDOW(compose_window), GTK_WIN_POS_CENTER);

  composemain_hbox = gtk_hbox_new(FALSE, 0);
  gtk_widget_show(composemain_hbox);
  gtk_container_add(GTK_CONTAINER(compose_window), composemain_hbox);

  compose_vpaned = gtk_vpaned_new();
  gtk_widget_show(compose_vpaned);
  gtk_box_pack_start(GTK_BOX(composemain_hbox), compose_vpaned, TRUE, TRUE,
                     0);
  gtk_paned_set_position(GTK_PANED(compose_vpaned), 140);

  up_hbox = gtk_hbox_new(FALSE, 0);
  gtk_widget_show(up_hbox);
  gtk_paned_pack1(GTK_PANED(compose_vpaned), up_hbox, FALSE, TRUE);

  head_hbox = gtk_hbox_new(FALSE, 0);
  gtk_widget_show(head_hbox);
  gtk_box_pack_start(GTK_BOX(up_hbox), head_hbox, TRUE, TRUE, 0);

  scrolledwindow = gtk_scrolled_window_new(NULL, NULL);
  gtk_widget_show(scrolledwindow);
  gtk_box_pack_start(GTK_BOX(head_hbox), scrolledwindow, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolledwindow),
                                 GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  viewport = gtk_viewport_new(NULL, NULL);
  gtk_widget_show(viewport);
  gtk_container_add(GTK_CONTAINER(scrolledwindow), viewport);
  gtk_widget_set_size_request(viewport, 320, -1);
  gtk_viewport_set_shadow_type(GTK_VIEWPORT(viewport), GTK_SHADOW_OUT);

  head_table = gtk_table_new(6, 2, FALSE);
  gtk_widget_show(head_table);
  gtk_container_add(GTK_CONTAINER(viewport), head_table);
  gtk_widget_set_size_request(head_table, 300, -1);
  gtk_container_set_border_width(GTK_CONTAINER(head_table), 5);

  label = gtk_label_new(_(" :: Reply-to"));
  gtk_widget_show(label);
  gtk_table_attach(GTK_TABLE(head_table), label, 1, 2, 5, 6,
                   (GtkAttachOptions) (GTK_FILL),
                   (GtkAttachOptions) (GTK_EXPAND), 0, 0);
  gtk_label_set_use_markup(GTK_LABEL(label), TRUE);
  gtk_misc_set_alignment(GTK_MISC(label), 0, 0.5);

  label = gtk_label_new(_(" :: Bcc"));
  gtk_widget_show(label);
  gtk_table_attach(GTK_TABLE(head_table), label, 1, 2, 4, 5,
                   (GtkAttachOptions) (GTK_FILL),
                   (GtkAttachOptions) (GTK_EXPAND), 0, 0);
  gtk_label_set_use_markup(GTK_LABEL(label), TRUE);
  gtk_misc_set_alignment(GTK_MISC(label), 0, 0.5);

  label = gtk_label_new(_(" :: Cc"));
  gtk_widget_show(label);
  gtk_table_attach(GTK_TABLE(head_table), label, 1, 2, 3, 4,
                   (GtkAttachOptions) (GTK_FILL),
                   (GtkAttachOptions) (GTK_EXPAND), 0, 0);
  gtk_label_set_use_markup(GTK_LABEL(label), TRUE);
  gtk_misc_set_alignment(GTK_MISC(label), 0, 0.5);


  manual_label = gtk_label_new(_(" <<<"));
  gtk_table_attach(GTK_TABLE(head_table), manual_label, 1, 2, 1, 2,
                   (GtkAttachOptions) (GTK_FILL),
                   (GtkAttachOptions) (GTK_EXPAND), 0, 0);
  // gtk_label_set_use_markup (GTK_LABEL (manual_label), TRUE);
  gtk_misc_set_alignment(GTK_MISC(manual_label), 0, 0.5);

  label = gtk_label_new(_("<b> :: From</b>"));
  gtk_widget_show(label);
  gtk_table_attach(GTK_TABLE(head_table), label, 1, 2, 0, 1,
                   (GtkAttachOptions) (GTK_FILL),
                   (GtkAttachOptions) (GTK_EXPAND), 0, 0);
  gtk_label_set_use_markup(GTK_LABEL(label), TRUE);
  gtk_misc_set_alignment(GTK_MISC(label), 0, 0.5);

  manualfrom_entry = gtk_entry_new();
  gtk_table_attach(GTK_TABLE(head_table), manualfrom_entry, 0, 1, 1, 2,
                   (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                   (GtkAttachOptions) (0), 0, 0);

  to_entry = gtk_entry_new();
  gtk_widget_show(to_entry);
  gtk_table_attach(GTK_TABLE(head_table), to_entry, 0, 1, 2, 3,
                   (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                   (GtkAttachOptions) (0), 0, 0);

  cc_entry = gtk_entry_new();
  gtk_widget_show(cc_entry);
  gtk_table_attach(GTK_TABLE(head_table), cc_entry, 0, 1, 3, 4,
                   (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                   (GtkAttachOptions) (0), 0, 0);

  bcc_entry = gtk_entry_new();
  gtk_widget_show(bcc_entry);
  gtk_table_attach(GTK_TABLE(head_table), bcc_entry, 0, 1, 4, 5,
                   (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                   (GtkAttachOptions) (0), 0, 0);

  replyto_entry = gtk_entry_new();
  gtk_widget_show(replyto_entry);
  gtk_table_attach(GTK_TABLE(head_table), replyto_entry, 0, 1, 5, 6,
                   (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                   (GtkAttachOptions) (0), 0, 0);

  // METTE GLI ACCOUNT

  account_store = gtk_list_store_new(ACC_NCOL, G_TYPE_STRING, G_TYPE_STRING);
  print_accounts();

  from_comboboxentry = gtk_combo_box_new_text();
  gtk_widget_show(from_comboboxentry);
  gtk_table_attach(GTK_TABLE(head_table), from_comboboxentry, 0, 1, 0, 1,
                   (GtkAttachOptions) (GTK_FILL),
                   (GtkAttachOptions) (0), 0, 0);



  if (naccount > 0)
  {
    int i;

    for (i = 0; i < naccount; i++)
      gtk_combo_box_append_text(GTK_COMBO_BOX(from_comboboxentry),
                                account[i]->email);
  }

  /*
   * gtk_list_store_append(GTK_LIST_STORE(account_store), &iter);
   * gtk_list_store_set(account_store,&iter, ACC_EMAIL,"Manual from",-1);
   * gtk_editable_set_editable(GTK_EDITABLE(GTK_BIN(from_comboboxentry)->child),FALSE);
   */
  gtk_combo_box_append_text(GTK_COMBO_BOX(from_comboboxentry), "Manual From");
  gtk_combo_box_set_active(GTK_COMBO_BOX(from_comboboxentry), 0);

  label = gtk_label_new(_("<b> :: To</b>"));
  gtk_widget_show(label);
  gtk_table_attach(GTK_TABLE(head_table), label, 1, 2, 2, 3,
                   (GtkAttachOptions) (GTK_FILL),
                   (GtkAttachOptions) (GTK_EXPAND), 0, 0);
  gtk_label_set_use_markup(GTK_LABEL(label), TRUE);
  gtk_misc_set_alignment(GTK_MISC(label), 0, 0.5);

  opt_vbox = gtk_vbox_new(FALSE, 0);
  gtk_widget_show(opt_vbox);
  gtk_box_pack_start(GTK_BOX(head_hbox), opt_vbox, FALSE, FALSE, 10);

  butt_vbox = gtk_vbox_new(FALSE, 0);
  gtk_widget_show(butt_vbox);
  gtk_box_pack_start(GTK_BOX(opt_vbox), butt_vbox, TRUE, TRUE, 10);

  vbox = gtk_vbox_new(FALSE, 0);
  gtk_widget_show(vbox);
  gtk_box_pack_start(GTK_BOX(butt_vbox), vbox, TRUE, FALSE, 0);

  anon_togglebutton = gtk_toggle_button_new_with_mnemonic("");
  gtk_widget_show(anon_togglebutton);
  gtk_box_pack_start(GTK_BOX(vbox), anon_togglebutton, FALSE, FALSE, 0);
  gtk_tooltips_set_tip(tooltips, anon_togglebutton, _("Anonimyze email"),
                       NULL);

  sign_togglebutton = gtk_toggle_button_new_with_mnemonic("");
  gtk_widget_show(sign_togglebutton);
  gtk_box_pack_start(GTK_BOX(vbox), sign_togglebutton, FALSE, FALSE, 0);
  gtk_tooltips_set_tip(tooltips, sign_togglebutton, _("Sign email"), NULL);

  encrypt_togglebutton = gtk_toggle_button_new_with_mnemonic("");
  gtk_widget_show(encrypt_togglebutton);
  gtk_box_pack_start(GTK_BOX(vbox), encrypt_togglebutton, FALSE, FALSE, 0);
  gtk_tooltips_set_tip(tooltips, encrypt_togglebutton, _("encrypt email"),
                       NULL);

  showattach_button = gtk_button_new();
  gtk_widget_show(showattach_button);
  gtk_box_pack_end(GTK_BOX(butt_vbox), showattach_button, FALSE, FALSE, 0);
  gtk_tooltips_set_tip(tooltips, showattach_button, _("Show attachments"),
                       NULL);

  att_image = gtk_image_new_from_stock("gtk-undo", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show(att_image);
  gtk_container_add(GTK_CONTAINER(showattach_button), att_image);

  attach_scrolledwindow = gtk_scrolled_window_new(NULL, NULL);
  gtk_box_pack_start(GTK_BOX(up_hbox), attach_scrolledwindow, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(attach_scrolledwindow),
                                 GTK_POLICY_NEVER, GTK_POLICY_NEVER);

  viewport = gtk_viewport_new(NULL, NULL);
  gtk_widget_show(viewport);
  gtk_container_add(GTK_CONTAINER(attach_scrolledwindow), viewport);
  gtk_viewport_set_shadow_type(GTK_VIEWPORT(viewport), GTK_SHADOW_OUT);


  att_table = gtk_table_new(2, 1, FALSE);
  gtk_widget_show(att_table);
  gtk_container_add(GTK_CONTAINER(viewport), att_table);
  gtk_container_set_border_width(GTK_CONTAINER(att_table), 5);

  label = gtk_label_new(_("<i>:: Attachments ::</i>"));
  gtk_widget_show(label);
  gtk_table_attach(GTK_TABLE(att_table), label, 0, 1, 0, 1,
                   (GtkAttachOptions) (GTK_FILL),
                   (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_use_markup(GTK_LABEL(label), TRUE);
  gtk_misc_set_alignment(GTK_MISC(label), 0, 0.5);

  scrolledwindow = gtk_scrolled_window_new(NULL, NULL);
  gtk_widget_show(scrolledwindow);
  gtk_table_attach(GTK_TABLE(att_table), scrolledwindow, 0, 1, 1, 2,
                   (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                   (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolledwindow),
                                 GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  viewport = gtk_viewport_new(NULL, NULL);
  gtk_widget_show(viewport);
  gtk_container_add(GTK_CONTAINER(scrolledwindow), viewport);

  out_hbox = gtk_hbox_new(FALSE, 0);
  gtk_widget_show(out_hbox);
  gtk_container_add(GTK_CONTAINER(viewport), out_hbox);

  attach_tree = gtk_tree_view_new();
  gtk_widget_show(GTK_WIDGET(attach_tree));
  gtk_box_pack_start(GTK_BOX(out_hbox), GTK_WIDGET(attach_tree), TRUE, TRUE,
                     0);

  vbox = gtk_vbox_new(FALSE, 0);
  gtk_widget_show(vbox);
  gtk_box_pack_start(GTK_BOX(out_hbox), vbox, FALSE, TRUE, 0);

  addattach_button = gtk_button_new();
  gtk_widget_show(addattach_button);
  gtk_box_pack_start(GTK_BOX(vbox), addattach_button, TRUE, TRUE, 0);

  image82 = gtk_image_new_from_stock("gtk-add", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show(image82);
  gtk_container_add(GTK_CONTAINER(addattach_button), image82);

  delattach_button = gtk_button_new();
  gtk_widget_show(delattach_button);
  gtk_box_pack_start(GTK_BOX(vbox), delattach_button, TRUE, TRUE, 0);

  image81 = gtk_image_new_from_stock("gtk-remove", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show(image81);
  gtk_container_add(GTK_CONTAINER(delattach_button), image81);

  gtk_widget_hide_all(attach_scrolledwindow);
  attshow = 0;


  text_vbox = gtk_vbox_new(FALSE, 0);
  gtk_widget_show(text_vbox);
  gtk_paned_pack2(GTK_PANED(compose_vpaned), text_vbox, TRUE, TRUE);

  scrolledwindow = gtk_scrolled_window_new(NULL, NULL);
  gtk_widget_show(scrolledwindow);
  gtk_box_pack_start(GTK_BOX(text_vbox), scrolledwindow, FALSE, FALSE, 0);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolledwindow),
                                 GTK_POLICY_NEVER, GTK_POLICY_NEVER);

  viewport = gtk_viewport_new(NULL, NULL);
  gtk_widget_show(viewport);
  gtk_container_add(GTK_CONTAINER(scrolledwindow), viewport);
  gtk_viewport_set_shadow_type(GTK_VIEWPORT(viewport), GTK_SHADOW_OUT);

  hbox = gtk_hbox_new(FALSE, 0);
  gtk_widget_show(hbox);
  gtk_container_add(GTK_CONTAINER(viewport), hbox);

  cut_button = gtk_button_new();
  gtk_widget_show(cut_button);
  gtk_box_pack_start(GTK_BOX(hbox), cut_button, FALSE, FALSE, 0);
  gtk_button_set_relief(GTK_BUTTON(cut_button), GTK_RELIEF_NONE);
  gtk_tooltips_set_tip(tooltips, cut_button, _("Cut"), NULL);

  image84 = gtk_image_new_from_stock("gtk-cut", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show(image84);
  gtk_container_add(GTK_CONTAINER(cut_button), image84);

  copy_button = gtk_button_new();
  gtk_widget_show(copy_button);
  gtk_box_pack_start(GTK_BOX(hbox), copy_button, FALSE, FALSE, 0);
  gtk_button_set_relief(GTK_BUTTON(copy_button), GTK_RELIEF_NONE);
  gtk_tooltips_set_tip(tooltips, copy_button, _("Copy"), NULL);

  image85 = gtk_image_new_from_stock("gtk-copy", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show(image85);
  gtk_container_add(GTK_CONTAINER(copy_button), image85);

  paste_button = gtk_button_new();
  gtk_widget_show(paste_button);
  gtk_box_pack_start(GTK_BOX(hbox), paste_button, FALSE, FALSE, 0);
  gtk_button_set_relief(GTK_BUTTON(paste_button), GTK_RELIEF_NONE);
  gtk_tooltips_set_tip(tooltips, paste_button, _("Paste"), NULL);

  image86 = gtk_image_new_from_stock("gtk-paste", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show(image86);
  gtk_container_add(GTK_CONTAINER(paste_button), image86);

  separatortoolitem = (GtkWidget *) gtk_separator_tool_item_new();
  gtk_widget_show(separatortoolitem);
  gtk_box_pack_start(GTK_BOX(hbox), separatortoolitem, FALSE, TRUE, 0);

  selall_button = gtk_button_new();
  gtk_widget_show(selall_button);
  gtk_box_pack_start(GTK_BOX(hbox), selall_button, FALSE, FALSE, 0);
  gtk_button_set_relief(GTK_BUTTON(selall_button), GTK_RELIEF_NONE);
  gtk_tooltips_set_tip(tooltips, selall_button, _("Select All"), NULL);

  image87 =
    gtk_image_new_from_stock("gtk-justify-fill", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show(image87);
  gtk_container_add(GTK_CONTAINER(selall_button), image87);

  delete_button = gtk_button_new();
  gtk_widget_show(delete_button);
  gtk_box_pack_start(GTK_BOX(hbox), delete_button, FALSE, FALSE, 0);
  gtk_button_set_relief(GTK_BUTTON(delete_button), GTK_RELIEF_NONE);
  gtk_tooltips_set_tip(tooltips, delete_button, _("Delete"), NULL);

  image83 = gtk_image_new_from_stock("gtk-cancel", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show(image83);
  gtk_container_add(GTK_CONTAINER(delete_button), image83);

  clear_button = gtk_button_new();
  gtk_widget_show(clear_button);
  gtk_box_pack_start(GTK_BOX(hbox), clear_button, FALSE, FALSE, 0);
  gtk_button_set_relief(GTK_BUTTON(clear_button), GTK_RELIEF_NONE);
  gtk_button_set_focus_on_click(GTK_BUTTON(clear_button), FALSE);
  gtk_tooltips_set_tip(tooltips, clear_button, _("Clear text"), NULL);

  image90 = gtk_image_new_from_stock("gtk-clear", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show(image90);
  gtk_container_add(GTK_CONTAINER(clear_button), image90);

  separatortoolitem = (GtkWidget *) gtk_separator_tool_item_new();
  gtk_widget_show(separatortoolitem);
  gtk_box_pack_start(GTK_BOX(hbox), separatortoolitem, FALSE, FALSE, 0);

  fromfile_button = gtk_button_new();
  gtk_widget_show(fromfile_button);
  gtk_box_pack_start(GTK_BOX(hbox), fromfile_button, FALSE, FALSE, 0);
  gtk_button_set_relief(GTK_BUTTON(fromfile_button), GTK_RELIEF_NONE);
  gtk_tooltips_set_tip(tooltips, fromfile_button, _("Get text from file"),
                       NULL);

  image89 = gtk_image_new_from_stock("gtk-open", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show(image89);
  gtk_container_add(GTK_CONTAINER(fromfile_button), image89);

  hbox = gtk_hbox_new(FALSE, 0);
  gtk_widget_show(hbox);
  gtk_box_pack_start(GTK_BOX(text_vbox), hbox, FALSE, TRUE, 3);

  label250 = gtk_label_new(_("<b>  Subject :: </b>"));
  gtk_widget_show(label250);
  gtk_box_pack_start(GTK_BOX(hbox), label250, FALSE, FALSE, 0);
  gtk_label_set_use_markup(GTK_LABEL(label250), TRUE);

  subject_entry = gtk_entry_new();
  gtk_widget_show(subject_entry);
  gtk_box_pack_start(GTK_BOX(hbox), subject_entry, TRUE, TRUE, 0);

  scrolledwindow = gtk_scrolled_window_new(NULL, NULL);
  gtk_widget_show(scrolledwindow);
  gtk_box_pack_start(GTK_BOX(text_vbox), scrolledwindow, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolledwindow),
                                 GTK_POLICY_NEVER, GTK_POLICY_NEVER);
  gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(scrolledwindow),
                                      GTK_SHADOW_OUT);

  viewport = gtk_viewport_new(NULL, NULL);
  gtk_widget_show(viewport);
  gtk_container_add(GTK_CONTAINER(scrolledwindow), viewport);

  scrolledwindow = gtk_scrolled_window_new(NULL, NULL);
  gtk_widget_show(scrolledwindow);
  gtk_container_add(GTK_CONTAINER(viewport), scrolledwindow);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolledwindow),
                                 GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(scrolledwindow),
                                      GTK_SHADOW_ETCHED_IN);

  body_textview = gtk_text_view_new();
  gtk_widget_show(body_textview);
  gtk_container_add(GTK_CONTAINER(scrolledwindow), body_textview);
  gtk_text_view_set_left_margin(GTK_TEXT_VIEW(body_textview), 5);
  gtk_text_view_set_right_margin(GTK_TEXT_VIEW(body_textview), 5);

  switch (mode)
  {
      // si potrebbe sicuro fare di meglio...ma ormai e' tardi
      // Reply
    case 1:
      {
        GtkTextIter iter;

        // struct email *p;
        char *buff;
        int i, t;

        // p = folder[0]->head;
        // for (i=0;i <n_mail;i++)
        // p = p->next;

        // prendo il subject e metto il Re:
        buff = (char *) malloc(sizeof(char) * (strlen(mail->subject) + 6));
        sprintf(buff, "Re: %s", mail->subject);
        gtk_entry_set_text(GTK_ENTRY(subject_entry), buff);

        // prendo il to dal from
        gtk_entry_set_text(GTK_ENTRY(to_entry), mail->from);

        // stampo qualche riga bianca all'inizio del body
        body_buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(body_textview));
        gtk_text_buffer_get_start_iter(GTK_TEXT_BUFFER(body_buffer), &iter);

        for (t = 0; t < 2; t++)
        {
          buff = strdup("\n");
          gtk_text_buffer_insert(GTK_TEXT_BUFFER(body_buffer), &iter, buff,
                                 strlen(buff));
          gtk_text_buffer_get_iter_at_line(GTK_TEXT_BUFFER(body_buffer),
                                           &iter, t + 1);
        }

        // stampo 'from' wrote: 
        buff =
          (char *) realloc(buff, sizeof(char) * (strlen(mail->from) + 20));
        sprintf(buff, "----  %s wrote:\n", mail->from);
        gtk_text_buffer_insert(GTK_TEXT_BUFFER(body_buffer), &iter, buff,
                               strlen(buff));
        gtk_text_buffer_get_iter_at_line(GTK_TEXT_BUFFER(body_buffer), &iter,
                                         ++t);

        // un'altra riga bianca
        buff = strdup("\n");
        gtk_text_buffer_insert(GTK_TEXT_BUFFER(body_buffer), &iter, buff,
                               strlen(buff));
        gtk_text_buffer_get_iter_at_line(GTK_TEXT_BUFFER(body_buffer), &iter,
                                         ++t);

        // stampo il body quotato
        i = 0;
        while (i < mail->body_lines)
        {
          buff =
            (char *) realloc(buff,
                             sizeof(char) * (strlen(mail->body[i]) + 5));
          sprintf(buff, "> %s\n", mail->body[i]);
          // printa
          gtk_text_buffer_insert(GTK_TEXT_BUFFER(body_buffer), &iter, buff,
                                 strlen(buff));
          gtk_text_buffer_get_iter_at_line(GTK_TEXT_BUFFER(body_buffer),
                                           &iter, ++i + t);
        }

        // metto il cursore all'inizio del body
        gtk_text_buffer_get_start_iter(GTK_TEXT_BUFFER(body_buffer), &iter);
        gtk_text_buffer_place_cursor(GTK_TEXT_BUFFER(body_buffer), &iter);

        free(buff);
        break;
      }
      // FORWARD
    case 2:
      {
        GtkTextIter iter;

        // struct email *p;
        char *buff;
        int i, t;

        // p = folder[0]->head;
        // for (i=0;i <n_mail;i++)
        // p = p->next;

        // prendo il subject e metto il Re:
        buff = (char *) malloc(sizeof(char) * (strlen(mail->subject) + 6));
        sprintf(buff, "Fwd: %s", mail->subject);
        gtk_entry_set_text(GTK_ENTRY(subject_entry), buff);


        // stampo qualche riga bianca all'inizio del body
        body_buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(body_textview));
        gtk_text_buffer_get_start_iter(GTK_TEXT_BUFFER(body_buffer), &iter);

        for (t = 0; t < 2; t++)
        {
          buff = strdup("\n");
          gtk_text_buffer_insert(GTK_TEXT_BUFFER(body_buffer), &iter, buff,
                                 strlen(buff));
          gtk_text_buffer_get_iter_at_line(GTK_TEXT_BUFFER(body_buffer),
                                           &iter, t + 1);
        }

        // stampo forwarded message
        buff =
          (char *) realloc(buff, sizeof(char) * (strlen(mail->from) + 20));
        sprintf(buff, "---------- Forwarded message ----------\n");
        gtk_text_buffer_insert(GTK_TEXT_BUFFER(body_buffer), &iter, buff,
                               strlen(buff));
        gtk_text_buffer_get_iter_at_line(GTK_TEXT_BUFFER(body_buffer), &iter,
                                         ++t);

        // un'altra riga bianca POI DOVREBBE STAMPARE GLI HEAD PRINCIPALI
        // DELLA MAIL
        buff = strdup("\n");
        gtk_text_buffer_insert(GTK_TEXT_BUFFER(body_buffer), &iter, buff,
                               strlen(buff));
        gtk_text_buffer_get_iter_at_line(GTK_TEXT_BUFFER(body_buffer), &iter,
                                         ++t);

        // stampo il body 
        i = 0;
        while (i < mail->body_lines)
        {
          buff =
            (char *) realloc(buff,
                             sizeof(char) * (strlen(mail->body[i]) + 5));
          sprintf(buff, "%s\n", mail->body[i]);
          // printa
          gtk_text_buffer_insert(GTK_TEXT_BUFFER(body_buffer), &iter, buff,
                                 strlen(buff));
          i++;
          gtk_text_buffer_get_iter_at_line(GTK_TEXT_BUFFER(body_buffer),
                                           &iter, i + t);
        }

        // metto il cursore all'inizio del body
        gtk_text_buffer_get_start_iter(GTK_TEXT_BUFFER(body_buffer), &iter);
        gtk_text_buffer_place_cursor(GTK_TEXT_BUFFER(body_buffer), &iter);

        free(buff);
        break;
      }

      // EDIT AS NEW
    case 3:
      {
        char *buff = (char *) malloc(sizeof(char));
        GtkTextIter iter;

        // struct email *p;
        int i = 0;

        // prendo il subject e metto il Re:
        body_buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(body_textview));
        gtk_entry_set_text(GTK_ENTRY(subject_entry), mail->subject);
        // gtk_text_buffer_get_start_iter(GTK_TEXT_BUFFER(body_buffer),
        // &iter);

        while (i < mail->body_lines)
        {
          gtk_text_buffer_get_iter_at_line(GTK_TEXT_BUFFER(body_buffer),
                                           &iter, i);
          buff =
            (char *) realloc(buff,
                             sizeof(char) * (strlen(mail->body[i]) + 5));
          sprintf(buff, "%s\n", mail->body[i]);
          // printa
          gtk_text_buffer_insert(GTK_TEXT_BUFFER(body_buffer), &iter, buff,
                                 strlen(buff));
          i++;
          gtk_text_buffer_get_iter_at_line(GTK_TEXT_BUFFER(body_buffer),
                                           &iter, i);
        }
        // metto il cursore all'inizio del body
        gtk_text_buffer_get_start_iter(GTK_TEXT_BUFFER(body_buffer), &iter);
        gtk_text_buffer_place_cursor(GTK_TEXT_BUFFER(body_buffer), &iter);

        break;
      }
      // compose to
    case 4:
      {
        gtk_entry_set_text(GTK_ENTRY(to_entry), mail->from);
      }
      break;
    default:
      printf("mode 0\n");
      break;
  }

  composebutton_vbox = gtk_vbox_new(TRUE, 0);
  gtk_widget_show(composebutton_vbox);
  gtk_box_pack_start(GTK_BOX(composemain_hbox), composebutton_vbox, FALSE,
                     TRUE, 0);
  gtk_widget_set_size_request(composebutton_vbox, 25, -1);

  postpone_button = gtk_button_new_with_mnemonic(_("P\nO\nS\nT\nP\nO\nN\nE"));
  gtk_widget_show(postpone_button);
  gtk_box_pack_start(GTK_BOX(composebutton_vbox), postpone_button, TRUE, TRUE,
                     0);

  send_button = gtk_button_new_with_mnemonic(_("S\nE\nN\nD"));
  gtk_widget_show(send_button);
  gtk_box_pack_start(GTK_BOX(composebutton_vbox), send_button, TRUE, TRUE, 0);

  cancel_button = gtk_button_new_with_mnemonic(_("D\nR\nO\nP"));
  gtk_widget_show(cancel_button);
  gtk_box_pack_start(GTK_BOX(composebutton_vbox), cancel_button, FALSE, TRUE,
                     0);

  g_signal_connect((gpointer) showattach_button, "clicked",
                   G_CALLBACK(on_showattach_button_clicked), NULL);

  g_signal_connect((gpointer) from_comboboxentry, "changed",
                   G_CALLBACK(on_from_changed), NULL);

  g_signal_connect((gpointer) addattach_button, "clicked",
                   G_CALLBACK(on_addattach_button_clicked), NULL);
  g_signal_connect((gpointer) delattach_button, "clicked",
                   G_CALLBACK(on_delattach_button_clicked), NULL);
  g_signal_connect((gpointer) cut_button, "clicked",
                   G_CALLBACK(on_cut_button_clicked), NULL);
  g_signal_connect((gpointer) copy_button, "clicked",
                   G_CALLBACK(on_copy_button_clicked), NULL);
  g_signal_connect((gpointer) paste_button, "clicked",
                   G_CALLBACK(on_paste_button_clicked), NULL);
  g_signal_connect((gpointer) selall_button, "clicked",
                   G_CALLBACK(on_selall_button_clicked), NULL);
  g_signal_connect((gpointer) delete_button, "clicked",
                   G_CALLBACK(on_delete_button_clicked), NULL);
  g_signal_connect((gpointer) clear_button, "clicked",
                   G_CALLBACK(on_clear_button_clicked), NULL);
  g_signal_connect((gpointer) fromfile_button, "clicked",
                   G_CALLBACK(on_fromfile_button_clicked), NULL);
  g_signal_connect((gpointer) postpone_button, "clicked",
                   G_CALLBACK(on_composeppone_button_clicked), NULL);
  g_signal_connect((gpointer) send_button, "clicked",
                   G_CALLBACK(on_composesend_button_clicked), NULL);
  g_signal_connect((gpointer) cancel_button, "clicked",
                   G_CALLBACK(on_cancel_button_clicked), compose_window);

  return compose_window;
}
