#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>
#include <glib.h>

#include "callbacks.h"
#include "support.h"


char *THEME;

/*
 *  struct for backnext windows
 */

struct backnext_pages
{
  GtkWidget *page;
  gchar *title;
  struct backnext_pages *prev, *next;
} *newacc_pages;

/*
 * mailwin.c
 */

GtkWidget *mail_window;

/*
 * mainwin.c 
 */

// quando si defocussa una windows
// bisognerebbe deselezionare la selezione
// 
// e Joshu chiese: "ma se la Via nn deve essere selezionata, come faccio ad
// aprirla?"
// al che Nansen rispose: "crtl+alt+canc".

struct folders *current_fold;
struct email *current_mail, *current_sent, *current_received;
struct contacts_group *current_group;
struct contacts *current_contact;
struct filters *current_filter;
struct accountlist *current_account;

GtkWidget *view_combobox;


// expander for plugins
GtkWidget *more_expander, *plugbox;
void plugin_main();


void mail_renderer();

GtkWidget *create_link(gchar * link, void *handler, struct email *mail);

GtkWidget *create_alert_dialog(char *alert);
GtkWidget *create_utility_bar();
GtkWidget *create_main_window(void);
GtkWidget *create_menubar(struct email *cur_mail);
GtkWidget *create_toolbar(struct email *cur_mail);
GtkWidget *create_mail_window(struct email *mail);
GtkWidget *create_settings_window(int page);
GtkWidget *create_compose_window(struct email *mail, int mode);
GtkWidget *create_parapass_window(void);
GtkWidget *create_accounts_window(void);
GtkWidget *create_contact_window(int mode);
GtkWidget *create_backnext_window(struct backnext_pages *pages,
                                  GtkWidget * finish_button3);
GtkWidget *create_addfilter_window (void);
GtkWidget *create_maillist_menu(void);
GtkWidget *create_foldlist_menu(void);
GtkWidget *create_mailaddress_menu(struct email *mail);
GtkWidget *create_mail_filechooserdialog(void);
GtkWidget *create_fast_contacts();
GtkWidget *smtpserver_entry;
GtkWidget *mail_filechooserdialog;
GtkWidget *settings_window;
GtkWidget *compose_window;
GtkWidget *parapass_window;
GtkWidget *accounts_window;
GtkWidget *contact_window;
GtkWidget *add_accounts_window;
GtkWidget *compose_window;
GtkWidget *main_statusbar;
GtkWidget *head_table;
GtkWidget *fold_box;
GtkWidget *maillist_menu;
GtkWidget *foldlist_menu;



GtkTextBuffer *selmail_buffer;
GtkWidget *mail_tree;
GtkWidget *fold_tree;
GtkTreeSelection *mail_sel;
GtkTreeSelection *fold_sel;
GtkWidget *progressbar, **progress;
GtkWidget *fold_store;
GtkWidget *mail_store;
guint context_id;
guint mess_id;
GtkWidget *real_label;
GtkWidget *preview_vbox;
GtkWidget *preview_viewport;

enum
{
  FOLD_ICON,
  FOLD_NAME,
  FOLD_NUM,
  FOLD,
  FOLD_NCOL
};

enum
{
  FILT_MUST,
  FILT_WHAT,
  FILT_WHERE,
  FILT,
  FILT_NCOL
};


enum
{
  MAIL_ATTACH,
  MAIL_DATE,
  MAIL_NEW,
  MAIL_FROM,
  MAIL_SUBJECT,
  MAIL,
  MAIL_SORT,
  MAIL_NCOL
};

/*
 * accountwin 
 */

GtkWidget *emailnick_entry;
GtkWidget *emailadd_entry;
GtkWidget *popserver_entry;
GtkWidget *popport_entry;
GtkWidget *poppass_entry;
GtkWidget *popproto_comboboxentry;
GtkWidget *keepon_checkbutton;
GtkWidget *popuser_entry;

/*
 * composewin 
 */

GtkWidget *from_comboboxentry;
GtkWidget *to_entry;
GtkWidget *compose_vpaned, *manual_label;
GtkWidget *cc_entry;
GtkWidget *bcc_entry;
GtkWidget *replyto_entry;
GtkWidget *subject_entry;
GtkWidget *manualfrom_entry;
GtkWidget *anon_togglebutton;
GtkWidget *sign_togglebutton;
GtkWidget *encrypt_togglebutton;
GtkWidget *body_textview;
GtkTextBuffer *body_buffer;
GtkWidget *hbox29;
GtkWidget *attach_scrolledwindow;
GtkWidget *att_image;
GtkWidget *showattach_button;
ushort attshow;
GtkWidget *attach_tree;






GtkWidget *delgroup_dialog;

/*
 * settingswin 
 */

GtkWidget *total_label, *unread_label;

GtkWidget *create_common_button_box(void *ok_handler, GtkWidget * window);


GtkWidget *create_smtp_table(void);
GtkWidget *smtpauth_table, *smtppass_entry, *smtpuser_entry;
GtkWidget *auth_checkbutton;

GtkWidget *themes_combobox;
struct backnext_pages *add_account_pages_new(void);
GtkWidget *create_twobutton_dialog(char *message, void *ok_handler);
GtkWidget *account_dialog;

GtkWidget *addacc_name_entry, *addacc_email_entry, *autoprobe_button;
GtkWidget *addacc_pop_entry, *addacc_port_entry, *pop_radiobutton,
  *imap_radiobutton, *ssl_radiobutton, *clear_radiobutton;
GtkWidget *username_entry, *password_entry;
GtkWidget *keep_radiobutton, *delete_radiobutton, *deldownload_radiobutton,
  *delI_radiobutton;
GtkWidget *title_textview, *info_table, *confirm_table;


GtkWidget *account_list;
GtkListStore *account_store;
GtkWidget *addacc_finish_button;

// questo si fa per ridere, naturlamentesi riscrivera'
GtkWidget *next_button;
GtkWidget *back_button;
GtkWidget *buio_label;

GtkWidget *newgroup_vbox;
GtkWidget *newgroup_entry;
GtkWidget *search_contact_entry;
GtkWidget *search_field_combobox;
GtkWidget *groups_tree;
GtkListStore *groups_list;
GtkWidget *contacts_tree;
GtkListStore *contacts_list;
GtkListStore *filters_list;
GtkWidget *filters_tree;
enum
{
  ACC_NAME,
  ACC_EMAIL,
  ACC_NCOL
};

enum
{
  CON_NAME,
  CON_EMAIL,
  CON_KEY,
  CONTACT,
  CON_NCOL
};

enum
{
  GROUP_NAME,
  GROUP,
  GROUP_NCOL
};

enum
{
  FILTER_NAME,
  FILTER,
  FILTER_NCOL
};


void on_about_activate(GtkWidget * item, gpointer user_data);
void on_back_button_clicked(GtkButton * button, struct backnext_pages *pages);

void on_next_button_clicked(GtkButton * button, struct backnext_pages *pages);

/*
 * contact win 
 */

GtkWidget *contactname_entry;
GtkWidget *contactmail_entry;
GtkWidget *search_entry;
GtkWidget *field_combobox;



/*
 * download win 
 */
pthread_cond_t pop3event;
byte down_flag;
GtkWidget *create_download_window();
