#include "../include.h"

GtkWidget *
create_mail_window(struct email * mail)
{
  GtkWidget *headers_table;
  GtkWidget *mailmain_vbox;
  GtkWidget *menubar;
  GtkWidget *central_hbox;
  GtkWidget *headers_vpaned;
  GtkWidget *mainhead_scrolledwindow;
  GtkWidget *mainhead_textview;
  GtkWidget *body_vpaned;
  GtkWidget *body_scrolledwindow;
  GtkWidget *body_textview;
  GtkWidget *toolbar2;
  GtkWidget *mail_statusbar;
  GtkTextBuffer *buffer;
  GtkTextIter iter;
  char buff[BUFFER_REAL];
  int i;

  mail_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_size_request(mail_window, 650, 550);
  gtk_window_set_title(GTK_WINDOW(mail_window), _(":: paranoy ::"));

  mailmain_vbox = gtk_vbox_new(FALSE, 0);
  gtk_widget_show(mailmain_vbox);
  gtk_container_add(GTK_CONTAINER(mail_window), mailmain_vbox);

  menubar = create_menubar(mail);
  gtk_box_pack_start(GTK_BOX(mailmain_vbox), menubar, FALSE, FALSE, 0);

  central_hbox = gtk_hbox_new(FALSE, 0);
  gtk_widget_show(central_hbox);
  gtk_box_pack_start(GTK_BOX(mailmain_vbox), central_hbox, TRUE, TRUE, 0);

  headers_vpaned = gtk_vpaned_new();
  gtk_widget_show(headers_vpaned);
  gtk_box_pack_start(GTK_BOX(central_hbox), headers_vpaned, TRUE, TRUE, 0);
  gtk_paned_set_position(GTK_PANED(headers_vpaned), 0);

  mainhead_scrolledwindow = gtk_scrolled_window_new(NULL, NULL);
  gtk_widget_show(mainhead_scrolledwindow);
  gtk_paned_pack1(GTK_PANED(headers_vpaned), mainhead_scrolledwindow, FALSE,
                  TRUE);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(mainhead_scrolledwindow),
                                 GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW
                                      (mainhead_scrolledwindow),
                                      GTK_SHADOW_ETCHED_IN);

  mainhead_textview = gtk_text_view_new();
  gtk_widget_show(mainhead_textview);
  gtk_container_add(GTK_CONTAINER(mainhead_scrolledwindow),
                    mainhead_textview);
  gtk_text_view_set_editable(GTK_TEXT_VIEW(mainhead_textview), FALSE);
  gtk_text_view_set_cursor_visible(GTK_TEXT_VIEW(mainhead_textview), FALSE);

  // metto gli headers
  i = 0;
  buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(mainhead_textview));
  gtk_text_buffer_get_start_iter(GTK_TEXT_BUFFER(buffer), &iter);

  while (i < mail->head_lines)
  {
    sprintf(buff, "%s\n", mail->header[i]);
    gtk_text_buffer_insert(GTK_TEXT_BUFFER(buffer),
                           &iter, buff, strlen(buff));
    gtk_text_buffer_get_iter_at_line(GTK_TEXT_BUFFER(buffer), &iter, ++i);
  }

  body_vpaned = gtk_vpaned_new();
  gtk_widget_show(body_vpaned);
  gtk_paned_pack2(GTK_PANED(headers_vpaned), body_vpaned, TRUE, TRUE);
  gtk_paned_set_position(GTK_PANED(body_vpaned), 80);

  body_scrolledwindow = gtk_scrolled_window_new(NULL, NULL);
  gtk_widget_show(body_scrolledwindow);
  gtk_paned_pack1(GTK_PANED(body_vpaned), body_scrolledwindow, FALSE, TRUE);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(body_scrolledwindow),
                                 GTK_POLICY_NEVER, GTK_POLICY_NEVER);
  gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW
                                      (body_scrolledwindow),
                                      GTK_SHADOW_ETCHED_IN);


  headers_table = create_table_headers(mail);
  gtk_widget_show(headers_table);
  // gtk_paned_pack1(GTK_PANED(body_vpaned), headers_table, TRUE, TRUE);
  gtk_container_add(GTK_CONTAINER(body_scrolledwindow), headers_table);

  body_scrolledwindow = gtk_scrolled_window_new(NULL, NULL);
  gtk_widget_show(body_scrolledwindow);
  gtk_paned_pack2(GTK_PANED(body_vpaned), body_scrolledwindow, TRUE, TRUE);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(body_scrolledwindow),
                                 GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW
                                      (body_scrolledwindow),
                                      GTK_SHADOW_ETCHED_IN);

  body_textview = gtk_text_view_new();
  gtk_widget_show(body_textview);
  gtk_container_add(GTK_CONTAINER(body_scrolledwindow), body_textview);
  gtk_text_view_set_editable(GTK_TEXT_VIEW(body_textview), FALSE);
  gtk_text_view_set_cursor_visible(GTK_TEXT_VIEW(body_textview), FALSE);
  // gtk_text_view_set_pixels_above_lines (GTK_TEXT_VIEW (body_textview), 5);
  // gtk_text_view_set_pixels_below_lines (GTK_TEXT_VIEW (body_textview), 5);
  gtk_text_view_set_left_margin(GTK_TEXT_VIEW(body_textview), 5);
  gtk_text_view_set_right_margin(GTK_TEXT_VIEW(body_textview), 5);

  // scrivo il body

  i = 0;
  buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(body_textview));
  gtk_text_buffer_get_start_iter(GTK_TEXT_BUFFER(buffer), &iter);

  while (i < mail->body_lines)
  {
    sprintf(buff, "%s\n", mail->body[i]);
    gtk_text_buffer_insert(GTK_TEXT_BUFFER(buffer),
                           &iter, buff, strlen(buff));
    gtk_text_buffer_get_iter_at_line(GTK_TEXT_BUFFER(buffer), &iter, ++i);
  }


  if (mail->type & NEW)
  {
    // mail = catch_mail_selection( GTK_LIST_STORE(fold_store),
    // GTK_TREE_VIEW(fold_tree) );
    // fold =
    // catch_fold_selection(GTK_LIST_STORE(fold_store),GTK_TREE_VIEW(fold_tree));
    mail->type -= NEW;
    current_fold->nnew--;
    write_index();

  }

  toolbar2 = create_toolbar(mail);
  gtk_box_pack_start(GTK_BOX(central_hbox), toolbar2, FALSE, FALSE, 0);

  mail_statusbar = gtk_statusbar_new();
  gtk_widget_show(mail_statusbar);
  gtk_box_pack_start(GTK_BOX(mailmain_vbox), mail_statusbar, FALSE, FALSE, 0);
  gtk_widget_grab_focus(menubar);
  gtk_widget_grab_default(menubar);

  return mail_window;
}

GtkWidget *
create_menubar(struct email * cur_mail)
{
  GtkWidget *menubar;
  GtkWidget *file_menuitem;
  GtkWidget *file_menuitem_menu;
  GtkWidget *new_menuitem;
  GtkWidget *new_menuitem_menu;
  GtkWidget *mail;
  GtkWidget *account;
  GtkWidget *folder;
  GtkWidget *separator5;
  GtkWidget *from_file;
  GtkWidget *postponed;
  GtkWidget *mail_to;
  GtkWidget *mail_to_menu;
  GtkWidget *menuitem5;
  GtkWidget *separator6;
  GtkWidget *get_mail_for;
  GtkWidget *get_mail_for_menu;
  GtkWidget *provafiglio;
  GtkWidget *separator7;
  GtkWidget *close_paranoy;
  GtkWidget *edit;
  GtkWidget *edit_menu;
  GtkWidget *cut;
  GtkWidget *copy;
  GtkWidget *paste;
  GtkWidget *delete_mail;
  GtkWidget *separator8;
  GtkWidget *select_all;
  GtkWidget *sort_mails;
  GtkWidget *sort_mails_menu;
  GtkWidget *item1;
  GtkWidget *separator9;
  GtkWidget *preferences;
  GtkWidget *view;
  GtkWidget *mails;
  GtkWidget *mails_menu;
  GtkWidget *new_mail;
  GtkWidget *separator11;
  GtkWidget *reply;
  GtkWidget *reply_all;
  GtkWidget *forward;
  GtkWidget *mail_as_new;
  GtkWidget *open_mail;
  GtkWidget *separator10;
  GtkWidget *filter_from_mail;
  GtkWidget *imagemenuitem7;
  GtkWidget *imagemenuitem7_menu;
  GtkWidget *menuitem10;
  GtkWidget *menuitem11;
  GtkWidget *menuitem12;
  GtkWidget *menuitem13;
  GtkWidget *menuitem14;
  GtkWidget *menuitem15;
  GtkWidget *menuitem16;
  GtkWidget *imagemenuitem8;
  GtkWidget *imagemenuitem8_menu;
  GtkWidget *menuitem17;
  GtkWidget *menuitem18;
  GtkWidget *menuitem19;
  GtkWidget *menuitem20;



  menubar = gtk_menu_bar_new();
  gtk_widget_show(menubar);

  GTK_WIDGET_SET_FLAGS(menubar, GTK_CAN_DEFAULT);

  file_menuitem = gtk_menu_item_new_with_mnemonic(_("_File"));
  gtk_widget_show(file_menuitem);
  gtk_container_add(GTK_CONTAINER(menubar), file_menuitem);

  file_menuitem_menu = gtk_menu_new();
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(file_menuitem), file_menuitem_menu);

  new_menuitem =
    gtk_menu_item_new_with_mnemonic(_("   New                             "));
  gtk_widget_show(new_menuitem);
  gtk_container_add(GTK_CONTAINER(file_menuitem_menu), new_menuitem);

  new_menuitem_menu = gtk_menu_new();
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(new_menuitem), new_menuitem_menu);

  mail = gtk_menu_item_new_with_mnemonic(_("   Mail"));
  gtk_widget_show(mail);
  gtk_container_add(GTK_CONTAINER(new_menuitem_menu), mail);

  account = gtk_menu_item_new_with_mnemonic(_("   Account"));
  gtk_widget_show(account);
  gtk_container_add(GTK_CONTAINER(new_menuitem_menu), account);

  folder = gtk_menu_item_new_with_mnemonic(_("   Folder"));
  gtk_widget_show(folder);
  gtk_container_add(GTK_CONTAINER(new_menuitem_menu), folder);

  separator5 = gtk_separator_menu_item_new();
  gtk_widget_show(separator5);
  gtk_container_add(GTK_CONTAINER(file_menuitem_menu), separator5);
  gtk_widget_set_sensitive(separator5, FALSE);

  from_file = gtk_menu_item_new_with_mnemonic(_("   Mail from file"));
  gtk_widget_show(from_file);
  gtk_container_add(GTK_CONTAINER(file_menuitem_menu), from_file);

  postponed = gtk_menu_item_new_with_mnemonic(_("   Postponed mail"));
  gtk_widget_show(postponed);
  gtk_container_add(GTK_CONTAINER(file_menuitem_menu), postponed);

  mail_to = gtk_menu_item_new_with_mnemonic(_("   Mail to"));
  gtk_widget_show(mail_to);
  gtk_container_add(GTK_CONTAINER(file_menuitem_menu), mail_to);

  mail_to_menu = gtk_menu_new();
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(mail_to), mail_to_menu);

  menuitem5 = gtk_menu_item_new_with_mnemonic(_("   prova figlio"));
  gtk_widget_show(menuitem5);
  gtk_container_add(GTK_CONTAINER(mail_to_menu), menuitem5);

  separator6 = gtk_separator_menu_item_new();
  gtk_widget_show(separator6);
  gtk_container_add(GTK_CONTAINER(file_menuitem_menu), separator6);
  gtk_widget_set_sensitive(separator6, FALSE);

  get_mail_for = gtk_menu_item_new_with_mnemonic(_("   Get mail for"));
  gtk_widget_show(get_mail_for);
  gtk_container_add(GTK_CONTAINER(file_menuitem_menu), get_mail_for);

  get_mail_for_menu = gtk_menu_new();
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(get_mail_for), get_mail_for_menu);

  provafiglio = gtk_menu_item_new_with_mnemonic(_("   provafiglio"));
  gtk_widget_show(provafiglio);
  gtk_container_add(GTK_CONTAINER(get_mail_for_menu), provafiglio);

  separator7 = gtk_separator_menu_item_new();
  gtk_widget_show(separator7);
  gtk_container_add(GTK_CONTAINER(file_menuitem_menu), separator7);
  gtk_widget_set_sensitive(separator7, FALSE);

  close_paranoy = gtk_menu_item_new_with_mnemonic(_("   Close paranoy"));
  gtk_widget_show(close_paranoy);
  gtk_container_add(GTK_CONTAINER(file_menuitem_menu), close_paranoy);

  edit = gtk_menu_item_new_with_mnemonic(_("_Edit"));
  gtk_widget_show(edit);
  gtk_container_add(GTK_CONTAINER(menubar), edit);

  edit_menu = gtk_menu_new();
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(edit), edit_menu);

  cut = gtk_menu_item_new_with_mnemonic(_("   Cut "));
  gtk_widget_show(cut);
  gtk_container_add(GTK_CONTAINER(edit_menu), cut);

  copy = gtk_menu_item_new_with_mnemonic(_("   Copy "));
  gtk_widget_show(copy);
  gtk_container_add(GTK_CONTAINER(edit_menu), copy);

  paste = gtk_menu_item_new_with_mnemonic(_("   Paste"));
  gtk_widget_show(paste);
  gtk_container_add(GTK_CONTAINER(edit_menu), paste);

  delete_mail =
    gtk_menu_item_new_with_mnemonic(_("   Delete Mail           Del    "));
  gtk_widget_show(delete_mail);
  gtk_container_add(GTK_CONTAINER(edit_menu), delete_mail);

  separator8 = gtk_separator_menu_item_new();
  gtk_widget_show(separator8);
  gtk_container_add(GTK_CONTAINER(edit_menu), separator8);
  gtk_widget_set_sensitive(separator8, FALSE);

  select_all = gtk_menu_item_new_with_mnemonic(_("   Select all"));
  gtk_widget_show(select_all);
  gtk_container_add(GTK_CONTAINER(edit_menu), select_all);

  sort_mails = gtk_menu_item_new_with_mnemonic(_("   Sort Mails"));
  gtk_widget_show(sort_mails);
  gtk_container_add(GTK_CONTAINER(edit_menu), sort_mails);

  sort_mails_menu = gtk_menu_new();
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(sort_mails), sort_mails_menu);

  item1 = gtk_menu_item_new_with_mnemonic(_("   item2"));
  gtk_widget_show(item1);
  gtk_container_add(GTK_CONTAINER(sort_mails_menu), item1);

  separator9 = gtk_separator_menu_item_new();
  gtk_widget_show(separator9);
  gtk_container_add(GTK_CONTAINER(edit_menu), separator9);
  gtk_widget_set_sensitive(separator9, FALSE);

  preferences = gtk_menu_item_new_with_mnemonic(_("   Preferences"));
  gtk_widget_show(preferences);
  gtk_container_add(GTK_CONTAINER(edit_menu), preferences);

  view = gtk_menu_item_new_with_mnemonic(_("_View"));
  gtk_widget_show(view);
  gtk_container_add(GTK_CONTAINER(menubar), view);

  mails = gtk_menu_item_new_with_mnemonic(_("_Mails"));
  gtk_widget_show(mails);
  gtk_container_add(GTK_CONTAINER(menubar), mails);

  mails_menu = gtk_menu_new();
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(mails), mails_menu);

  new_mail = gtk_menu_item_new_with_mnemonic(_("   New Mail"));
  gtk_widget_show(new_mail);
  gtk_container_add(GTK_CONTAINER(mails_menu), new_mail);

  separator11 = gtk_separator_menu_item_new();
  gtk_widget_show(separator11);
  gtk_container_add(GTK_CONTAINER(mails_menu), separator11);
  gtk_widget_set_sensitive(separator11, FALSE);

  reply = gtk_menu_item_new_with_mnemonic(_("   Reply"));
  gtk_widget_show(reply);
  gtk_container_add(GTK_CONTAINER(mails_menu), reply);

  reply_all = gtk_menu_item_new_with_mnemonic(_("   Reply all"));
  gtk_widget_show(reply_all);
  gtk_container_add(GTK_CONTAINER(mails_menu), reply_all);

  forward = gtk_menu_item_new_with_mnemonic(_("   Forward"));
  gtk_widget_show(forward);
  gtk_container_add(GTK_CONTAINER(mails_menu), forward);

  mail_as_new =
    gtk_menu_item_new_with_mnemonic(_
                                    ("   Edit mail as new         CTRL+M  "));
  gtk_widget_show(mail_as_new);
  gtk_container_add(GTK_CONTAINER(mails_menu), mail_as_new);

  open_mail = gtk_menu_item_new_with_mnemonic(_("   Open mail"));
  gtk_widget_show(open_mail);
  gtk_container_add(GTK_CONTAINER(mails_menu), open_mail);

  separator10 = gtk_separator_menu_item_new();
  gtk_widget_show(separator10);
  gtk_container_add(GTK_CONTAINER(mails_menu), separator10);
  gtk_widget_set_sensitive(separator10, FALSE);

  filter_from_mail =
    gtk_menu_item_new_with_mnemonic(_("   Filter from mail"));
  gtk_widget_show(filter_from_mail);
  gtk_container_add(GTK_CONTAINER(mails_menu), filter_from_mail);

  imagemenuitem7 = gtk_menu_item_new_with_mnemonic(_("_Settings"));
  gtk_widget_show(imagemenuitem7);
  gtk_container_add(GTK_CONTAINER(menubar), imagemenuitem7);

  imagemenuitem7_menu = gtk_menu_new();
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(imagemenuitem7),
                            imagemenuitem7_menu);

  menuitem12 = gtk_menu_item_new_with_mnemonic(_("   General options   "));
  gtk_widget_show(menuitem12);
  gtk_container_add(GTK_CONTAINER(imagemenuitem7_menu), menuitem12);

  menuitem10 = gtk_menu_item_new_with_mnemonic(_("   Accounts"));
  gtk_widget_show(menuitem10);
  gtk_container_add(GTK_CONTAINER(imagemenuitem7_menu), menuitem10);

  menuitem11 = gtk_menu_item_new_with_mnemonic(_("   Contacts"));
  gtk_widget_show(menuitem11);
  gtk_container_add(GTK_CONTAINER(imagemenuitem7_menu), menuitem11);

  menuitem13 = gtk_menu_item_new_with_mnemonic(_("   Filters"));
  gtk_widget_show(menuitem13);
  gtk_container_add(GTK_CONTAINER(imagemenuitem7_menu), menuitem13);

  menuitem14 = gtk_menu_item_new_with_mnemonic(_("   PGP"));
  gtk_widget_show(menuitem14);
  gtk_container_add(GTK_CONTAINER(imagemenuitem7_menu), menuitem14);

  menuitem15 = gtk_menu_item_new_with_mnemonic(_("   Security"));
  gtk_widget_show(menuitem15);
  gtk_container_add(GTK_CONTAINER(imagemenuitem7_menu), menuitem15);

  menuitem16 = gtk_menu_item_new_with_mnemonic(_("   Anonimity"));
  gtk_widget_show(menuitem16);
  gtk_container_add(GTK_CONTAINER(imagemenuitem7_menu), menuitem16);

  separator8 = gtk_separator_menu_item_new();
  gtk_widget_show(separator8);
  gtk_container_add(GTK_CONTAINER(imagemenuitem7_menu), separator8);
  gtk_widget_set_sensitive(separator8, FALSE);

  menuitem16 = gtk_menu_item_new_with_mnemonic(_("   Wizard Configure   "));
  gtk_widget_show(menuitem16);
  gtk_container_add(GTK_CONTAINER(imagemenuitem7_menu), menuitem16);

  imagemenuitem8 = gtk_menu_item_new_with_mnemonic(_("_Help"));
  gtk_widget_show(imagemenuitem8);
  gtk_container_add(GTK_CONTAINER(menubar), imagemenuitem8);

  imagemenuitem8_menu = gtk_menu_new();
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(imagemenuitem8),
                            imagemenuitem8_menu);

  menuitem17 = gtk_menu_item_new_with_mnemonic(_("   Help paranoy   "));
  gtk_widget_show(menuitem17);
  gtk_container_add(GTK_CONTAINER(imagemenuitem8_menu), menuitem17);

  menuitem18 = gtk_menu_item_new_with_mnemonic(_("   Help PGP"));
  gtk_widget_show(menuitem18);
  gtk_container_add(GTK_CONTAINER(imagemenuitem8_menu), menuitem18);

  menuitem19 =
    gtk_menu_item_new_with_mnemonic(_("   What is the E-mail?     "));
  gtk_widget_show(menuitem19);
  gtk_container_add(GTK_CONTAINER(imagemenuitem8_menu), menuitem19);

  menuitem20 = gtk_menu_item_new_with_mnemonic(_("   About paranoy"));
  gtk_widget_show(menuitem20);
  gtk_container_add(GTK_CONTAINER(imagemenuitem8_menu), menuitem20);



  g_signal_connect((gpointer) mail, "activate",
                   G_CALLBACK(on_new_mail_activate), NULL);
  g_signal_connect((gpointer) account, "activate",
                   G_CALLBACK(on_addaccount_button_clicked), NULL);
  g_signal_connect((gpointer) folder, "activate",
                   G_CALLBACK(on_new_folder_activate), NULL);
  g_signal_connect((gpointer) from_file, "activate",
                   G_CALLBACK(on_from_file_activate), NULL);
  g_signal_connect((gpointer) postponed, "activate",
                   G_CALLBACK(on_posponed_mail_activate), NULL);
  g_signal_connect((gpointer) mail_to, "activate",
                   G_CALLBACK(on_contacts_menu_activate), NULL);
  g_signal_connect((gpointer) menuitem5, "activate",
                   G_CALLBACK(on_prova_figlio1_activate), NULL);
  g_signal_connect((gpointer) provafiglio, "activate",
                   G_CALLBACK(on_get_mail_activate), NULL);
  g_signal_connect((gpointer) close_paranoy, "activate",
                   G_CALLBACK(on_mainquit_button_clicked), NULL);
  g_signal_connect((gpointer) cut, "activate",
                   G_CALLBACK(on_cut_activate), NULL);
  g_signal_connect((gpointer) copy, "activate",
                   G_CALLBACK(on_copy_activate), NULL);
  g_signal_connect((gpointer) paste, "activate",
                   G_CALLBACK(on_paste_activate), NULL);
  g_signal_connect((gpointer) delete_mail, "activate",
                   G_CALLBACK(on_delete_mail_activate), NULL);
  g_signal_connect((gpointer) select_all, "activate",
                   G_CALLBACK(on_select_all_activate), NULL);
  g_signal_connect((gpointer) item1, "activate",
                   G_CALLBACK(on_item1_activate), NULL);
  g_signal_connect((gpointer) preferences, "activate",
                   G_CALLBACK(on_preferences_activate), NULL);
  g_signal_connect((gpointer) view, "activate",
                   G_CALLBACK(on_view_activate), NULL);
  g_signal_connect((gpointer) mails, "activate",
                   G_CALLBACK(on_mails_activate), NULL);
  g_signal_connect((gpointer) new_mail, "activate",
                   G_CALLBACK(on_new_mail_activate), NULL);
  g_signal_connect((gpointer) reply, "activate",
                   G_CALLBACK(on_reply_button_clicked), (gpointer) cur_mail);
  g_signal_connect((gpointer) reply_all, "activate",
                   G_CALLBACK(on_replyall_button_clicked),
                   (gpointer) cur_mail);
  g_signal_connect((gpointer) forward, "activate",
                   G_CALLBACK(on_forward_button_clicked),
                   (gpointer) cur_mail);
  g_signal_connect((gpointer) mail_as_new, "activate",
                   G_CALLBACK(on_edit_as_new_activate), NULL);
  g_signal_connect((gpointer) open_mail, "activate",
                   G_CALLBACK(on_open_mail_activate), 0);
  g_signal_connect((gpointer) filter_from_mail, "activate",
                   G_CALLBACK(on_filter_from_mail_activate), NULL);
  g_signal_connect((gpointer) menuitem10, "activate",
                   G_CALLBACK(on_accounts_activate), NULL);
  g_signal_connect((gpointer) menuitem11, "activate",
                   G_CALLBACK(on_contacts_activate), NULL);
  g_signal_connect((gpointer) menuitem12, "activate",
                   G_CALLBACK(on_general_options_activate), NULL);
  g_signal_connect((gpointer) menuitem13, "activate",
                   G_CALLBACK(on_filters_activate), NULL);
  g_signal_connect((gpointer) menuitem14, "activate",
                   G_CALLBACK(on_pgp_item_activate), NULL);
  g_signal_connect((gpointer) menuitem15, "activate",
                   G_CALLBACK(on_security_activate), NULL);
  g_signal_connect((gpointer) menuitem16, "activate",
                   G_CALLBACK(on_anonimity_activate), NULL);
  g_signal_connect((gpointer) menuitem17, "activate",
                   G_CALLBACK(on_help_paranoy1_activate), NULL);
  g_signal_connect((gpointer) menuitem18, "activate",
                   G_CALLBACK(on_help_pgp_activate), NULL);
  g_signal_connect((gpointer) menuitem19, "activate",
                   G_CALLBACK(on_about_email_activate), NULL);
  g_signal_connect((gpointer) menuitem20, "activate",
                   G_CALLBACK(on_about_activate), NULL);


  return menubar;
}
