/*
 * Copyright (C) 2003  
 * paranoy project - paranox.sf.net - paranoy@autistici.org
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

#include "include.h"

#define POP3_OK 0
#define POP3_ERROR 1



// return the connection with c->err set and with socket not still closed
struct connection *
pop3_session(struct accountlist *a)
{
  struct connection *c = NULL;
  char buff[BUFFER_REAL];
  ushort n = 0, i = 1;
  struct email *mail = NULL;
  struct folders *fold = NULL;
  struct filters *filter = NULL;

  // ushort *msg=NULL;
  char *banner = NULL;

  struct lista
  {
    ushort i;
    char *uidl;
    struct lista *next;
  } *mlist = NULL;

  c = (struct connection *) smalloc(sizeof(struct connection));
  c->sbio = NULL;
  c->err = NO_ERROR;

  info(0, "  -[ Connecting to %s ... -] ", a->host);

  // control if connection estabilished
  if (para_connect
      (c, a->host, a->port,
       (a->proto == POP3_FORCE_SSL_PROTO
        || a->proto == POP3_SSL_PROTO) ? SSL_CONNECTION : CLEAR_CONNECTION))
  {
    info(2, "Error while connecting to %s:%d", a->host, a->port);
    free(c);
    c = NULL;
    return c;
  }

  info(0, "Connected...reading banner");

  // read banner
  if (para_read(c, buff, BUFFER_LEN) < 0)
  {
    info(2, "  -[ Error while reading pop3 banner ]-");
    return c;
  }

  /*
   * if (a->nopass == 1 && a->pass == NULL) { downpass = 1; info(0, "Insert
   * the password for %s: ", a->email); wgetnstr(winfo, buff, BUFFER_LEN);
   * a->pass = _malloc(strlen(buff) + 1); _mempcpy(a->pass, buff,
   * strlen(buff)); downpass = 0; } 
   */
  info(0, "  -[ Authenticating... ]-");

  // apop auth
  if ((banner = apop_banner(buff)) != NULL)
  {

    if (pop3_apop_login(c, a, banner) != NO_ERROR)
    {
      // info(0,
      // "Apop authentication failed......reconnecting with normal
      // authentication\n");
      para_close(c);
      if (para_connect
          (c, a->host, a->port,
           (a->proto == POP3_FORCE_SSL_PROTO
            || a->proto ==
            POP3_SSL_PROTO) ? SSL_CONNECTION : CLEAR_CONNECTION))
      {
        info(2, "Error while connecting to %s:%d\n", a->host, a->port);
        free(c);
        c = NULL;
        return c;
      }

      info(0, "  -[ Connected... ]-");
      // read banner
      if (para_read(c, buff, BUFFER_LEN) < 0)
      {
        info(2, "Error while reading pop3 banner\n");
        return c;
      }
      info(0, "Logging... ");
      c->err = pop3_login(c, a);

    }
  } else if (pop3_login(c, a) != NO_ERROR)
  {
    info(2, "  -[ Error in authentication ]-");
    return c;
  }


  /*
   * AFTER AUTHENTICATION 
   */
  info(0, "  -[ Sending UIDL ]-");
  snprintf(buff, BUFFER_LEN, "UIDL\r\n");

  para_write(c, buff);
  recvline(c, buff, BUFFER_LEN);

  // server don't supports UIDL command TODO
  if (strncmp(buff, "+OK", 3))
  {
    info(0, "  -[ Error while sending UIDL: %s ]-", buff);
    logg("pop3 - server doesn't support uidl command, not good\n");

    // info(0, "Sending STAT\n");
    // c->state = POP3_STAT;
    // snprintf(buff, BUFFER_LEN, "STAT\r\n");
    // pop3_query(c, buff);

    // here buff is "+OK numofmails numofoctects"
    // if (strncmp(buff, "+OK", 3))
    // {
    // info(1, "Error while sending STAT: %s", buff);
    // return c;
    // }
    // strcpy(buff, buff + 4);
    // strip the octects
    // size = atoi(strchr(cs, ' '));
    // logg("il size trovato e' %d\n", size);

    // put a NULL after the number of email 
    // memcpy(strchr(buff, ' '), "\0", 1);
    // n = atoi(buff);

    return c;
  }
  // server support UIDL command
  else
  {
    char *p;
    struct stat file_stat;
    struct lista *cur;

    logg("pop3 - server supports uidl command\n");
    recvline(c, buff, BUFFER_LEN);

    // reads each lines returned
    while (buff[0] != '.')
    {
      // buff = "n uidl,S=byte"
      p = strchr(buff, ' ');
      *p = 0;
      p++;
      MD5String(p);
      // not exists (adding to list)
      if (stat(p, &file_stat) == -1)
      {
        cur = (struct lista *) smalloc(sizeof(struct lista));
        cur->next = mlist;
        cur->i = atoi(buff);
        cur->uidl = strdup(p);
        if (!cur->uidl)
          end("Not enough memory! Please kill some program!\n");
        // logg("pop3 - mail %d is new\n", cur->i);
        mlist = cur;
        n++;
      }
      // else
      // logg("pop3 - mail %d is NOT new\n", atoi(buff));

      recvline(c, buff, BUFFER_LEN);
    }
  }

  logg("pop3 - there are %d messages to download\n", n);


  // no messages
  if (!n)
  {
    info(0, "-[ No messages ]-");
#ifdef USE_GTK
    if (gui == GTK)
    {
      gtk_progress_bar_set_fraction((GtkProgressBar *) progressbar,
                                    (gdouble) 100);
      gtk_progress_bar_set_text((GtkProgressBar *) progressbar,
                                _(" -[ No messages ]-"));
      // pthread_cond_signal(&pop3event);
    }
#endif


    return c;
  }
  // msg = (ushort *) malloc(sizeof(ushort) * n);

  c->state = POP3_RETR;


  // for each message
  while (mlist)
  {

    mail = (struct email *) smalloc(sizeof(struct email));
    mail->from = NULL;
    mail->subject = NULL;
    mail->body = NULL;
    mail->header = NULL;
    mail->to = NULL;
    mail->nto = 0;
    mail->bcc = NULL;
    mail->nbcc = 0;
    mail->date = NULL;
    mail->hlen = 0;
    mail->len = 0;
    mail->level = 0;
    mail->row_len = NULL;
    mail->messageid = NULL;
    mail->inreplyto = NULL;
    mail->attach = NULL;
    mail->boundary = NULL;
    mail->type = NEW;
    mail->nattach = 0;
    mail->mime = NOMIME;
    mail->body_lines = 0;
    mail->head_lines = 0;

    mail->uidl = strdup(mlist->uidl);


    // if (!mail->uidl)
    // end("Not enough memory! Please kill some program!\n");

    info(0, "  -[ Downloading %d/%d message ]-", i, n);
#ifdef USE_GTK
    if (gui == GTK)
    {
      gtk_progress_bar_set_fraction((GtkProgressBar *) progressbar,
                                    (gdouble) i / n);
      snprintf(buff, BUFFER_LEN, " -[ Downloading %d of %d emails ]-", i, n);
      gtk_progress_bar_set_text((GtkProgressBar *) progressbar, _(buff));

      pthread_cond_signal(&pop3event);
    }
#endif

    sprintf(buff, "TOP %d 0\r\n", mlist->i);
    para_write(c, buff);

    if (recvline(c, buff, BUFFER_LEN) < 0)
    {
      info(0, "  -[ Error while retrieving headers -]");
      c->err = GENERIC_ERROR;
      return c;
    }

    if (strncmp(buff, "+OK", 3))
    {
      info(0, "  -[ Error while retrieving headers: %s ]-", buff);
      c->err = GENERIC_ERROR;
      return c;
    }
    // logg("pop3 - before filterz\n");
    filter = filterz(c, mail);
    logg("pop3 - dopo filterz\n");

    if (filter != NULL)
      strncpy(buff, filter->where, BUFFER_LEN);
    else
      strncpy(buff, "Inbox", BUFFER_LEN);

    // this is spam
    if (!strcmp(buff, "porkoddiodiunospammaledetto"))
    {
      pop3_dele(c, mlist->i);
      continue;
    } else
    {
      fold = search_folder(buff);

      // create a new folder
      if (!fold)
        fold = new_folder(buff);

      if (!fold)
      {
        info(0, "  -[ Error while creating new folder to store emails ]-");
        c->err = GENERIC_ERROR;
        return c;
      }

      logg("pop3 - before pop3_retr of %d", mlist->i, mail->body_lines);
      pop3_retr(c, mlist->i, mail);
      logg("pop3 - after pop3_retr of %d , %d rows\n", mlist->i,
           mail->body_lines);
      logg("prima di controllare il mail->boundary %p\n", mail->boundary);
      if (mail->boundary)
      {
        logg("Sono dentro l'if\n");
        logg("pop3 - doing parse_attach perke' il boundary e' '%s'\n",
             mail->boundary);
        parse_attach(mail, strlen(mail->boundary));
        logg("pop3 - numero di allegati %d, txt_attach = %d\n", mail->nattach,
             mail->txt_attach);
      }
      // write mail in file
      // logg("prima di save mail nline = %d\n", mail->nline);
      logg("prima di save_mail\n");
      save_mail(mail, 0);
      logg("sono dopo save_mail\n");
      // debug (questo va ragionato)
      write_index(NULL);
      logg("dopo write index\n");

      logg("pop3 - free_mail_body\n");
      free_mail_body(mail);

      logg("pop3 - adding mail\n");
      add_mail(fold, mail);
    }
    i++;
    mlist = mlist->next;
  }

  logg("pop3 - write_index\n");
  write_index(NULL);

  info(0, "  -[ Download completed ]-");
#ifdef USE_GTK
  if (gui == GTK)
  {
    // gtk_progress_bar_set_fraction((GtkProgressBar *) progressbar, 0);
    print_folders();
    print_contacts();
  }
#endif
  pop3_quit(c);
  free(c);
  return NULL;
}

byte
pop3_apop_login(struct connection * c, struct accountlist * a,
                char *apop_banner)
{
  char buff[BUFFER_REAL];
  char md5sum[33];
  char *p = _return(a->pass);

  logg("dentro apop_login con banner='%s' e user='%s' e pass='%s'\n",
       apop_banner, a->user, p);
  snprintf(buff, BUFFER_LEN, "%s%s", apop_banner, (char *) _return(a->pass));
  logg("calcolo l'md5 di '%s'\n", buff);
  strcpy(md5sum, MD5String(buff));
  snprintf(buff, BUFFER_LEN, "APOP %s %s\r\n", a->user, md5sum);
  logg("apop login .. mando '%s'\n", buff);
  para_write(c, buff);
  free(p);
  if (para_read(c, buff, BUFFER_LEN) < 0)
  {
    logg("porcodio dpopo apop nn leggo una sega...\n");
    return LOGIN_ERROR;
  }
  logg("dopo apop leggo '%s'\n", buff);
  if (strncmp(buff, "+OK", 3))
    return LOGIN_ERROR;
  return NO_ERROR;
}

byte
pop3_login(struct connection * c, struct accountlist * a)
{
  char buff[BUFFER_REAL];

  snprintf(buff, BUFFER_LEN, "USER %s\r\n", a->user);
  para_write(c, buff);
  if (recvline(c, buff, BUFFER_LEN) < 0)
  {
    logg("Aleggo come risposta all'user '%s'\n", buff);
    return LOGIN_ERROR;
  }
  logg("leggo come risposta all'user '%s'\n", buff);
  if (strncmp(buff, "+OK", 3))
    return LOGIN_ERROR;

  snprintf(buff, BUFFER_LEN, "PASS %s\r\n", (char *) _return(a->pass));
  para_write(c, buff);
  if (recvline(c, buff, BUFFER_LEN) < 0)
  {
    logg("A leggo come risposta alla pass '%s'\n", buff);
    return LOGIN_ERROR;
  }
  logg("leggo come risposta alla pass '%s'\n", buff);
  if (strncmp(buff, "+OK", 3))
    return LOGIN_ERROR;
  return NO_ERROR;
}

byte
pop3_retr(struct connection * c, ushort n, struct email * mail)
{
  ushort i = 0;
  int l;
  char buff[BUFFER_REAL];


  logg("vado di retr\n");

  // send the request
  snprintf(buff, BUFFER_LEN, "RETR %d\r\n", n);
  para_write(c, buff);

  logg("dopo para_write\n");

  // check the +OK
  if (recvline(c, buff, BUFFER_LEN) < 0)
  {
    info(1, "  -[ Error while sending RETR ]-");
    return SOCKET_READ_ERROR;
  }
  logg("dopo il parse dell'ok con la mail %d '%s'\n", n, buff);

  if (strncmp(buff, "+OK", 3))
  {
    info(1, "  -[ Error while sending RETR ]-");
    return SOCKET_READ_ERROR;
  }

  logg("dopo il parse dell'ok2\n");


  // read email
  l = recvline(c, buff, BUFFER_LEN);

  logg("ho iniziato di leggere gli headers %d '%s'\n", l, buff);

  // salta gli headers (gia' salvati)
  while (buff[0])
  {
    l = recvline(c, buff, BUFFER_LEN);
    logg("headers %d '%s'\n", l, buff);
  }
  logg("ho finito di leggere gli headers\n");

  // read all body
  mail->body = (char **) smalloc(sizeof(char *));
  mail->row_len = (ushort *) malloc(sizeof(ushort));

  l = recvline(c, buff, BUFFER_LEN);
  logg("-- body %d '%s'\n", l, buff);

  while (!(buff[0] == '.' && l == 1))
  {
    mail->len += l;

    mail->body =
      (char **) realloc((char **) mail->body, sizeof(char *) * (i + 2));
    mail->row_len =
      (ushort *) realloc((ushort *) mail->row_len, sizeof(ushort) * (i + 2));
    mail->body[i] = strdup(buff);

    mail->row_len[i] = (ushort) l;

    l = recvline(c, buff, BUFFER_LEN);
    logg("-- body %d '%s'\n", l, buff);
    i++;
  }
  logg("dopo il while\n");
  mail->body_lines = i;
  // mail->row_len[i + 1] = 0;
  logg("ho trovato %i righe\n", i);


  return POP3_OK;
}



byte
pop3_dele(struct connection * c, ushort n)
{
  char buff[BUFFER_REAL];

  snprintf(buff, BUFFER_LEN, "DELE %d\r\n", n);
  pop3_query(c, buff);
  return c->err;
}

byte
pop3_quit(struct connection * c)
{
  char buff[BUFFER_LEN] = "QUIT\r\n";

  logg("mandando la query ricevo '%s'\n", pop3_query(c, buff));
  logg("Closing connection\n");
  para_close(c);
  logg("dopo para_close\n");
  return 0;
}

char *
apop_banner(char *banner)
{
  char *init;

  init = strstr(banner, "<");
  if (init != NULL)
  {
    *(strstr(init, "\r")) = 0;
    logg("dentro apop_banner il banner trovato e' '%s'\n", init);
    return init;
  }
  return NULL;
}

char *
pop3_query(struct connection *c, char *query)
{
  // send query
  if (para_write(c, query) < 0)
    return NULL;
  // read answer
  if (para_read(c, query, BUFFER_LEN) < 0)
    return NULL;
  return query;
}

byte
pop3_error(char *err)
{
  logg("L'errore ke arriva dal pop3 e' %s\n", err);
  return POP3_ERROR;
}


// keep the capatibilies of the pop3 server
void
capa(struct connection *conn, struct accountlist *acc)
{
  // send CAPA to the server to keep the capabalities of the pop3
  // server

}

// only to read headers (must return 0 if headers ends)
ushort
pop3_recv_line(struct connection *c, char *buff, ushort len)
{
  // qui e' il problema 
  static int i = 1;
  static char s_buff[BUFFER_REAL];
  ushort l = 0, t = 0;

  logg("Dentro pop3_recv_line\n");

  // prima volta
  if (i)
  {
    logg("\tprima volta dentro pop3_recv_line\n");
    i = 0;
    recvline(c, s_buff, BUFFER_LEN);
  }

  if (s_buff[0] == '.' && s_buff[1] == 0)
  {
    logg("\tUltima esecuzione\n");
    strcpy(buff, ".\n");
    i = 1;
    return 1;
  }
  logg("\tDENTRO pop3c dpo gli if s_buff='%s'\n", s_buff);
  l = strlen(s_buff);
  memcpy(buff, s_buff, sizeof(char) * l);
  buff[l] = 0;
  logg("\tDENTRO prima del recvlines\n");

  t = recvline(c, s_buff, BUFFER_LEN);

  logg("\tDENTRO pop3c prima del while ho letto %d chars -> '%s'\n", t,
       s_buff);

  while ((s_buff[0] == ' ' || s_buff[0] == '\t') && t != 1)
  {
    logg
      ("\tsono dentro il while del pop3_recv_line e ho trovato una riga da riporto\n");
    l += t;
    strncat(buff, s_buff + 1, BUFFER_LEN);
    t = recvline(c, s_buff, BUFFER_LEN);
  }
  logg("\tdentro pop3_recv_line %d buff diventa '%s'\n", l, buff);
  return l;
}
