/*
 * Copyright (C) 2003  
 * paranoy project - paranox.sf.net - paranoy@autistici.org
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

#include "include.h"

#define PAD	"="
// tabella Base64
char base64[64] = {
  'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M',
  'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z',
  'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm',
  'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z',
  '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '+', '/'
};

// encode from (ASCII) to a base64 format (for MIME encoding...rfc 1521);
char *
base64_encode(char *to, char *from)
{
  char f[3];
  char t[4];
  unsigned int i = 0, count = 0;

  // static int l = 0;

  count = strlen(from) / 3;

  for (i = 0; i < count; i++)
  {
    strncpy(f, from + i * 3, 3);

    /*
     * ASCII -> 8bits 11111111 11111111 00000000 
     * Base64 -> 6bits 111111   000011   110000   111111 
     */

    t[0] = (f[0] & 0xFC) >> 2;
    t[1] = ((f[0] & 0x03) << 4) | ((f[1] & 0xF0) >> 4);
    t[2] = ((f[1] & 0x0F) << 2) | ((f[2] & 0xC0) >> 6);
    t[3] = f[2] & 0x3F;

    to[i * 4] = base64[(int) t[0]];
    to[i * 4 + 1] = base64[(int) t[1]];
    to[i * 4 + 2] = base64[(int) t[2]];
    to[i * 4 + 3] = base64[(int) t[3]];

  }
  to[(i-1)*4+4] = 0;
  return to;
}

// decode from (base64) to an ASCII format (for MIME encoding...rfc 1521);
char *
base64_decode(char *to, char *from)
{
  char f[4];
  unsigned int i = 0, count = 0;

  count = strlen(from) / 4;

  /*
   * Base64 -> 6bits 111111 111111 000000 000000 ASCII -> 8bits 11111100
   * 11000000 00001111 
   */

  for (i = 0; i < count; i++)
  {
    strncpy(f, from + i * 4, 4);

    f[0] = found64(f[0]);
    f[1] = found64(f[1]);
    f[2] = found64(f[2]);
    f[3] = found64(f[3]);

    to[i * 3] = (f[0] << 2) | ((f[1] & 0x30) >> 4);
    to[i * 3 + 1] = ((f[1] & 0x0F) << 4) | ((f[2] & 0x3C) >> 2);
    to[i * 3 + 2] = ((f[2] & 0x03) << 6) | (f[3] & 0x3F);
  }
  to[(i-1)*3+3]=0;
  return to;
}

// return the char to its Base64 decimal value
int
found64(char c)
{
  int i;

  for (i = 0; i <= 64; i++)
    if (base64[i] == c)
      return i;
  return 0;
}



char *
tolow(char *s, int lenght)
{
  unsigned short int i, l;

  l = strlen(s) > lenght ? lenght : strlen(s);
  for (i = 0; i < l; i++)
  {
    if (s[i] >= 65 && s[i] <= 90)
      s[i] += 32;
  }
  return s;
}
