#include "include.h"

#define DATA(L)	((L)->data)
#define NEXT(L) ((L)->next)
#define FRONT(Q) ((Q)->front)
#define REAR(Q) ((Q)->rear)

byte
allocate_node(list * l, void *data)
{
  list new_list;

  new_list = (list) malloc(sizeof(node));

  if (new_list == NULL)
    return 0;

  *l = new_list;

  DATA(new_list) = data;
  NEXT(new_list) = NULL;
  return 1;
}


void
free_node(list * l)
{
  free(*l);
  *l = NULL;
}


byte
init_queue(queue * q)
{
  FRONT(q) = NULL;
  REAR(q) = NULL;
  return 1;
}

byte
empty_queue(queue * q)
{
  return (FRONT(q) == NULL) ? 1 : 0;
}

byte
qadd(queue * q, void *data)
{
  list newnode;

  if (!allocate_node(&newnode, data))
    return 0;

  if (!empty_queue(q))
  {
    NEXT(REAR(q)) = newnode;
    REAR(q) = newnode;
  } else
    FRONT(q) = REAR(q) = newnode;

  return 1;
}

byte
qremove(queue * q, void **p_data)
{
  list nodeinfront;

  if (empty_queue(q))
    return 0;

  nodeinfront = FRONT(q);

  *p_data = DATA(nodeinfront);

  if (REAR(q) == FRONT(q))
    REAR(q) = FRONT(q) = NULL;
  else
    FRONT(q) = NEXT(nodeinfront);

  free_node(&nodeinfront);
  return 1;
}
