/*
 * Copyright (C) 2003  
 * paranoy project - paranox.sf.net - paranoy@autistici.org
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

#include "include.h"

void
attach_win(struct email *mail)
{
  WINDOW *wattach;
  ushort i;

  wattach = subwin(wmain, 10, 40, LINES / 2 - 5, COLS / 2 - 20);
  wborder(wattach, 0, 0, 0, 0, 0, 0, 0, 0);
  for (i = 0; i < mail->nattach; i++)
    mvwprintw(wattach, 1 + i, 2, " - %d ", i);
  wrefresh(wattach);

  delwin(wattach);
}

void
folders()
{
  byte i, ffold = 0;


  clear_w(wmain, 0);
  logg("read folders() - nfolds = %d\n", nfolds);
  wattroff(wmain, A_REVERSE);
  for (i = 0; i < nfolds; i++)
    mvwprintw(wmain, 2 + i, 4, "%-20s (%d/%d)", folder[i]->name,
              folder[i]->nnew, folder[i]->nall);
  for (i = 0; i < naccount; i++)
  {
    // there's an imap account
    if (account[i]->proto > 3)
    {
      logg("read folders() - dentro l'account imap\n");
      if (!ffold)
      {
        ffold++;
        mvwprintw(wmain, 3 + nfolds, 2, "______- IMAP ACCOUNT -_______");
      }
      mvwprintw(wmain, 5 + nfolds + i, 4, "%s", account[i]->email);
    }
  }
  title("Read: %d folders", nfolds);
  ffold = i = 0;
  wrefresh(wmain);
  refresh();
  while (ffold != 100)
  {
    if (!net_optimize)
    {

      // cancello la selezione precedente
      wattroff(wmain, A_REVERSE);
      mvwprintw(wmain, 2 + i, 4, "%-20s (%d/%d)", folder[i]->name,
                folder[i]->nnew, folder[i]->nall);
      // seleziono la nuova roba
      wattron(wmain, A_REVERSE);
      mvwprintw(wmain, 2 + ffold, 4, "%-20s (%d/%d)", folder[ffold]->name,
                folder[ffold]->nnew, folder[ffold]->nall);
    } else
    {
      // cancello la selezione precedente
      mvwprintw(wmain, 2 + i, 3, " ");
      // seleziono quella nuova
      mvwprintw(wmain, 2 + ffold, 3, ">");
    }
    wrefresh(wmain);

    switch (getch())
    {
      case KEY_LEFT:
      case 'q':
      case 27:
        ffold = 100;
        break;
      case KEY_DOWN:
        if (ffold < nfolds - 1)
        {
          i = ffold;
          ffold++;
        }
        // imap account if any TODO
        else
        {


        }
        break;
      case KEY_UP:
        if (ffold > 0)
        {
          i = ffold;
          ffold--;
        }
        break;
      case KEY_RIGHT:
      case 10:
      case 32:
        if (folder[ffold]->nall != 0)
        {
          logg("read - selected folder n.%d\n", ffold);
          list_email(folder[ffold], 0);

          // reprint the folders list
          for (i = 0; i < nfolds; i++)
            mvwprintw(wmain, 2 + i, 4, "%-20s (%d/%d)", folder[i]->name,
                      folder[i]->nnew, folder[i]->nall);

          for (i = 0; i < naccount; i++)
          {
            // there's an imap account
            if (account[i]->proto > 3)
            {
              if (!ffold)
              {
                ffold++;
                mvwprintw(wmain, 3 + nfolds, 2,
                          "______- IMAP ACCOUNT -_______");
              }
              mvwprintw(wmain, 5 + nfolds + i, 4, "%s", account[i]->email);
            }
          }
          i = ffold;
          title("Read: %d folders", nfolds);
        } else
          info(1, "No emails in %s", folder[ffold]->name);
        break;
    }
  }
  clear_w(wmain, 0);
  wattroff(wmain, A_REVERSE);
}


void
list_email(struct folders *folder, int mode)
{
  // first 
  ushort real = 0, c;
  byte sel = 0, old = 0;
  struct list *selm = NULL, *oldm = NULL, *realm = NULL;
  char buff[BUFFER_REAL];

  selm = oldm = realm = folder->head;
  clear_w(wmain, 0);
  print_mail_list(selm, mode, real);
  wrefresh(wmain);
  title("Mail list -= %s =-: all: %d - new: %d", folder->name, folder->nall,
        folder->nnew);

  while (1)
  {
    if (!net_optimize)
    {
      oldm->mail->type & DEL ? wattrset(wmain,
                                        COLOR_PAIR(COLOR_DELETE)) : oldm->
        mail->type & NEW ? wattrset(wmain,
                                    COLOR_PAIR(COLOR_NEW)) : wattrset(wmain,
                                                                      COLOR_PAIR
                                                                      (COLOR_OLD));
      // normalize old selection
      mvwprintw(wmain, old, 2, " %-3d %s %.30s", old + real + 1,
                date_descr(oldm->mail, buff), oldm->mail->from);
      mvwprintw(wmain, old, 47 + oldm->mail->level * 2, "%.40s",
                oldm->mail->level ? "." : oldm->mail->subject);
      selm->mail->type & DEL ? wattrset(wmain,
                                        COLOR_PAIR(COLOR_DELETE)) : selm->
        mail->type & NEW ? wattrset(wmain,
                                    COLOR_PAIR(COLOR_NEW)) : wattrset(wmain,
                                                                      COLOR_PAIR
                                                                      (COLOR_OLD));
      wattron(wmain, A_REVERSE);
      mvwprintw(wmain, sel, 2, " %-3d %s %.30s", sel + real + 1,
                date_descr(selm->mail, buff), selm->mail->from);
      mvwprintw(wmain, sel, 47 + selm->mail->level * 2, "%.40s",
                selm->mail->level ? "." : selm->mail->subject);

      wattroff(wmain, A_REVERSE);
    } else
    {
      // normalize old selection
      mvwprintw(wmain, old, 1, " ");
      // select new label
      mvwprintw(wmain, sel, 1, ">");
    }
    wrefresh(wmain);
    switch (c = wgetch(wmain))
    {

        // sort for subject
      case 'S':
        sort_mails(folder, SSUBJECT);
        real = 0;
        sel = 0;
        old = 0;
        realm = selm = oldm = folder->head;
        clear_w(wmain, 0);
        print_mail_list(selm, mode, real);
        wrefresh(wmain);
        title("Mail list -= %s =-: all: %d - new: %d", folder->name,
              folder->nall, folder->nnew);
        break;
      case 'F':
        sort_mails(folder, SFROM);
        real = 0;
        sel = 0;
        old = 0;
        realm = selm = oldm = folder->head;
        clear_w(wmain, 0);
        print_mail_list(selm, mode, real);
        wrefresh(wmain);
        title("Mail list -= %s =-: all: %d - new: %d", folder->name,
              folder->nall, folder->nnew);
        break;
      case 'D':
        sort_mails(folder, SDATE);
        real = 0;
        sel = 0;
        old = 0;
        realm = selm = oldm = folder->head;
        clear_w(wmain, 0);
        print_mail_list(selm, mode, real);
        wrefresh(wmain);
        title("Mail list -= %s =-: all: %d - new: %d", folder->name,
              folder->nall, folder->nnew);
        break;
        // put in the trash
      case 't':
        {
          struct list *cur = folder->head;

          if (!cur)
            return;
          while (cur)
          {
            if (cur->mail->type & DEL)
            {
            retry:
              switch (move_mail(folder->name, "Trash", cur))
              {
                  // we never won't to be here 
                case -1:
                  info(2, " Folder not found\n");
                  break;
                  // the trash is not found
                case -2:
                  info(0,
                       " Folder trash not found, do you want to create [Y/n] ? ");
                  switch (wgetch(winfo))
                  {
                    case 'y':
                    case 'Y':
                    case '\n':
                      new_folder("trash");
                      goto retry;
                    default:
                      info(2, " Mail not moved!\n");
                  }
                  break;
              }
            }
            cur = cur->next;
          }
          print_mail_list(selm, mode, real);
        }
        break;
        // delete definitively FIXME
      case 'x':
        {
          struct list *temp, *cur = folder->head;

          if (!cur)
            return;
          while (cur)
          {
            temp = cur->next;
            if (cur->mail->type & DEL)
            {
              if (!delete_mail(folder, cur))
              {
                logg("Premendo x delete_mail ritorna NULL\n");
                clear_w(wmain, 0);
                return;
              }
            }
            cur = temp;
          }
          old = sel = 0;
          oldm = selm = realm = folder->head;
          print_mail_list(realm, mode, real);
        }
        break;
      case KEY_DC:
      case 'd':
        // if email is deleted yet, we don't need to do nothing
        if (selm->mail->type & DEL)
          break;
        selm->mail->type += DEL;
        if (selm->next != NULL)
        {
          oldm = selm;
          selm = selm->next;
          old = sel;
          sel++;
        }
        break;
      case 'u':
        if (selm->mail->type & DEL)
          selm->mail->type -= DEL;
        break;
      case KEY_LEFT:
      case 'q':
      case ESC:
        wattrset(wmain, A_NORMAL);
        clear_w(wmain, 0);
        return;

      case KEY_DOWN:


        if (selm->next != NULL)
        {
          oldm = selm;
          selm = selm->next;
          if (sel < LINES - 4 || !selm->next)
          {
            old = sel;
            sel++;
          } else
          {
            real++;
            realm = realm->next;
            print_mail_list(realm, mode, real);
          }
        }
        break;
      case KEY_UP:
        if (selm->prev != NULL)
        {
          oldm = selm;
          selm = selm->prev;
          if (sel > 1 || !selm->prev)
          {
            old = sel;
            sel--;
          } else
          {
            real--;
            realm = realm->prev;
            print_mail_list(realm, mode, real);
          }
        }
        break;
        // TOFIX
      case KEY_NPAGE:
        // control if we must change page (reprint the list)
        if (folder->nall - real > LINES - 2)
        {
          ushort i;

          real += LINES - 4;
          for (i = 0; i < LINES - 3; i++, realm = realm->next);
          if (sel + real < folder->nall)
            for (i = 0; i < LINES - 2; i++, selm = selm->next);
          else
          {
            sel = folder->nall - real;
            while (selm->next)
              selm = selm->next;
          }
          old = sel;
          oldm = selm;
          clear_w(wmain, 0);
          print_mail_list(realm, 0, real);
        }
        // we haven't to change page
        else
        {
          oldm = selm;
          old = sel;
          for (; selm->next; selm = selm->next, sel++);
        }
        break;
      case KEY_PPAGE:
        if (real != 0)
        {

        }
        // we haven't to change page
        else
        {
          old = sel;
          oldm = selm;
          sel = real;
          selm = folder->head;
        }
        break;
      case KEY_RIGHT:
      case ENTER:
      case SPACE:
        if (selm->mail->type & NEW)
          folder->nnew--;
        read_email(selm->mail);
        clear_w(wmain, 0);
        print_mail_list(realm, mode, real);
        title("Mail list -= %s =-: all: %d - new: %d", folder->name,
              folder->nall, folder->nnew);
        break;
      case KEY_F(1):
        break;
      default:
        info(2, "Unknow key %d", c);
        break;
    }
  }
  wrefresh(wdata);
}


// printa la lista delle email a partire dall'elemento head della lista
void
print_mail_list(struct list *head, int mode, int real)
{
  byte n = 0;
  char buff[BUFFER_REAL];
  struct email *tmpmail = head->mail;

  if (tmpmail == NULL)
    return;
  clear_w(wmain, 0);
  wattrset(wmain, A_NORMAL);
  while (n < LINES - 2)
  {
    tmpmail->type & DEL ? wattrset(wmain,
                                   COLOR_PAIR(COLOR_DELETE)) :
      tmpmail->type & NEW ? wattrset(wmain,
                                     COLOR_PAIR(COLOR_NEW)) :
      wattrset(wmain, COLOR_PAIR(COLOR_OLD));


    mvwprintw(wmain, n, 2, " %-3d %s %.30s", n + real + 1,
              date_descr(tmpmail, buff), tmpmail->from);
    mvwprintw(wmain, n, 47 + tmpmail->level * 2, "%.40s",
              tmpmail->level ? "." : tmpmail->subject);
    n++;
    head = head->next;
    if (!head)
      break;
    tmpmail = head->mail;
  }
}


void
read_email(struct email *mail)
{
  short lh, lb, real, i;
  byte show_head = 0;
  ushort a, init, end;
  char buffer[BUFFER_LEN];


  // sign as readed if new
  if (mail->type & NEW)
    mail->type -= NEW;

  init = end = real = 0;
  a = 0;
  lh = 0;
  lb = 0;
  clear_w(wmain, 0);
  wattrset(wmain, A_NORMAL);
  title(" Subject: %s", mail->subject); // ? mail->subject : "No subject");

  // load email from encrypted file
  load_mail(mail);
  lh = mail->head_lines;
  lb = mail->body_lines;

  clear_w(wmain, 0);

  wattrset(wmain, COLOR_PAIR(COLOR_NEW));
  mvwprintw(wmain, 0, 0, "Date: %s\n", date_descr(mail, buffer));
  mvwprintw(wmain, 1, 0, "From: %s\n", mail->from);
  mvwprintw(wmain, 2, 0, "Subject: %s\n", mail->subject);
  wattrset(wmain, A_NORMAL);

  // logg("prima del ciclo real = %d, lb = %d\n", real, lb);
  a = 4;
  if (show_head)
    for (; a - 4 + real < lh - end && a < LINES - 6; a++)
      print_line(wmain, a, mail->header[a + real - 4 + init]);
  else
    for (; a - 4 + real < lb - end && a < LINES - 6; a++)
      print_line(wmain, a, mail->body[a + real - 4 + init]);

  wrefresh(wmain);
  scrollok(wmain, TRUE);
  while (1)
  {
    // logg("dopo il for e prima del getch\n");
    switch (wgetch(wmain))
    {
        // reply to
      case 'r':
        {
          if (!smtpserver)
          {
            info(0, "No smtpserver...");
            break;
          }
          compose(mail, 1);
          title(" Subject: %s", mail->subject);
          wattrset(wmain, COLOR_PAIR(COLOR_NEW));
          mvwprintw(wmain, 0, 0, "Date: %s\n", date_descr(mail, buffer));
          mvwprintw(wmain, 1, 0, "From: %s\n", mail->from);
          mvwprintw(wmain, 2, 0, "Subject: %s\n", mail->subject);
          wattrset(wmain, A_NORMAL);
          a = 4;
          if (show_head)
            for (; a - 4 + real < lh - end && a < LINES - 6; a++)
              print_line(wmain, a, mail->header[a + real - 4 + init]);
          else
            for (; a - 4 + real < lb - end && a < LINES - 6; a++)
              print_line(wmain, a, mail->body[a + real - 4 + init]);

          wrefresh(wmain);
          break;
        }

      case 'H':
        clear_w(wmain, 0);
        wattrset(wmain, COLOR_PAIR(COLOR_NEW));
        mvwprintw(wmain, 0, 0, "Date: %s\n", date_descr(mail, buffer));
        mvwprintw(wmain, 1, 0, "From: %s\n", mail->from);
        mvwprintw(wmain, 2, 0, "Subject: %s\n", mail->subject);
        wattrset(wmain, A_NORMAL);

        show_head = show_head ? 0 : 1;
        a = 4;
        if (show_head)
          for (; a - 4 + real < lh - end && a < LINES - 6; a++)
            print_line(wmain, a, mail->header[a + real - 4 + init]);
        else
          for (; a - 4 + real < lb - end && a < LINES - 6; a++)
            print_line(wmain, a, mail->body[a + real - 4 + init]);

        wrefresh(wmain);
        break;
      case 'R':
        if (smtpserver)
          compose(mail, 3);
        break;
        // forward
      case 'f':
        if (smtpserver)
          compose(mail, 2);
        break;
      case KEY_LEFT:
      case ESC:
      case 'q':
        free_mail_body(mail);
        scrollok(wmain, FALSE);
        return;
        break;
      case 'a':
      case 'A':
        attach_win(mail);
        wrefresh(wmain);
        refresh();
        break;
      case KEY_DOWN:
        if (real < lb - LINES + 6)
        {
          wscrl(wmain, 1);
          print_line(wmain, LINES - 7, mail->body[LINES - 6 + real]);
          real++;
          wrefresh(wmain);
        }
        logg("dopo il key down real = %d\n", real);
        break;
      case KEY_UP:
        logg("sono al key_up.... real = %d\n", real);
        if (real > 0)
        {
          wscrl(wmain, -1);
          print_line(wmain, 4, mail->body[real - 1]);
          real--;
          wrefresh(wmain);
        }
        break;
      case KEY_NPAGE:
        // calcolo quante righe mancano alla fine della email
        i = lb - (real + LINES - 2);
        if (i > 10)
        {
          wscrl(wmain, 10);
          for (i = 0; i < 10; i++)
            print_line(wmain, LINES - 3 - i,
                       mail->body[LINES - 2 - i + real]);
          real += 10;
          wrefresh(wmain);
        } else if (i > 0)
        {
          wscrl(wmain, i);
          for (; i > 0; i--)
          {
            real++;
            print_line(wmain, LINES - i - 2, mail->body[LINES - i + real]);
          }
          wrefresh(wmain);
        }
        break;
      case KEY_PPAGE:
        break;
      default:
        info(1, "Unknown key\n");
    }
  }
}
